/*  doubly linked list and related functions */
#include <stdio.h>
#include <stdlib.h> 
#include <sys/file.h>
#include "dll.h"


/*Always keep the start point to the beginning of the linked list, and
  end point to the end of linked list */
extern DLL start,end;

/* Append the node to the tail of the list */
void Append(DLL node)
{
	if(start==NULL&&end==NULL)
	{
		start=node;
		end=node;
	}
	else	
	{
	end->rlink=node; // list is updated here  ->
	node->llink=end; //                       <-

	end=node;
	}
}

/* delete node by value */
void Delete(DLL node)
{
	if(node){
		if(node->data.RemoteHost)
			free(node->data.RemoteHost);
		if(node->data.ExternalIP)
			free(node->data.ExternalIP);
		if(node->data.Protocol)
			free(node->data.Protocol);
		if(node->data.InternalClient)
			free(node->data.InternalClient);
		if(node->data.PortMappingDescription)
			free(node->data.PortMappingDescription);
	}

	
	if(node==end&&node!=start)
	{
	end=node->llink;
	end->rlink=NULL;
	}
	else if(node==start&&node!=end)
	{
	start=node->rlink;
	node->llink=NULL;
	}
	else if(node==start&&node==end)
	{
	start=NULL;
	end=NULL;
	}
	else
	{
	node->llink->rlink=node->rlink;   // we break the links ->
	node->rlink->llink=node->llink;  //same here <-
	}
//	puts("free node");
	free(node); // free the node
}


/* search according the index we give , and return a node ptr */
DLL Search(int index)
{
	DLL ptr=NULL;
	int i;

	//search from start
	ptr = start;

	for(i=0;i<index;i++)
	{
		ptr=ptr->rlink;
		
	}
	return(ptr);
}


DLL AllocNode(void){

	DLL tmp;

	tmp=malloc(sizeof(struct dll));

	if(tmp==NULL)
	{
		perror("Insufficient memory");
	}

	memset(tmp,0,sizeof(struct dll));
	
	tmp->rlink=tmp->llink=NULL;
	return(tmp);
}


/* calculate the length of link length */
int LinkLength(void){
	int len=0;
	DLL ptr;
	/* if Linked List is not exist, length is zero */
	if(start==NULL)
		return len;
	/* else the length should be larger than 1 */
	ptr=start;
	len=1;
	
	while(ptr->rlink!=NULL)
	{	ptr=ptr->rlink;
		len++;
	}
	return len;
}

#if 1
void print_node(DLL node)
{

	printf("<NewExternalPort>%d\n<NewProtocol>%s\n<NewInternalPort>%d\n<NewInternalClient>%s\n<NewEnabled>%d\n<NewPortMappingDescription>%s\n",
			node->data.ExternalPort,
			node->data.Protocol,
			node->data.InternalPort,
			node->data.InternalClient,
			node->data.PortMappingEnabled,
			node->data.PortMappingDescription);

}
#endif

int print_link(void)
{
	DLL ptr;
	FILE *fp;

        fp=fopen("/tmp/upnptab","w+");	
	if(fp==NULL)
		return 1;
	/* else the length should be larger than 1 */
	for(ptr=start;ptr!=NULL;ptr=ptr->rlink){
#if 0
fprintf(fp,"<TR>");
if(ptr->data.PortMappingEnabled)
	fprintf(fp,"<TD  width=\"10%%\" align=\"center\"><b>YES</b></TD>\n");
else
	fprintf(fp,"<TD  width=\"10%%\" align=\"center\"><b>NO</b></TD>\n");
fprintf(fp,"<TD  width=\"15%%\" align=\"center\"><b>%s</b></TD>\n",ptr->data.Protocol);
fprintf(fp,"<TD  width=\"15%%\" align=\"center\"><b>%d</b></TD>\n",ptr->data.InternalPort);
fprintf(fp,"<TD  width=\"15%%\" align=\"center\"><b>%d</b></TD>\n",ptr->data.ExternalPort);
fprintf(fp,"<TD  width=\"25%%\" align=\"center\"><b>%s</b></TD>\n",ptr->data.InternalClient);
fprintf(fp,"</TR>");
#endif
	fprintf(fp,"%s\1%s\1%d\1%s\1%d\n",ptr->data.PortMappingDescription,ptr->data.Protocol,ptr->data.InternalPort,ptr->data.InternalClient,ptr->data.PortMappingEnabled);
	//print_node(ptr);
	fflush(fp);	
	}
        fclose(fp);
	return 1;
}
