#include <time.h>
#include "../nvram/nvram.h"

#define SYSTEM_UPTIME_FILE	"/proc/uptime"

int get_rt_now_datetime(char *buf)
{
	time_t t;
	struct tm *st;

	setenv("TZ", nvram_safe_get("time_zone"),1);
//	t=time(NULL)+atoi(value_parser("time_daylight"))*3600;
	t=time(NULL)+atoi("time_daylight")*3600;
	st=localtime(&t);

	sprintf(buf,"%d-%02d-%02d %02d:%02d:%02d"
			,st->tm_year+1900
			,st->tm_mon+1
			,st->tm_mday
			,st->tm_hour
			,st->tm_min
			,st->tm_sec);
	if(st)
		free(st);
	return 0;
}

inline long get_sys_uptime_return_seconds(void)
{
	FILE *fpTime;
	long lTmp = 0;
	char caTime[10] = "";

	fpTime=fopen(SYSTEM_UPTIME_FILE, "r");
	if(fpTime)
	{
		//fscanf(fpTime,"%[^.].%d", caTime, &iValue);
		fscanf(fpTime,"%[^.]", caTime);
		lTmp = atoi(caTime);	//*100 + iValue;
		fclose(fpTime);
	}
	DEBUG_PRINT("Now get time:[%s]: %ld\n", caTime, lTmp);

	return lTmp;
}

void prov_hook_wait(int iContinueCount)
{
	FILE *fp=NULL;
	char buf[128]="";
	int  iCount=0;
	
	do{
		fp=fopen("/proc/tiuhw","r");
		if(fp==NULL)
			return ;
		sleep(1);	
		fread(buf,128,1,fp);
		DEBUG_PRINT(buf);
		/* 2005.05.18 Ron hard code */
		if(strstr(buf,"0|0") && strstr(buf,"1|0"))
			iCount ++;
		else
			iCount = 0;
		fclose(fp);	
	}while(iCount< iContinueCount);
}

int use_backoff_retry_time(int iTimes)
{
	PROV_SYSTEM("%s Use Backoff Retry Time:%d >> %s", ECHO_CMD, (0x01<<iTimes), DEBUG_SAVE_DIR);
	return (0x01<<iTimes);
}

void get_modem_now_time(long *lpTime_Now)
{
	*lpTime_Now = get_sys_uptime_return_seconds();
	DEBUG_PRINT("\nNew Get the time:%ld\n", *lpTime_Now);
}

void get_last_update_time(long *lpTime_Last_Update)
{
	*lpTime_Last_Update = get_sys_uptime_return_seconds();
	DEBUG_PRINT("Last_update time:%ld\n", *lpTime_Last_Update);
}

void set_last_ntp_time_and_2_nvram(char *cpData)
{
	char caTime[MAX_CFG_FILE_SIZE] = "";

	get_rt_now_datetime(caTime);

	DEBUG_PRINT("\tTime get...\t%s:%s\n", cpData, caTime);
	nvram_set(cpData, caTime);
	sleep(1);
	nvram_commit();
	sleep(1);
}
