#include "prov_tiny.h"
#include "provision_share.h"
#include "rc4.c"

int initialize_struct_Prov_Information(struct sPROV_INFORMATION *spProv_Info)
{
	memset(spProv_Info, 0, sizeof (struct sPROV_INFORMATION));
//	return (initialize_get_env_param_info(spProv_Info));
	return (copy_NVRAM_default_data_2_struct(spProv_Info));
}

/*
int initialize_get_env_param_info(struct sPROV_INFORMATION *spProv_Info)
{
	char caTmpData[MAX_CFG_FILE_SIZE]="";

	DEBUG_PRINT("Open (1)/etc/provisioning or (2)/tmp/store_mac_file or default parameter...\n");
	// Only open (2)/tmp/store_[mac].cfg ..., don't open (1)/etc/provisioning...
	open_mtdblock5_file_to_get_data(caTmpData);

	if(read_data_to_specific_name(caTmpData, spProv_Info) != MSG_OK)
	{
		DEBUG_PRINT("Read failed, initialize the caTmpData...\n");
		memset(caTmpData, 0x00, MAX_CFG_FILE_SIZE);
		DEBUG_PRINT("Used nvram_safe_get to cat Route CFG in NVRAM...\n");
		if(copy_NVRAM_default_data_2_struct(spProv_Info) != MSG_OK)
			return ERROR_MSG_CHECK;
	}
	return MSG_OK;
}
*/

int copy_NVRAM_default_data_2_struct(struct sPROV_INFORMATION *spProv_Info)
{
//	char *cpTmp;

	while(1)
	{
		int iFlag = 1;

		DEBUG_PRINT("\nStart to get File Name from NVRAM...\n");
		// Configuration File ...
		strcpy(spProv_Info->caFile_Sys_Name, nvram_safe_get(NVRAM_CFG_FILE_NAME));
		if(strlen(spProv_Info->caFile_Sys_Name) == 0)
		{
			/* Assume all of the method's used server IP were the same.... */
			get_default_cfg_file_name(spProv_Info->caFile_Sys_Name);
			PROV_SYSTEM("%s File Name default:%s... >> %s", ECHO_CMD, spProv_Info->caFile_Sys_Name, DEBUG_SAVE_DIR);
		}
		PROV_SYSTEM("%s Get File Name Init.: %s... >> %s", ECHO_CMD, spProv_Info->caFile_Sys_Name, DEBUG_SAVE_DIR);
		sleep(1);
		// TFTP Server ...
		strcpy(spProv_Info->caServerIP, nvram_safe_get(NVRAM_TFTP_DOMAIN_STR));
		if(strlen(spProv_Info->caServerIP) == 0)
		{
			DEBUG_PRINT("\nGet Server IP Address from NVRAM: Failed\n");
			// Must clean the debugaaa(DEBUG_SAVE_DIR), avoid size would improve.
			PROV_SYSTEM("%s Get Server IP Address from NVRAM: Failed > %s", ECHO_CMD, DEBUG_SAVE_DIR);
			iFlag = 0;
			
			continue;
//			return ERROR_MSG_CHECK;
		}
		PROV_SYSTEM("%s TFTP Server: %s >> %s", ECHO_CMD, spProv_Info->caServerIP, DEBUG_SAVE_DIR);
		DEBUG_PRINT("\nGet Server IP Address from NVRAM: %s\n", spProv_Info->caServerIP);
		sleep(1);

		get_tftp_port_number_from_nvram(&spProv_Info->iTftpDefaultPortNum, &spProv_Info->iTftpPrimaryPortNum, &spProv_Info->iTftpSecondaryPortNum);
		PROV_SYSTEM("%s TFTP Port OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		sleep(1);
		strcpy(spProv_Info->caRC4_Key, nvram_safe_get(NVRAM_RC4_KEY_STR));
		if(strlen(spProv_Info->caRC4_Key) < 1)
		{
			get_default_rc4key_from_ticfgenv(spProv_Info->caRC4_Key);
			DEBUG_PRINT("Default RC4_KEY in ENV:\n\t%s\n", spProv_Info->caRC4_Key);
		}
		else
		{
			DEBUG_PRINT("\nRC4 Key get from NVRAM:\n\t%s\n", spProv_Info->caRC4_Key);
		}
		PROV_SYSTEM("%s RC4 Key OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		sleep(1);
		strcpy(spProv_Info->caFWFileName, nvram_safe_get(NVRAM_FW_UPDATE_FILE_NAME));
		if(!spProv_Info->caFWFileName)
		{
			PROV_SYSTEM("%s FW File Name Init. Failed... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		}
		else
		{
			PROV_SYSTEM("%s FW File Name Init. OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		}
		sleep(1);

		strcpy(spProv_Info->caProvCFGVer, nvram_safe_get(NVRAM_CFG_FILE_VERSION));
		PROV_SYSTEM("%s CFG File Version:%s, Init. OK... >> %s", ECHO_CMD, spProv_Info->caProvCFGVer, DEBUG_SAVE_DIR);
		sleep(1);
		spProv_Info->iPeriodicInterval = atoi(nvram_safe_get(NVRAM_RELOAD_PERIOD_STR));
		PROV_SYSTEM("%s Period Interval Init. OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		sleep(1);
		if(iFlag)
			break;
		sleep(1);
	}
	return MSG_OK;
}

char *update_cfg_file_name_into_simple(char *cpFileName)
{
	char *cpTmp;

	cpTmp = strrchr(cpFileName, '/');
	if(cpTmp == NULL)
		return cpFileName;
	cpTmp ++;

	return cpTmp;
}

int get_tftp_port_number_from_nvram(int *ipDefaultPortNum, int *ipPrimaryPortNum, int *ipSecondaryPortNum)
{
	int iVal = 0;
/* Start of get the TFTP port (default, primary, secondary) from NVRAM(Router CFG)... */
	// TFTP Port Default Number ...
	iVal = atoi(nvram_safe_get(NVRAM_TFTP_DEFAULT_PORT_NUM_STR));
	if(iVal != 0)
	{
		*ipDefaultPortNum = iVal;
	}
	if(*ipDefaultPortNum == 0)
	{
		*ipDefaultPortNum = DEFAULT_TFTP_PORT_NUMBER;
		DEBUG_PRINT("\nGet TFTP Default Port Number from NVRAM: Failed\n	\
				Set Default Port to 69\n");
	}
	DEBUG_PRINT("\nTftp Default PortNumber get from NVRAM: %d\n", *ipDefaultPortNum);
	PROV_SYSTEM("%s Tftp Default PortNumber: %d >> %s", ECHO_CMD, *ipDefaultPortNum, DEBUG_SAVE_DIR);

	// TFTP Port Primary Alternate Port Number ...
	iVal = atoi(nvram_safe_get(NVRAM_TFTP_PRIMARY_PORT_NUM_STR));
	if(iVal != 0)
	{
		*ipPrimaryPortNum = iVal;
	}
	if(*ipPrimaryPortNum == 0)
	{
		*ipPrimaryPortNum = DEFAULT_PRIMARY_TFTP_PORT_NUMBER;
	}
	DEBUG_PRINT("\nTftp Primary PortNumber get from NVRAM: %d\n", *ipPrimaryPortNum);
	PROV_SYSTEM("%s Tftp Primary PortNumber: %d >> %s", ECHO_CMD, *ipPrimaryPortNum, DEBUG_SAVE_DIR);

	// TFTP Port Secondary Alternate Port Number ...
	iVal = atoi(nvram_safe_get(NVRAM_TFTP_SECONDARY_PORT_NUM_STR));
	if(iVal != 0)
	{
		*ipSecondaryPortNum = iVal;
	}
	DEBUG_PRINT("\niTftp Secondary PortNumber get from NVRAM: %d\n", *ipSecondaryPortNum);
	PROV_SYSTEM("%s Tftp Secondary PortNumber: %d >> %s", ECHO_CMD, *ipSecondaryPortNum, DEBUG_SAVE_DIR);

/* End of get the TFTP port (default, primary, secondary) from NVRAM(Router CFG)... */
	return MSG_OK;
}
#if 0
int read_data_to_specific_name(char *cpData, struct sPROV_INFORMATION *spProv_Info)
{
	/* Commond area for some parameters.... Get the file name from MAC...*/
	get_provisioning_file_name(cpData, spProv_Info->caFile_Sys_Name);
	DEBUG_PRINT("\tGet File Name from open file data: %s\n", spProv_Info->caFile_Sys_Name);
	if(strlen(spProv_Info->caFile_Sys_Name) == 0)
	{
		DEBUG_PRINT("\tCouldn't Get File Name from open file data: %s\n", spProv_Info->caFile_Sys_Name);
		return ERROR_MSG_CHECK;
	}

	/* Ok to get the tftp seripa */
	get_tftp_server_ip_address(cpData, spProv_Info->caServerIP);
	DEBUG_PRINT("\tGet Server IP Address from open file data: %s\n", spProv_Info->caServerIP);
	if(strlen(spProv_Info->caServerIP) == 0)
	{
		DEBUG_PRINT("\tCouldn't Get Server IP Address from open file data: %s\n", spProv_Info->caServerIP);
		return ERROR_MSG_CHECK;
	}

	get_tftp_port_number(cpData, CHECK_TFTP_PRIMARY_PORT_NUM_STR, &spProv_Info->iTftpPrimaryPortNum);
	get_tftp_port_number(cpData, CHECK_TFTP_SECONDARY_PORT_NUM_STR, &spProv_Info->iTftpSecondaryPortNum);
	get_tftp_port_number(cpData, CHECK_TFTP_DEFAULT_PORT_NUM_STR, &spProv_Info->iTftpDefaultPortNum);

	get_rc4_key_from_buffer(cpData, spProv_Info->caRC4_Key);
	DEBUG_PRINT("\tRC4 Key get from open file data:\n%s\n", spProv_Info->caRC4_Key);
	if(strlen(spProv_Info->caRC4_Key) == 0)
	{
		DEBUG_PRINT("\tCouldn't RC4 Key get from open file data:\n%s\n", spProv_Info->caRC4_Key);
		return ERROR_MSG_CHECK;
	}

	get_tftp_update_fw_filename(cpData, spProv_Info->caFWFileName);
	DEBUG_PRINT("\Get Update FW File Name: %s\n", spProv_Info->caFWFileName);

	get_reload_period_interval_time(cpData, &spProv_Info->iPeriodicInterval);
	DEBUG_PRINT("\tiTftp iPeriodicInterval get from open file data: %d\n", spProv_Info->iPeriodicInterval);
	/* if non setting this value, don't check this value... */
//	if(spProv_Info->iPeriodicInterval == 0)
//	{
//		DEBUG_PRINT("\tCouldn't iTftp iPeriodicInterval get from open file data: %d\n", spProv_Info->iPeriodicInterval);
//		return ERROR_MSG_CHECK;
//	}
	/* In initialize, the cState must be update configure file:(cfg)
		Always get cfg file first, then to check update new configure or get FW... */
	spProv_Info->cState = STATE_UPDATE_CFG;

	return MSG_OK;
}
#endif
void open_mtdblock5_file_to_get_data(char *cpData)
{
	FILE *fpInit;
//	int iInitDataLen = 0;

	/* Open MTD5: /dev/mtdblock/5 */
	if((fpInit = fopen(SAVE_VOIP_CFG_TO_FLASH, "r")) == NULL)
	{
		/* Set to default... */
		memset(cpData, 0x00, MAX_CFG_FILE_SIZE);
		DEBUG_PRINT("No file to Open, select default file...\n");
	}
	else
	{
		DEBUG_PRINT("Success Store file from /dev/mtdblock/5...\n");
//		iInitDataLen = fread(cpData, 1, MAX_CFG_FILE_SIZE, fpInit);
		fread(cpData, 1, MAX_CFG_FILE_SIZE, fpInit);
		fclose(fpInit);
	}
}

int get_spec_data_from_file(char *cpFileData, char *cpKeyWord, char *cpRetData)
{
	int  iKeyWordLen=strlen(cpKeyWord), iPosition=10000, iTmp = 0;

	iPosition = get_the_position_in_string(cpFileData, cpKeyWord);
	DEBUG_PRINT("\nCheck get tftp %s length: %d\n", cpKeyWord, iPosition);
#ifdef PDEBUG_RD
	DEBUG_PRINT("\n\n\n\n\n\n\n\nBuffer Data2:\n%s\n", cpFileData);
#endif
	iPosition += iKeyWordLen;
	DEBUG_PRINT("%d, File length(%d) with %s(%d)...\n", iPosition, strlen(cpFileData), cpKeyWord, iKeyWordLen);
	if((iPosition > strlen(cpFileData)) || (iPosition < (iKeyWordLen-1)))
	{
		/* Couldn't find the (Spec. Data) in Get File Data... */
		ERROR_PRINT("Couldn't find the %s in Get File Data...\n", cpKeyWord);
		PROV_SYSTEM("%s Couldn\\'t find the %s in Get File Data...>> %s", ECHO_CMD, cpKeyWord, DEBUG_SAVE_DIR);
		return ERROR_MSG_CHECK;
	}
	while((cpFileData[iPosition] != '\n') && (cpFileData[iPosition] != '\r')&& (cpFileData[iPosition] != '\0'))
	{
		if((cpFileData[iPosition] == '#') && (cpFileData[iPosition + 1] == '#'))
		{
			/* End of check "##..." ... */
			break;
		}
		cpRetData[iTmp] = cpFileData[iPosition];
		iTmp ++;
		iPosition ++;
	}
	cpRetData[iTmp] = '\0';
#ifdef PDEBUG_RD
	DEBUG_PRINT("Get %s Data from get file: %s\n", cpKeyWord, cpRetData);
#endif
	return MSG_OK;	/* MSG_OK = 0 */
}

int get_rand_sec()
{
	return (rand()%10);
}

int wan_ready(void)
{
	// WAN uptime check, ...
	if(access("/tmp/wan_uptime",F_OK)!=0)
	{
		return 0;
	}
	return 1;
}

int mxp_stop_ready(void)
{
	if(access("/tmp/mxp_stop", F_OK) != 0)
	{
		return 0;
	}
	return 1;
}
void error_msg_process(int iEid)
{
	ERROR_PRINT("Error Message: %d\n", iEid);
}

int get_prov_interval_cfg(void)
{
	char *provItvStr = "";//=get_reloadperiod_nmm();
	unsigned short provItvInt16;

	provItvInt16=atoi(provItvStr);

	if(provItvInt16==0)
		provItvInt16=0;	//atoi(NMM_DEF_TFTP_INTERVAL_STR);
	return provItvInt16;
}

int get_file_provision_tftp(char *cpFileName, char *cpServerIPA, int iTftpPortNum)
{
	char caCmdBuf[MAX_CMD_USE_LENGTH] = "", caTmpName[FILENAME_MAX_LEN] = "";

	DEBUG_PRINT("sprintf: %s\n", cpFileName);
	DEBUG_PRINT("\tPort Number: %d\n", iTftpPortNum);
	DEBUG_PRINT("\t\tIn get_file_use_tftp Server IP Address: %s\n", cpServerIPA);
	sprintf(caCmdBuf, "/usr/bin/tftp -g -r %s%s -l %s%s %s %d\n",
			DIR_REMOTE_CFG, cpFileName, DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpFileName), cpServerIPA, iTftpPortNum);

	DEBUG_PRINT("\t\t\tCmd line: %s\n", caCmdBuf);
	system(caCmdBuf);
	sleep(1);
	PROV_SYSTEM("%s Get file provision tftp cmd: \"%s\" >> %s", ECHO_CMD, caCmdBuf, DEBUG_SAVE_DIR);

	sprintf(caTmpName, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpFileName));
	if(check_file_size_non_zero(caTmpName) == MSG_OK)
	{
		return MSG_OK;
	}
	PROV_SYSTEM("%s get_file_provision_tftp: failed >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	return ERROR_MSG_UPDATE_TFTP;
}

int check_file_size_non_zero(char *cpTmpName)
{
	FILE *fpTmp;
	int iFileLeng = 0;

	fpTmp = fopen(cpTmpName, "r");
	if(fpTmp == NULL)
	{
		PROV_SYSTEM("%s check file size non-zero: could not open file:%s...>> %s", ECHO_CMD, cpTmpName, DEBUG_SAVE_DIR);
		return UNSUCCESS_OPEN_or_GET_FILE;
	}
	if((iFileLeng = my_file_length_with_fp(fpTmp)) == 0)
	{
		fclose(fpTmp);
		PROV_SYSTEM("%s could not open file:%s, length:%d...>> %s", ECHO_CMD, cpTmpName, iFileLeng, DEBUG_SAVE_DIR);
		//DEBUG_PRINT("Check file size was zero...\n");atoi(nvram_safe_get(NVRAM_TFTP_DEFAULT_PORT_NUM_STR));
		return UNSUCCESS_OPEN_or_GET_FILE;
	}
	fclose(fpTmp);
	DEBUG_PRINT("%s file size:%d\n", cpTmpName, iFileLeng);

	return MSG_OK;
}

void get_rc4_key_from_buffer(char *cpFileData, unsigned char *cpRC4_Key)
{
	char caRetData[KEY_MAX_LEN+1] = "";

	memset(cpRC4_Key, 0, KEY_MAX_LEN);

	if(get_spec_data_from_file(cpFileData, CHECK_RC4_KEY_VALUE_STR, caRetData) == MSG_OK)	/* MSG_OK = 0 */
	{
		strcpy(cpRC4_Key, caRetData);		
		cpRC4_Key[KEY_MAX_LEN] = '\0';
		DEBUG_PRINT("Get RC4 Key from file:%s\n", cpRC4_Key);
	}
#if 0
		if(strlen(cpRC4_Key) == 0)
		{
			/* Get the Default RC4_KEY in /proc/ticfg/env.... */
			char caRC4DefaultKey[64+1] = "";

			get_default_rc4key_from_ticfgenv(caRC4DefaultKey);
			strcpy(cpRC4_Key, caRC4DefaultKey);
			DEBUG_PRINT("DEFAULT RC4 Key:%s\n", cpRC4_Key);
		}
	}
	else
	{
#endif
}

void get_default_rc4key_from_ticfgenv(char *cpRC4DefaultKey)
{
	FILE *fpRc4;
	char caBuf[MAX_CFG_FILE_SIZE] = "";
	char *cpRc4;

	if((fpRc4 = fopen(GV_ENV_PATH, "r")) == NULL)
	{
		DEBUG_PRINT("Open the file to read RC4 Default Key:%s\n", GV_ENV_PATH);
		return;
	}
	fread(caBuf, MAX_CFG_FILE_SIZE, 1, fpRc4);
	fclose(fpRc4);
	DEBUG_PRINT("Open file to read the RC4 Default Key:\n\t\t\t%s\n", caBuf);
	if((cpRc4 = strstr(caBuf, ENV_DEFAULT_RC4_KEY)))
	{
		sscanf(cpRc4, "%*s %s", cpRC4DefaultKey);
	}
	DEBUG_PRINT("Get cpRC4DefaultKey:%s\n", cpRC4DefaultKey);
}

void prov_led_blink(char *act)
{
	FILE *fp;
	fp=fopen("/proc/led","w");
	if(fp==NULL)
		return ;
	fprintf(fp,"%s\n",act);
	fclose(fp);
}

void get_tftp_server_ip_address(char *cpFileData, char *cpSerIPA)
{
	char caRetData[DOMAIN_MAX_LEN] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_TFTP_DOMAIN_STR, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(strlen(cpSerIPA) == 0)
		{
			get_default_tftp_server_ip_from_ticfgenv(cpSerIPA);
			/* Assume all of the method's used server IP were the same.... */
			DEBUG_PRINT("DEFAULT TFTP SERVER:%s\n", cpSerIPA);
		}
	}
	else
	{
		strcpy(cpSerIPA, caRetData);		
		DEBUG_PRINT("Get TFTP SERVER:%s\n", cpSerIPA);
	}
}

void get_tftp_cfg_file_Version(char *cpFileData, char *cpProvCFGVer)
{
	char caRetData[VERSION_LENGTH] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_CFG_FILE_VERSION, caRetData) == MSG_OK)	/* MSG_OK = 0 */
	{
		strcpy(cpProvCFGVer, caRetData);		
		DEBUG_PRINT("Get TFTP Cfg File Version:%s\n", cpProvCFGVer);
		PROV_SYSTEM("%s Get TFTP Cfg File Version:%s >> %s", ECHO_CMD, cpProvCFGVer, DEBUG_SAVE_DIR);
	}
	else
	{
		DEBUG_PRINT("Couln't find the prov cfg file version in CFG file...\n");
		PROV_SYSTEM("%s Could not find the prov cfg file version in CFG file...>> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	}
}

void get_default_tftp_server_ip_from_ticfgenv(char *cpSerIPA)
{
	FILE *fpTsip;
	char caBuf[MAX_CFG_FILE_SIZE] = "";
	char *cpTsip;

	if((fpTsip = fopen(GV_ENV_PATH, "r")) == NULL)
	{
		DEBUG_PRINT("Open the file to read RC4 + Key:%s\n", GV_ENV_PATH);
		return;
	}
	fread(caBuf, MAX_CFG_FILE_SIZE, 1, fpTsip);
	fclose(fpTsip);
#ifdef PDEBUG_RD
	DEBUG_PRINT("Open file to read the TFTP default Server IP:\n\t\t\t%s\n", caBuf);
#endif
	if((cpTsip = strstr(caBuf, ENV_DEFAULT_TFTP_SERVER_IP)))
	{
		sscanf(cpTsip, "%*s %s", cpSerIPA);
	}
	else
		strcpy(cpSerIPA, TFTP_PROVISIONING_SERVER_IP_ADDR);
		
	DEBUG_PRINT("Get cpSerIPA:%s\n", cpSerIPA);
}

void get_tftp_update_fw_filename(char *cpFileData, char *cpFWFileName)
{
	char caRetData[FILENAME_MAX_LEN] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_FW_UPDATE_FILE_NAME, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(cpFWFileName[0] != '\0')
		{
			if(strlen(cpFWFileName) == 0)
			{
				/* Assume all of the method's used FileName were the same.... */
				strcpy(cpFWFileName, DEFAULT_FW_NAME);
				DEBUG_PRINT("DEFAULT FW File Name:%s\n", cpFWFileName);
			}
		}
	}
	else
	{
		strcpy(cpFWFileName, caRetData);		
		DEBUG_PRINT("Get Setting File of FW File Name:%s\n", cpFWFileName);
	}
}

int check_text_mac(struct sPROV_INFORMATION *spProv_Info)
{
	int iCount = 0;
	char caRetCFGMacData[12] = "", caModemMac[6] = "";

	DEBUG_PRINT("Check cfg decrypted MAC...\n\t\tstart...\n\n");

	if(get_spec_data_from_file(spProv_Info->cpBuffer, CHECK_CFG_FILE_MAC, caRetCFGMacData) != MSG_OK)
	{
		DEBUG_PRINT("This cfg file without MAC(%s) setting was not my cfg file...\n", caRetCFGMacData);
		PROV_SYSTEM("%s This cfg file without MAC\\(%s\\) setting was not my cfg file... >> %s", ECHO_CMD, caRetCFGMacData, DEBUG_SAVE_DIR);
		return NOT_MY_CFG_FILE;
	}

	getMac(caModemMac);

	//DEBUG_PRINT("Get mac from /proc/ticfg/env:%s\n", caModemMac);
	DEBUG_PRINT("Get mac from /proc/ticfg/env:\n");
	
	for(iCount = 0; iCount < 6; iCount ++)
	{
		DEBUG_PRINT("%hhx ", caModemMac[iCount]);
	}
	
	if(compare_two_kind_mac(caRetCFGMacData, caModemMac) != MSG_OK)	// MSG_OK = 0
	{
		DEBUG_PRINT("This cfg file was not suit for me...\nMac not same...\n");
		return NOT_MY_CFG_FILE;
	}

	DEBUG_PRINT("This cfg file was my cfg file, do next step...\n");

	return MSG_OK;
}

//cpModemMac:12, cpModemMac:6
int compare_two_kind_mac(char *cpCfgMac, char *cpModemMac)
{
	char caMac[12] = "";

	DEBUG_PRINT("MAC check start:...\n");
	DEBUG_PRINT("\tMAC get from CFG file:%s\n\tMAC get from Modem:%s\n", cpCfgMac, cpModemMac);

	sprintf(caMac, "%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx", cpModemMac[0], cpModemMac[1], cpModemMac[2], cpModemMac[3], cpModemMac[4], cpModemMac[5]);

	DEBUG_PRINT("\t\tGet Mac form Modem(6->12):%s\n", caMac);
	return (strcmp(caMac, cpCfgMac));
}

static void getMac(char *mac)
{
	FILE *fpMac;
	char caBuf[MAX_CFG_FILE_SIZE] = "";
	char *cpMac;

//	sprintf(caBuf, "cat %s > %s", GV_ENV_PATH, TMP_TICFG_ENV);
//	system(caBuf);
//	memset(caBuf, 0x00, MAX_CFG_FILE_SIZE);
//	fpMac = fopen(TMP_TICFG_ENV, "r");
//	if(fpMac == NULL)
//	{
//		DEBUG_PRINT("Try to system:\n\t%s\nTMP_TICFG_ENV:%s\n", caBuf, TMP_TICFG_ENV);
		if((fpMac = fopen(GV_ENV_PATH, "r")) == NULL)
		{
			DEBUG_PRINT("Open the file to read Mac:%s\n", GV_ENV_PATH);
			return;
		}
//	}
	fread(caBuf, MAX_CFG_FILE_SIZE, 1, fpMac);
	fclose(fpMac);
//#ifdef PDEBUG_RD
	DEBUG_PRINT("Open file to read the mac:\n%s\n", caBuf);
//#endif
	if((cpMac = strstr(caBuf,"maca")))
	{
		sscanf(cpMac, "%*s %hhx:%hhx:%hhx:%hhx:%hhx:%hhx", &mac[0], &mac[1], &mac[2], &mac[3], &mac[4], &mac[5]);
	}
	DEBUG_PRINT("Get Mac:%s\n", mac);
}

void get_provisioning_file_name(char *cpFileData, char *cpFileName)
{
	char caRetData[FILENAME_MAX_LEN] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_SET_CFG_FILE_NAME, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(strlen(cpFileName) == 0)
		{
			/* Assume all of the method's used server IP were the same.... */
			get_default_cfg_file_name(cpFileName);
			DEBUG_PRINT("CHECK_SET_CFG_FILE_NAME:%s\n", cpFileName);
		}
		DEBUG_PRINT("CHECK_SET_CFG_FILE_NAME_with_length more over 1:%s\n", cpFileName);
	}
	else
	{
		strcpy(cpFileName, caRetData);		
		DEBUG_PRINT("File get FILE_NAME:%s\n", cpFileName);
	}
}

void get_default_cfg_file_name(char *cpFileName)
{
#ifdef PDEBUG_RD
	int iTmp;
#endif
	char caMac[6];
	
	getMac(caMac);

	sprintf(cpFileName, "ng%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx.cfg", caMac[0], caMac[1], caMac[2], caMac[3], caMac[4], caMac[5]);
//	sprintf(cpMAC_Data, "%02hhX%02hhX%02hhX%02hhX%02hhX%02hhX", caMac[0], caMac[1], caMac[2], caMac[3], caMac[4], caMac[5]);
#ifdef PDEBUG_RD
	DEBUG_PRINT("\ncpFile Name:%s\n", cpFileName);
	for(iTmp = 0; iTmp < 12; iTmp ++)
	{
		DEBUG_PRINT("%02hhx", cpFileName[iTmp]);
	}
	DEBUG_PRINT("\n");
#endif
}

int get_reload_period_interval_time(char *cpFileData, int *ipPeriodicInterval)
{
	char caRetData[32] = "";

	if(get_spec_data_from_file(cpFileData, CHECK_RELOAD_PERIOD_STR, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(*ipPeriodicInterval < 1)
		{
			/* Get the Periodic time from Programing.... */
			*ipPeriodicInterval = DEFAULT_RELOAD_PERIOD_TIME;
			DEBUG_PRINT("Using DEFAULT_RELOAD_PERIOD_TIME:%d\n", *ipPeriodicInterval);
		}
	}
	else
	{
		*ipPeriodicInterval = atoi(caRetData);
		DEBUG_PRINT("File get Reload Periodic Interval Time:%d\n", *ipPeriodicInterval);
	}
	return MSG_OK;
}

int get_tftp_port_number(char *cpFileData, char *cpIdParaName, int *ipTftpPortNum)
{
	char caRetData[32] = "";

	if(get_spec_data_from_file(cpFileData, cpIdParaName, caRetData) != MSG_OK)	/* MSG_OK = 0 */
	{
		if(*ipTftpPortNum < 1)
		{
			/* Assume all of the method's used server IP were the same.... */
			*ipTftpPortNum = 0;	//DEFAULT_TFTP_PORT_NUMBER;
			DEBUG_PRINT("Using %s:%d\n", cpIdParaName, *ipTftpPortNum);
			return ERROR_MSG_CHECK;
		}
	}
	else
	{
		*ipTftpPortNum = atoi(caRetData);
		DEBUG_PRINT("File get Port Number:%d\n", *ipTftpPortNum);
		return MSG_OK;
	}
	return MSG_OK;
}

int check_cfg_or_fw_update(unsigned char *ucpCheckData)
{
	if(ucpCheckData[0] == '1')
		return FW_UPDATE_FLAG;
	else
		return CFG_UPDATE_FLAG;
}

int decrypt_file(unsigned char * buff, unsigned int bufflen, int enc_type, unsigned char * keybuff,  unsigned int key_len)
{
	if (ENC_NULL == enc_type)
	{
		DEBUG_PRINT("\n no enc, do nothing\n");
		return MSG_OK;	/* MSG_OK = 0 */
	}
	if (ENC_RC4 == enc_type)
	{
#ifdef DEBUG_PRINT_DATA_BY_HEX
		int iTmp;
#endif
		//DEBUG_PRINT("What's ENC, do RC4 decrypt...Before\n");
		rc4_decrypt(buff, bufflen, keybuff, key_len);
		//DEBUG_PRINT("What's ENC, do RC4 decrypt...Finish\n");
		DEBUG_PRINT("ENC RC4: decrypt file buff length: %d\n", bufflen);
#ifdef DEBUG_PRINT_DATA_BY_HEX
		for(iTmp = 0; iTmp < bufflen; iTmp ++)
		{
			DEBUG_PRINT("0x%02x ", buff[iTmp]);
			if((iTmp+1)%10  == 0)
				DEBUG_PRINT("\n");
		}
		DEBUG_PRINT("\n");
#endif
		return MSG_OK;	/* MSG_OK = 0 */
	}
	return ERROR_RC4_DECRYPT_PARA;
}

void get_ucaKey_from_setting_or_default(unsigned char *ucpKeys, char *cpDefaultKey)
{
	char keybuff[KEY_MAX_LEN+1];    
	int enc_type;
	char outkeybuff[KEY_MAX_LEN/2];
	unsigned int outkeylen=0;
#ifdef DEBUG_PRINT_DATA_BY_HEX
	int iCount;
#endif

	// Only support the key length: 64byte....
	/*Descript the cfg file.*/
	strncpy(keybuff, get_keybuff(CFG_FILE, cpDefaultKey), KEY_MAX_LEN+1);
	keybuff[KEY_MAX_LEN] =0;

	DEBUG_PRINT("The return of RC4 Key:\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iCount = 0; iCount < KEY_MAX_LEN; iCount ++)
	{
		DEBUG_PRINT("0x%02x ", keybuff[iCount]);
		if(((iCount+1) % 10) == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif

	outkeylen = KEY_MAX_LEN/2;	// outkeylen = 32
	memset(outkeybuff, 0, outkeylen);	// outkeybuff set to Zero, initialize...
	AsciiToHex(keybuff, outkeybuff);	//+outkeylen-(strlen(keybuff))/2);	// combine 2 keybuffs to one and copy into outkeybuff.
	//DEBUG_PRINT("\n in convert key :%s\n", outkeybuff);	//+outkeylen-(strlen(keybuff))/2);
	memcpy(ucpKeys, outkeybuff, outkeylen);
	//memcpy(ucpKeys, keybuff, KEY_MAX_LEN/2);

	DEBUG_PRINT("The return of ucpKeys:\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iCount = 0; iCount < KEY_MAX_LEN/2; iCount ++)
	{
		DEBUG_PRINT("0x%02x ", outkeybuff[iCount]);
		if(((iCount+1) % 10) == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif

	enc_type = get_enctype(CFG_FILE);

	DEBUG_PRINT("\n\tOriginal convert key keybuff:%s.\n\t\toutkeylen:%d.\n\n", 
					keybuff, outkeylen);
}

int get_enctype(int file_type)
{
//#ifdef NMM_CONFIG
	if(file_type==CFG_FILE)
		return ENC_RC4/*get_pv_encrypt_type_cfg()*/;
	else if(file_type==FW_FILE)
		return ENC_NULL/*get_pv_encrypt_type_fw()*/;
	else
	{
		DEBUG_PRINT("\n[prov_mid.c ::get enc type error! file type is %d", file_type);
	}
	return 0;
}

char *get_keybuff(int file_type, char *cpDefaultKey)
{
	char *cpKey;
#if 1
	FILE *fpKeyFile;
	int iKeyLength = 0;

	if(cpDefaultKey)
	{
		return cpDefaultKey;
	}
	else
	{
		cpKey = (char *)malloc(KEY_MAX_LEN*sizeof(char));
		if(!cpKey)
		{
			memcpy(cpDefaultKey, DEFAULT_TEST_RC4_KEY, KEY_MAX_LEN);
			return cpDefaultKey;
		}

		fpKeyFile = fopen(STORE_RC4_KEY_FILE_NAME, "r");
		if(fpKeyFile == NULL)
		{
			memcpy(cpKey, DEFAULT_TEST_RC4_KEY, KEY_MAX_LEN);
	
			DEBUG_PRINT("The default of RC4 Key:\n");
	#ifdef DEBUG_PRINT_DATA_BY_HEX
			for(iCount = 0; iCount < KEY_MAX_LEN; iCount ++)
			{
				DEBUG_PRINT("0x%02hhx ", cpKey[iCount]);
				if(((iCount+1) % 10) == 0)
					DEBUG_PRINT("\n");
			}
			DEBUG_PRINT("\n");
	#endif
		}
		else
		{
			iKeyLength = fread(cpKey, 1, KEY_MAX_LEN+1, fpKeyFile);
	
			DEBUG_PRINT("The file of RC4 Key:\n");
		#ifdef DEBUG_PRINT_DATA_BY_HEX
			for(iCount = 0; iCount < iKeyLength; iCount ++)
			{
				DEBUG_PRINT("0x%02hhx ", cpKey[iCount]);
				if(((iCount+1) % 10) == 0)
					DEBUG_PRINT("\n");
			}
			DEBUG_PRINT("\n");
		#endif
			fclose(fpKeyFile);
		}

		strcpy(cpDefaultKey, cpKey);

		if(cpKey)
			free(cpKey);

		return cpDefaultKey;
	}
#else
	//#ifdef NMM_CONFIG
	if(file_type==CFG_FILE)
	{
		// get_rc4key_nmm() in nmm/nmmcfg.c
		pKey=get_rc4key_nmm();/*get_pv_encrypt_key_cfg();*/
	}
	else if(file_type==FW_FILE)
	{
		// get_pv_encrypt_key_fw() in nmm/nmmcfg.c
		pKey=get_pv_encrypt_key_fw();
	}
	else
	{
		DEBUG_PRINT("\n[prov_mid.c %d]::get enc key error! file type is %d",__LINE__,file_type);
		return "0000000000000000000000000000000000000000000000000000000000000000";
	}
	if(strcmp(pKey,"")==0)
	{
		// sys_getenv() in pform/psp/source/drv/envffs/env.c
		pKey=sys_getenv("RC4_KEY");
	}
	if(pKey==NULL || strcmp(pKey,"")==0)
	{        
		return "0000000000000000000000000000000000000000000000000000000000000000";
	}
	return pKey;
//#else
//	#errorcaProvCFGVer
//#endif
#endif
}

/* Parameters:
 *	Send two unsigned char array (or pointer), would convert first to second array(or point).
 *      abuf    : pointer to a ASCII String, use null terminater
 *      hbuf    : pointer to a Hex String
 *      convert ASCII String to Hex string
 */
#if 1
#define BYTE unsigned char
int AsciiToHex(char *abuf, BYTE *hbuf)
{
	int		ap, hp, nLen;
	BYTE	val;
	
    if( abuf==NULL ) 
	{
		hbuf[0] = '\0';
		return -1;
    }
	
	
	nLen = strlen(abuf);
	if( nLen<64 )
	{
		char temp[64];
		
		memcpy(temp,abuf,64);
		memset(abuf,'0',64);
		memcpy(abuf + 64 - nLen,temp,nLen);
	}

	for(ap=0,hp=0,val=0; (abuf[ap]); ap++) 
	{
		if ((abuf[ap] < '0') || (abuf[ap] > 'f') ||
			((abuf[ap] > '9') && (abuf[ap] < 'A')) ||
			((abuf[ap] > 'F') && (abuf[ap] < 'a'))
            )
		{
			break;
		}
		
		if (abuf[ap] <= '9')
			val = (char) (val * 16 + (abuf[ap] - '0'));
		else if (abuf[ap] <= 'F')
			val = (char) (val * 16 + (abuf[ap] - '7'));
		else val = (char) (val * 16 + (abuf[ap] - 'W'));
		
		if (ap % 2)
		{
			hbuf[hp] = val;
			hp++;
			val = 0;
		}
    }
    if (ap % 2)
		hbuf[hp] = val;
	
    return 2*hp;
}

#else

short AsciiToHex(unsigned char *abuf, unsigned char *hbuf)	//BYTE *abuf, BYTE *hbuf)
{
	short ap,hp;
	char val;
                                                                                               
	if (abuf==NULL) {
		hbuf[0] = '\0';
	}
                                                                                               
	for(ap=0,hp=0,val=0; (abuf[ap]); ap++)
	{
		if ((abuf[ap] < '0') || (abuf[ap] > 'f') ||	((abuf[ap] > '9') && (abuf[ap] < 'A')) ||
											((abuf[ap] > 'F') && (abuf[ap] < 'a')))
			return(ERROR);
		if (abuf[ap] <= '9')
			val = (char) (val * 16 + (abuf[ap] - '0'));
		else if (abuf[ap] <= 'F')
			val = (char) (val * 16 + (abuf[ap] - '7'));
		else
			val = (char) (val * 16 + (abuf[ap] - 'W'));
		if (ap % 2)
		{
			hbuf[hp] = val;
			hp++;
			val = 0;
		}
	}
	if (ap % 2) 
	{
		hbuf[hp] = val;
		hp++;
	}
	return(hp);
}
#endif

int my_read_file_length(char *filename)
{
	FILE *fp;
	int len=0;
	if((fp=fopen(filename,"rb"))==NULL){
		fprintf(stderr,"Error opening %s for output\n",filename);
		exit(-1);
	}
	fseek(fp,0,SEEK_END);
	len=ftell(fp);
/*
	if(len > size){
		fclose(fp);
		fprintf(stderr,"Sorry, %s must less than %d\n", filename,size);
		exit(-1);
	}
	fseek(fp, 0L, SEEK_SET);
	len=fread(buf,1,size,fp);
*/
	fclose(fp);

	DEBUG_PRINT("%s read %d bytes.\n", filename, len);

	return len;
}

int my_file_length_with_fp(FILE *fp)
{
	int len = 0;

	fseek(fp,0,SEEK_END);
	len=ftell(fp);
	fseek(fp, 0L, SEEK_SET);

	return len;
}

void save_struct_data_2_tmp_file(struct sPROV_INFORMATION *spProv_Info)
{
	FILE *fpSaveFile;
	char caFileName[FILENAME_MAX_LEN] = "";

	sprintf(caFileName, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(spProv_Info->caFile_Sys_Name));
	DEBUG_PRINT("update_cfg_file_name_into_simple:::save struct data to file:%s\n", caFileName);

	fpSaveFile = fopen(caFileName, "w");

	fprintf(fpSaveFile, "%s", spProv_Info->cpBuffer);

	fclose(fpSaveFile);
}

void save_para_2_file(struct sPROV_INFORMATION *spProv_Info)
{
	FILE *fpSaveFile;

	DEBUG_PRINT("save parameter to file:%s\n", DEFAULT_CONFIG_FILE_PATH);

	fpSaveFile = fopen(DEFAULT_CONFIG_FILE_PATH, "w");

	fprintf(fpSaveFile, "%s%s\n", CHECK_FW_UPDATE_FILE_NAME, spProv_Info->caFWFileName);
	fprintf(fpSaveFile, "%s%s\n", CHECK_TFTP_DOMAIN_STR, spProv_Info->caServerIP);
	fprintf(fpSaveFile, "%s%d\n", CHECK_TFTP_PRIMARY_PORT_NUM_STR, spProv_Info->iTftpPrimaryPortNum);
	fprintf(fpSaveFile, "%s%d\n", CHECK_TFTP_SECONDARY_PORT_NUM_STR, spProv_Info->iTftpSecondaryPortNum);
	fprintf(fpSaveFile, "%s%d\n", CHECK_TFTP_DEFAULT_PORT_NUM_STR, spProv_Info->iTftpDefaultPortNum);
	fprintf(fpSaveFile, "%s%d\n", CHECK_RELOAD_PERIOD_STR, spProv_Info->iPeriodicInterval);
	fprintf(fpSaveFile, "%s%s\n", CHECK_SET_CFG_FILE_NAME, spProv_Info->caFile_Sys_Name);
	fprintf(fpSaveFile, "%s%s\n", CHECK_RC4_KEY_VALUE_STR, spProv_Info->caRC4_Key);

	fclose(fpSaveFile);
}

void update_cfg_setting_2_sProv(struct sPROV_INFORMATION *spProv_Info)
{
	get_provisioning_file_name(spProv_Info->cpBuffer, spProv_Info->caFile_Sys_Name);
	DEBUG_PRINT("\n\n\n\n\nUpdate (%d)File Name: %s\n", strlen(spProv_Info->caFile_Sys_Name), spProv_Info->caFile_Sys_Name);
	/* Ok to get the tftp seripa */
	get_tftp_server_ip_address(spProv_Info->cpBuffer, spProv_Info->caServerIP);
	DEBUG_PRINT("\nUpdate (%d)_Server IP Address: %s\n", strlen(spProv_Info->caServerIP), spProv_Info->caServerIP);

	get_tftp_port_number(spProv_Info->cpBuffer, CHECK_TFTP_PRIMARY_PORT_NUM_STR, &spProv_Info->iTftpPrimaryPortNum);
	DEBUG_PRINT("\nUpdate Primary Port Number: %d\n", spProv_Info->iTftpPrimaryPortNum);

	get_tftp_port_number(spProv_Info->cpBuffer, CHECK_TFTP_SECONDARY_PORT_NUM_STR, &spProv_Info->iTftpSecondaryPortNum);
	DEBUG_PRINT("\nUpdate Secondary Port Number: %d\n", spProv_Info->iTftpSecondaryPortNum);

	get_tftp_port_number(spProv_Info->cpBuffer, CHECK_TFTP_DEFAULT_PORT_NUM_STR, &spProv_Info->iTftpDefaultPortNum);
	DEBUG_PRINT("\nUpdate Default Port Number: %d\n", spProv_Info->iTftpDefaultPortNum);

	get_rc4_key_from_buffer(spProv_Info->cpBuffer, spProv_Info->caRC4_Key);
	DEBUG_PRINT("\nGet RC4 Key: %s\n", spProv_Info->caRC4_Key);
	PROV_SYSTEM("%s Get Cfg to nvram set RC4 Key: %s >> %s", ECHO_CMD, spProv_Info->caRC4_Key, DEBUG_SAVE_DIR);

	get_tftp_cfg_file_Version(spProv_Info->cpBuffer, spProv_Info->caProvCFGVer);
	DEBUG_PRINT("\nUpdate (%d)_CFG file Version: %s\n", strlen(spProv_Info->caProvCFGVer), spProv_Info->caProvCFGVer);
	PROV_SYSTEM("%s Update \\(%d\\)_CFG file Version: %s >> %s", ECHO_CMD, strlen(spProv_Info->caProvCFGVer), spProv_Info->caProvCFGVer, DEBUG_SAVE_DIR);

	get_reload_period_interval_time(spProv_Info->cpBuffer, &spProv_Info->iPeriodicInterval);
	DEBUG_PRINT("\nUpdate Periodic Interval Time: %d\n\n\n\n\n\n\n", spProv_Info->iPeriodicInterval);
	PROV_SYSTEM("%s 1054: Update CFG file Version: %s >> %s", ECHO_CMD, spProv_Info->caProvCFGVer, DEBUG_SAVE_DIR);
	get_tftp_update_fw_filename(spProv_Info->cpBuffer, spProv_Info->caFWFileName);
	DEBUG_PRINT("\nUpdate FW File Name: %s\n", spProv_Info->caFWFileName);

	PROV_SYSTEM("%s 1058: Update CFG file Version: %s >> %s", ECHO_CMD, spProv_Info->caProvCFGVer, DEBUG_SAVE_DIR);
	PROV_SYSTEM("%s End Get Cfg to nvram set RC4 Key: %s >> %s", ECHO_CMD, spProv_Info->caRC4_Key, DEBUG_SAVE_DIR);

}

void save_cfg_2_nvram_set(struct sPROV_INFORMATION *spProv_Info)
{
#if 1
	char caTmp[VERSION_LENGTH] = "";
	nvram_set(NVRAM_TFTP_DOMAIN_STR, spProv_Info->caServerIP);
	sleep(1);
	
	number_transfer_to_str(caTmp, spProv_Info->iTftpDefaultPortNum);
	nvram_set(NVRAM_TFTP_DEFAULT_PORT_NUM_STR, caTmp);
	sleep(1);

	number_transfer_to_str(caTmp, spProv_Info->iTftpPrimaryPortNum);
	nvram_set(NVRAM_TFTP_PRIMARY_PORT_NUM_STR, caTmp);
	sleep(1);

	number_transfer_to_str(caTmp, spProv_Info->iTftpSecondaryPortNum);
	nvram_set(NVRAM_TFTP_SECONDARY_PORT_NUM_STR, caTmp);
	sleep(1);

	PROV_SYSTEM("%s Save Cfg to nvram set RC4 Key: %s >> %s", ECHO_CMD, spProv_Info->caRC4_Key, DEBUG_SAVE_DIR);
	nvram_set(NVRAM_RC4_KEY_STR, spProv_Info->caRC4_Key);
	sleep(1);

	number_transfer_to_str(caTmp, spProv_Info->iPeriodicInterval);
	nvram_set(NVRAM_RELOAD_PERIOD_STR, caTmp);
	sleep(1);

	nvram_set(NVRAM_CFG_FILE_NAME, spProv_Info->caFile_Sys_Name);
	sleep(1);

	nvram_set(NVRAM_FW_UPDATE_FILE_NAME, spProv_Info->caFWFileName);
	sleep(1);
	if(spProv_Info->caProvCFGVer != NULL)
	{
		DEBUG_PRINT("NVRAM set cfg file version to:%s\n", spProv_Info->caProvCFGVer);
		nvram_set(NVRAM_CFG_FILE_VERSION, spProv_Info->caProvCFGVer);
		PROV_SYSTEM("%s NVRAM set cfg file version to:%s >> %s", ECHO_CMD, spProv_Info->caProvCFGVer, DEBUG_SAVE_DIR);
		sleep(1);
	}
#ifdef PDEBUG
	else
	{
		// Just for debug...
		PROV_SYSTEM("%s Could not set into NVRAM_set cfg file version>> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	}
#endif
	nvram_commit();
#else
	char caCmd[200]="";

	/* Send Tftp Domain: nvram set prov_tftp_domain=192.168.0.113 */
	sprintf(caCmd, "nvram set %s=%s", NVRAM_TFTP_DOMAIN_STR, spProv_Info->caServerIP);
	system(caCmd);
	sleep(SYSTEM_CMD_INTERVAL_TIME);

	/* Send Tftp Port: nvram set prov_tftp_port=69 */
	memset(caCmd, 0, 200);
	sprintf(caCmd, "nvram set prov_tftp_port=%d", spProv_Info->iTftpDefaultPortNum);
	system(caCmd);
	sleep(SYSTEM_CMD_INTERVAL_TIME);

	/* Send Configure file name: nvram set prov_cfg_filename=ng00c002f9ffe0.cfg */
	memset(caCmd, 0, 200);
	sprintf(caCmd, "nvram set prov_cfg_filename=%s", spProv_Info->caFile_Sys_Name);
	system(caCmd);
	sleep(SYSTEM_CMD_INTERVAL_TIME);

	/* Send RC4 Key: nvram set prov_rc4_key=e15........c75 */
	memset(caCmd, 0, 200);
	sprintf(caCmd, "nvram set prov_rc4_key=%s", spProv_Info->caRC4_Key);
	system(caCmd);
	sleep(SYSTEM_CMD_INTERVAL_TIME);

	/* Send Periodic interval time: nvram set prov_period_interval=1440 */
	memset(caCmd, 0, 200);
	sprintf(caCmd, "nvram set prov_period_interval=%d", spProv_Info->iPeriodicInterval);
	system(caCmd);
	sleep(SYSTEM_CMD_INTERVAL_TIME);
#endif
}

void number_transfer_to_str(char *cpTmp, int iNum)
{
	memset(cpTmp, '\0', VERSION_LENGTH);
	sprintf(cpTmp, "%d", iNum);
}

void read_file_from_save_data(struct sPROV_INFORMATION *spProv_Info)
{
#ifdef DEBUG_PRINT_DATA_BY_HEX
	int iTmp;
#endif
	FILE *fpOpenFile;
	char *cpFileData;
	char caFileName[FILENAME_MAX_LEN] = "";

	//memcpy(caFileName, sProv_Info->caMAC_Data, MAC_LENGTH);
	//get_save_file_name(caFileName, sProv_Info->caMAC_Data);
	//strcat(caFileName, ".cfg");
	/* Use the store file name head, "store_"
		to save the decrypt rc4 file result... */
	sprintf(caFileName, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(spProv_Info->caFile_Sys_Name));
	DEBUG_PRINT("read file from save data: %s\n", caFileName);
	fpOpenFile = fopen(caFileName, "r");
	if(fpOpenFile == NULL)
		return;

	cpFileData = (char *)malloc(sizeof(char)*spProv_Info->ulBufferLen);
	if(!cpFileData)
	{
		fclose(fpOpenFile);
		return;
	}
	fscanf(fpOpenFile, "%s", cpFileData);

	DEBUG_PRINT("\nDebug for open data file:\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iTmp = 0; iTmp < spProv_Info->ulBufferLen; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", cpFileData[iTmp]);
		if((iTmp+1)%10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif
	if(cpFileData)
		free(cpFileData);
	fclose(fpOpenFile);
}

int get_internet_file(struct sPROV_INFORMATION *spProv_Info)
{
	int iRet = 0;

	switch(spProv_Info->ucProv_Methods)
	{
		case PROV_USE_TFTP:
			iRet = get_file_use_tftp(spProv_Info);
			break;
		case PROV_USE_HTTP:
			break;
		case PROV_USE_HTTPS:
			break;
		case PROV_USE_FTP:
			break;
		default:
			 break;
	}
	return iRet;
}

int check_cfg_file_need_to_reboot_modem(char *cpData)
{
	if(cpData)
	{
		if(strstr(cpData, REBOOT_CMD_IN_CFG_FILE) != NULL)
		{
			PROV_SYSTEM("%s Find the Reboot in file, and need to update file... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		
			return MSG_OK;
		}
		PROV_SYSTEM("%s Not need to reboot the modem from cfg file... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	}
	PROV_SYSTEM("%s Not find the Reboot in file... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	return CFG_FILE_NON_REBOOT_MODEM;
}
// Return Success or UnSucces get file...
int get_file_use_tftp(struct sPROV_INFORMATION *spProv_Info)
{
	DEBUG_PRINT("get_file_use_tftp: %s\n", spProv_Info->caFile_Sys_Name);


	if(spProv_Info->iTftpDefaultPortNum != 0)
	{
		if((get_file_provision_tftp(spProv_Info->caFile_Sys_Name, spProv_Info->caServerIP, spProv_Info->iTftpDefaultPortNum)) == MSG_OK)
		{
			PROV_SYSTEM("%s Default Port get file OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			DEBUG_PRINT("\tTftp Update OK.....\n\t\tUsed Default Port...\n");
			return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
		}
	}
	PROV_SYSTEM("%s Default Port get file failed.. >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	ERROR_PRINT("Update by TFTP with \"Default\" Port... Unsuccess.....\nPlease retry..\n");
	DEBUG_PRINT("Update by TFTP with \"Default\" Port... Unsuccess.....\nPlease retry..\n");

	if(spProv_Info->iTftpPrimaryPortNum != 0)
	{
		if((get_file_provision_tftp(spProv_Info->caFile_Sys_Name, spProv_Info->caServerIP, spProv_Info->iTftpPrimaryPortNum)) == MSG_OK)
		{
			PROV_SYSTEM("%s Primary Port get file OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			DEBUG_PRINT("\tTftp Update Used Primary Port:OK.....\n");
			return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
		}
	}
	PROV_SYSTEM("%s Primary Port get file failed.. >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	ERROR_PRINT("Update by TFTP with \"Primary Port\"... Unsuccess.....\n");
	
	if(spProv_Info->iTftpSecondaryPortNum != 0)
	{
		if((get_file_provision_tftp(spProv_Info->caFile_Sys_Name, spProv_Info->caServerIP, spProv_Info->iTftpSecondaryPortNum)) == MSG_OK)
		{
			PROV_SYSTEM("%s Secondary Port get file OK... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			DEBUG_PRINT("\tTftp Update OK.....\n\t\tUsed Secondary Port...\n");
			return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
		}
	}
	PROV_SYSTEM("%s Secondary Port get file failed... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	ERROR_PRINT("Update by TFTP with \"Secondary\" Port... Unsuccess.....\n");
	DEBUG_PRINT("Update by TFTP with \"Secondary\" Port... Unsuccess.....\n");

	return UNSUCCESS_OPEN_or_GET_FILE;
}

//1
int check_fw_version_the_same(char *cpFWFileName)
{
	char caOrgVer[VERSION_LENGTH] = "";

	if(get_version_from_etc_version(caOrgVer) != MSG_OK)
	{
		return NEED_TO_UPDATE_FW_FILE;
	}
	/* Don't update, because version check isn't new version... */
	if(check_new_fw_version_same(caOrgVer, cpFWFileName) == MSG_OK)
	{
		return MSG_OK;
	}
	return NEED_TO_UPDATE_FW_FILE;
}

//1_1
int get_version_from_etc_version(char *cpOrgVer)
{
	FILE *fpVer;
	int iCount;

	fpVer = fopen(VERSION_CHECK_FILE_NAME, "r");
	if(fpVer == NULL)
		return NEED_TO_UPDATE_FW_FILE;

	iCount = fread(cpOrgVer, 1, VERSION_LENGTH, fpVer);
	DEBUG_PRINT("Get Version length(%d) from /etc/version:%s\n", iCount, cpOrgVer);

	DEBUG_PRINT("Start fclose fpVer\n");
	fclose(fpVer);
	DEBUG_PRINT("fclose fpVer\n");

	return MSG_OK;
}

//1_2
int check_new_fw_version_same(char *cpOrgVer, char *cpFileName)
{
	int iCount = 0, iaVer[5], iaOpenVer[5];
	
	for(iCount = 0; iCount < 5; iCount ++)
	{
		iaVer[iCount] = 0;
		iaOpenVer[iCount] = 0;
	}

	PROV_SYSTEM("%s start version Check .... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	DEBUG_PRINT("FileName:%s\nVersion:%s\n", cpFileName, cpOrgVer);

	parse_version_2_char(cpOrgVer, iaOpenVer);
	DEBUG_PRINT("Parse Version 2 char ... Finish\n");
	parse_filename_2_char(cpFileName, iaVer);
	DEBUG_PRINT("Parse File Name 2 char ... Finish\n");

	return (check_two_integers_same(iaOpenVer, iaVer));
}

//1_2_3
int check_two_integers_same(int *ipOpenVer, int *ipVer)
{
	if(ipOpenVer[0] == ipVer[0])
	{
		if(ipOpenVer[1] == ipVer[1])
		{
			if(ipOpenVer[2] == ipVer[2])
			{
				PROV_SYSTEM("%s Version Same... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
				DEBUG_PRINT("Version Same[012]... >> %s\n", DEBUG_SAVE_DIR);
				return MSG_OK;
			}
			PROV_SYSTEM("%s Version not Same in [2]... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			DEBUG_PRINT("Version not Same in [2]... >> %s\n", DEBUG_SAVE_DIR);
		}
		PROV_SYSTEM("%s Version not Same in [1]... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		DEBUG_PRINT("Version not Same in [1]... >> %s\n", DEBUG_SAVE_DIR);
	}
	PROV_SYSTEM("%s Version not Same in [0]... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	DEBUG_PRINT("Version not Same in [0]... >> %s\n", DEBUG_SAVE_DIR);
	return NEED_TO_UPDATE_FW_FILE;
}

//1_2_1
void parse_version_2_char(char *cpOrgVer, int *ipOpenVer)
{
	int iCount = 0;
	char caTmp1[3] = "", caTmp2[3] = "", caTmp3[3] = "";

	if(strlen(cpOrgVer) != 0)
	{
		int iTmp = 0;

		DEBUG_PRINT("1111\n");
		while((cpOrgVer[iCount] != '.') &&(cpOrgVer[iCount] != '\0'))
		{
			caTmp1[iTmp] = cpOrgVer[iCount];
			iCount ++;
			iTmp ++;
		}
		iCount ++;
		caTmp1[iCount] = '\0';
		DEBUG_PRINT("Version1:%02x %02x\n", caTmp1[0], caTmp1[1]);
		ipOpenVer[0] = atoi(&caTmp1[1]);
		DEBUG_PRINT("Version1:%d\n", ipOpenVer[0]);
		iTmp = 0;
		while(cpOrgVer[iCount] != '.')
		{
			caTmp2[iTmp] = cpOrgVer[iCount];
			iCount ++;
			iTmp ++;
		}
		iCount ++;
		DEBUG_PRINT("Version2:%c, %c\n%d, %d\n", caTmp2[0], caTmp2[1], atoi(&caTmp2[0]), atoi(&caTmp2[1]));
		ipOpenVer[1] = atoi(caTmp2);
		iTmp = 0;
		while((cpOrgVer[iCount] != '.') && (cpOrgVer[iCount] != '\0'))
		{
			caTmp3[iTmp] = cpOrgVer[iCount];
			iCount ++;
			iTmp ++;
		}
		DEBUG_PRINT("Version2:%c, %c\n", caTmp3[0], caTmp3[1]);
		ipOpenVer[2] = atoi(caTmp3);
		/* A0    .        01  .     22 */
		/* %[^.] .  %[^.] .  %d */
//		DEBUG_PRINT("parse version 2 char: do now...\n%s\n", cpOrgVer);
//		sscanf(cpOrgVer, "%[^.].%[^.].%d", caTmp, caTmp2, &ipOpenVer[2]);//&ipOpenVer[1], &ipOpenVer[2]);
		//sscanf(cpOrgVer, "%d.%d.%d", &ipOpenVer[0], &ipOpenVer[1], &ipOpenVer[2]);
//		ipOpenVer[1] = atoi(caTmp2[0]) * 10  + atoi(caTmp2[1]);
		//ipOpenVer[2] = atoi(caTmp3[0]) * 10  + atoi(caTmp3[1]);
//		DEBUG_PRINT("Parse version:%02x %02x,,,%d,,,%d...\n", caTmp[0], caTmp[1], ipOpenVer[1], ipOpenVer[2]);
//		ipOpenVer[0] = atoi(caTmp[1]);
		DEBUG_PRINT("Version Check by Open Version File: %d, %d, %d\n", ipOpenVer[0], ipOpenVer[1], ipOpenVer[2]);
		PROV_SYSTEM("%s Version Check by Open Version File %d.%d.%d >> %s", ECHO_CMD, ipOpenVer[0], ipOpenVer[1], ipOpenVer[2], DEBUG_SAVE_DIR);
	}
}
//1_2_2
void parse_filename_2_char(char *cpFileName, int *ipVer)
{
	int iCount = 0;
	char caTmp1[3] = "", caTmp2[3] = "", caTmp3[3] = "";

	if(strlen(cpFileName) != 0)
	{
		int iTmp = 0;

		while((cpFileName[iCount] != '_') && (cpFileName[iCount] != '\0'))
		{
			DEBUG_PRINT("%c\n", cpFileName[iCount]);
			iCount ++;
		}
		iCount ++;
		while((cpFileName[iCount] != '.') &&(cpFileName[iCount] != '\0'))
		{
			caTmp1[iTmp] = cpFileName[iCount];
			iCount ++;
			iTmp ++;
		}
		iCount ++;
		DEBUG_PRINT("_1111_end:%02x %02x\n", caTmp1[0], caTmp1[1]);
		ipVer[0] = atoi(&caTmp1[1]);
		DEBUG_PRINT("_1112:%d\n", ipVer[0]);
		iTmp = 0;
		while((cpFileName[iCount] != '.') &&(cpFileName[iCount] != '\0'))
		{
			caTmp2[iTmp] = cpFileName[iCount];
			iCount ++;
			iTmp ++;
		}
		iCount ++;
		DEBUG_PRINT("_1113:%c, %c\n%d, %d\n", caTmp2[0], caTmp2[1], atoi(&caTmp2[0]), atoi(&caTmp2[1]));
		ipVer[1] = atoi(caTmp2);
		iTmp = 0;
		while((cpFileName[iCount] != '.') && (cpFileName[iCount] != '\0'))
		{
			caTmp3[iTmp] = cpFileName[iCount];
			iCount ++;
			iTmp ++;
		}
		DEBUG_PRINT("_1114:%c, %c\n", caTmp3[0], caTmp3[1]);
		ipVer[2] = atoi(caTmp3);
	}
	/* DG834GV_ v0    .     01    .     22    .   img */
	/* %*s      %[^_]    %[^.]     %[^.]  %*s */
	//sscanf(cpFileName, "%*s_%s.%d.%d.%*s", caValue, caTmp, &ipVer[1], &ipVer[2], caValue);
	//ipVer[0] = atoi(&caTmp[1]);
	DEBUG_PRINT("Version Check by File Name: %d, %d, %d\n", ipVer[0], ipVer[1], ipVer[2]);
	PROV_SYSTEM("%s Version Check by File Name >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
}

int process_local_file(struct sPROV_INFORMATION *sProv_Information)
{
	int iTmp = 0;

	//DEBUG_SYSTEM("echo 006_1>> /tmp/debug");
	/* Get file size, ... */
	if(open_update_file(sProv_Information->caFile_Sys_Name, &sProv_Information->ulBufferLen) == UNSUCCESS_OPEN_or_GET_FILE)
	{
		ERROR_PRINT("\n\n\n\nCouldn't open the file: %s...\n", sProv_Information->caFile_Sys_Name);
		return ERROR_MSG_NO_FILE_OPEN;
	}

	/* Get file data space from memory, ... */
	sProv_Information->cpBuffer = (unsigned char *)malloc(((int)sProv_Information->ulBufferLen)*sizeof(unsigned char));

	if(!sProv_Information->cpBuffer)
	{
		return ERROR_MSG_NO_MEMORY_SPACE;
	}
	// Initialize the malloc space...
	for(iTmp = 0; iTmp < (int)sProv_Information->ulBufferLen; iTmp ++)
		sProv_Information->cpBuffer[iTmp] = '\0';

	if(file_read_data_to_struct(sProv_Information->caFile_Sys_Name, sProv_Information->cpBuffer, sProv_Information->ulBufferLen) == UNSUCCESS_OPEN_or_GET_FILE)
	{
		ERROR_PRINT("Error for copy data to struct...\n\n");
		return ERROR_MSG_NO_FILE_OPEN;
	}
	
	DEBUG_PRINT("\tGET the File Legnth: %ld\n", sProv_Information->ulBufferLen);
	DEBUG_PRINT("\t\tThe puts data:\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iTmp = 0; iTmp < sProv_Information->ulBufferLen; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", sProv_Information->cpBuffer[iTmp]);
		if((iTmp + 1) %10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif

	return MSG_OK;	/* MSG_OK = 0 */
}

/* Return the OK message, and get the file size and data...*/
int open_update_file(char *cpLocalFileName, unsigned long *ulpValue)
{
	int iFileLength;
	char caCmdChg[128] = "", caTmp[200] = "";
	FILE *fpCFG;

	// Change command mode to 666.
	sprintf(caCmdChg, "chmod 666 %s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpLocalFileName));
	system(caCmdChg);

	memset(caTmp, 0x00, 200);

	/*	Get the file length..... Sample by ron.....
		in tools/makeimage/src/makeImage.c .. my_read_file().... */
	//	Open file for read...
	sprintf(caTmp, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpLocalFileName));
	fpCFG = fopen(caTmp, "r");
	//	We don't need to check this, because we already check the file below.....
	if(fpCFG == NULL)
	//if((fpCFG = fopen("//tmp//0c02f9ffe0.cfg", "rb")) == NULL)
	{
		DEBUG_PRINT("Couldn't open the file...\n");

		return UNSUCCESS_OPEN_or_GET_FILE;
	}
	// Get the open file's length.....
	iFileLength = my_file_length_with_fp(fpCFG);

	DEBUG_PRINT("File Length by function: %d\n", iFileLength);
	DEBUG_PRINT("\tOpen file OK...\n");

	fclose(fpCFG);

	*ulpValue = (unsigned long)iFileLength;

	return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
}

int file_read_data_to_struct(char *cpLocalFileName, unsigned char *cpFileData, unsigned long ulDataLen)
{
#ifdef DEBUG_PRINT_DATA_BY_HEX
	int iTmp;
#endif
	FILE *fpCFG;
	char caTmpName[200];

	sprintf(caTmpName, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(cpLocalFileName));
	DEBUG_PRINT("file read data to struct file name:%s", caTmpName);
	fpCFG = fopen(caTmpName, "r");
	if(fpCFG == NULL)
	{
		ERROR_PRINT("Couldn't open the file to read...\n");
		return UNSUCCESS_OPEN_or_GET_FILE;
	}
	fread(cpFileData, 1, ulDataLen, fpCFG);
	fclose(fpCFG);

	DEBUG_PRINT("\nFile read data to struct...\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iTmp = 0; iTmp < ulDataLen; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", cpFileData[iTmp]);
		if((iTmp+1)%10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif
	return MSG_OK;	//SUCCESS_OPEN_or_GET_FILE;
}

void copy_mtdblock_5_to_old_file(char *cpFileName)
{
	FILE *fpMTD5;
	int iDataLen = 0, iFileLen = 0, iCount = 0;
	char caFileName[200] = "", *cpData, *cpFinalData;

	fpMTD5 = fopen(SAVE_VOIP_CFG_TO_FLASH, "r");
	if(fpMTD5 == NULL)
		return;
	iDataLen = my_file_length_with_fp(fpMTD5);
	DEBUG_PRINT("mtdblock_5 Length:%d\n\n", iDataLen);
	cpData = (char *)malloc(iDataLen * sizeof(char));
	if(!cpData)
	{
		fclose(fpMTD5);
		return;
	}
	DEBUG_PRINT("\tMalloc af .. mtdblock_5 Length:%d\n\n", iDataLen);
	memset(cpData, 0x00, iDataLen);
	fread(cpData, 1, iDataLen, fpMTD5);
	fclose(fpMTD5);
	DEBUG_PRINT("\t\tmtdblock_5 Length:%d\n\n", iDataLen);
	while(1)
	{
		if(cpData[iCount] == '\0')
			break;
		if((unsigned char)cpData[iCount] == 0xff)
			break;
		if(cpData[iCount] == 0x00)
			break;
		iFileLen ++;
		iCount++;
	}
	DEBUG_PRINT("\t\t\tmtdblock_5 Length:%d\n\n", iCount);

	cpFinalData = (char *)malloc((iCount + 1) * sizeof(char));
	if(!cpFinalData)
	{
		if(cpData)
			free(cpData);
		return;
	}
	memset(cpFinalData, '\0', iCount + 1);
	strncpy(cpFinalData, cpData, iCount);
	cpFinalData[iCount] = '\0';
	
	sprintf(caFileName, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	DEBUG_PRINT("\t\t\t\tCopy MTD5 (Length: %d) to file name:\n\t %s\n", iCount, cpFileName);
	/* Clean the file, set it to zero... */
	fpMTD5 = fopen(caFileName, "w+");
	fclose(fpMTD5);
	/* Open file and save data to it... */
	fpMTD5 = fopen(caFileName, "w+");
	fprintf(fpMTD5, cpFinalData);
	
	fclose(fpMTD5);
	if(cpData)
		free(cpData);
	if(cpFinalData)
		free(cpFinalData);
}

void copy_voip_default_cfg_to_old_file(char *cpFileName)
{
#if 0
	char caCmdBuf[200];
	
	sprintf(caCmdBuf, "cp %s %s%s%s", DEFAULT_VOIP_CFG_NAME,  DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	DEBUG_PRINT("Copy voip default.cfg to old_.... file:\n%s\n", caCmdBuf);
	
	system(caCmdBuf);
#endif
}

void move_nvram5_file_to_store_name(char *cpFileName)
{
	char caCmdBuf[200] = "";
	FILE *fpOrgFile;

	/* Always to copy the NVRAM file to store file... */
	sprintf(caCmdBuf, "%s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
	if((fpOrgFile = fopen(caCmdBuf, "r")) != NULL)
	{
		fclose(fpOrgFile);
		memset(caCmdBuf, 0, 200);
		sprintf(caCmdBuf, "rm %s%s%s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(cpFileName));
		system(caCmdBuf);
		DEBUG_PRINT("No original file to backup...\nCopy the default.cfg to backup...\n");
	}

	copy_mtdblock_5_to_old_file(cpFileName);
	DEBUG_PRINT("Move NVRAM file to backup...\n\n");
}

void save_file_to_nvram_mtdb5(struct sPROV_INFORMATION *spProv_Info)
{
	char caCmdBuf[FILENAME_MAX_LEN + 15] = "";

	system("rc voip stop");
	initialize_mtdblock5_to_0();
	//memcpy(caFileName, spProv_Info->caMAC_Data, MAC_LENGTH);
	//strcat(caFileName, ".cfg");
	sprintf(caCmdBuf, "cp %s%s%s %s", DEFAUTL_TMP_DIR, STORE_FILE_NAME_HEAD, update_cfg_file_name_into_simple(spProv_Info->caFile_Sys_Name), SAVE_VOIP_CFG_TO_FLASH);
	DEBUG_PRINT("Copy CFG File to NVRAM: %s\n", caCmdBuf);
	system(caCmdBuf);
	sleep(SYSTEM_CMD_INTERVAL_TIME);
	system("rc voip start");
	sleep(SYSTEM_CMD_INTERVAL_TIME);
}

void initialize_mtdblock5_to_0(void)
{
	sleep(SYSTEM_CMD_INTERVAL_TIME);
	system("dd if=/dev/zero of=/dev/mtdblock/5 bs=1k count=64");
	sleep(SYSTEM_CMD_INTERVAL_TIME);
}
