#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "my_error_msg.h"
#include "../nvram/nvram.h"
#include "provision_update.h"
#include "provision_tools.h"

int get_file_provision_tftp(char *, char *, int);
void get_tftp_server_ip_address(char *, char *);
static void getMac(char *);
void get_provisioning_file_name(char *, char *);
int get_tftp_port_number(char *, char *, int *);
void get_ucaKey_from_setting_or_default(unsigned char *, char *);
int get_rand_sec(void);
int wan_ready(void);
int get_prov_interval_cfg(void);
void error_msg_process(int);
int my_read_file_length(char *);
int AsciiToHex(char *, unsigned char *);
int my_file_length_with_fp(FILE *);
int decrypt_file(unsigned char *, unsigned int, int, unsigned char *,  unsigned int);
int get_internet_file(struct sPROV_INFORMATION *);
int get_file_use_tftp(struct sPROV_INFORMATION *);
int process_local_file(struct sPROV_INFORMATION *);
void copy_old_file_to_old_name(char *);
void save_file_to_nvram_mtdb5(struct sPROV_INFORMATION *);
int file_read_data_to_struct(char *, unsigned char *, unsigned long);
int open_update_file(char *, unsigned long *);

int initialize_get_env_param_info(struct sPROV_INFORMATION *);
int initialize_struct_Prov_Information(struct sPROV_INFORMATION *);
int copy_NVRAM_default_data_2_struct(struct sPROV_INFORMATION *);
void initialize_mtdblock5_to_0(void);
void parse_filename_2_char(char *, int *);
void parse_version_2_char(char *, int *);
int check_two_integers_same(int *, int *);
char *get_keybuff(int, char *);
int get_enctype(int);
int check_fw_version_the_same(char *);
int get_version_from_etc_version(char *);
int check_new_fw_version_same(char *, char *);
void get_default_tftp_server_ip_from_ticfgenv(char *);
void get_default_rc4key_from_ticfgenv(char *);
int check_file_size_non_zero(char *);
void open_mtdblock5_file_to_get_data(char *);
int get_reload_period_interval_time(char *, int *);
void get_tftp_update_fw_filename(char *, char *);
void get_rc4_key_from_buffer(char *, unsigned char *);
int read_data_to_specific_name(char *, struct sPROV_INFORMATION *);
void get_default_cfg_file_name(char *);
int compare_two_kind_mac(char *, char *);
void number_transfer_to_str(char *, int);
int get_tftp_port_number_from_nvram(int *, int *, int *);
void get_tftp_cfg_file_Version(char *, char *);
int check_cfg_file_need_to_reboot_modem(char *);
