#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "provisioning.h"
#include "my_error_msg.h"
#include "debug_process.c"
#include "prov_tiny.c"
#include "provision_update.c"
#include "prov_time.c"
#include "provision_tools.c"
#include "prov_voip_para.c"

/* In there, only process the Time that divided updated success or unsuccess... */
int main(int argc, char **argv)
{
	int first_prov = TRUE; // , iWaitSec = 0, iUpgrade_Success_Flag = TRUE;
	int iRet = 0, iTime_Interval = 0, iRandon_Time = 0, iFailed_Times = 0, iBackoff_Times = 0;
	long lTime_Last_Update = 99999, lTime_Now = 0, lPeriod_Time = 0;
	long lWhileTimeInterval = 0;
	char cRet;

	/* Added for 0.99b by Peter */
	if(argc < 2)
	{
		ERROR_PRINT("Command not enough length....\n");
		return ERROR;		
	}

	/* Already get the update way by user setting... */
	//cRet = getopt( argc, argv, "h:s:l:t:v:");
	// Only capture the one character... like t, h, s, l ...
	if(argv[argc-1][0] == '&')
	{
		cRet = argv[argc-2][0];
	}
	else
	{
		cRet = argv[argc-1][0];
	}
	DEBUG_SIMPLE_MSG("User Used way: %c\n\t\targv:%s\n", cRet, argv[argc-1]);

	while(!wan_ready())
	{
		ERROR_PRINT("Wan not ready! Must wait...........\n");
		sleep(DEFAULT_RELOAD_PERIOD_TIME);
	}

	/* Get the Pid from first 128 bytes in mtdblock 1 (Kernel) */
	get_pid_from_kernel_mtdblock_1();

	get_last_update_time(&lTime_Last_Update);

	while(1)
	{
		DEBUG_PRINT("\n+++++++++++++Start Timing Check...++++++++++++++++\n");
		PROV_SYSTEM("%s Step_0 Show Time... > %s", ECHO_CMD, DEBUG_SAVE_DIR);

		get_modem_now_time(&lTime_Now);

		DEBUG_PRINT("Get the New time for timing...\n");
		/* Use default Periodic Time interval(from sec. to min.)...*/
		lWhileTimeInterval = iTime_Interval * 60;
		//debug_system_cmd("echo While time get... > /tmp/debugaa");
		PROV_SYSTEM("%s Step_1 While Interval time get: %ld\\(s\\)... >> %s"
				, ECHO_CMD, lWhileTimeInterval, DEBUG_SAVE_DIR);
		PROV_SYSTEM("%s Step_1_1 Time Interval: %d\\(min\\)... >> %s"
				, ECHO_CMD, iTime_Interval, DEBUG_SAVE_DIR);

		DEBUG_PRINT("\tlWhiel Time Interval: %ld\n", lWhileTimeInterval);
		if(iRet != MSG_OK)
		{
			/* Get the new time from "Backoff_Time * 5"... */
			iBackoff_Times = use_backoff_retry_time(iFailed_Times) * 5;
			if(iBackoff_Times > lWhileTimeInterval)
			{
				iBackoff_Times = lWhileTimeInterval;
			}
			DEBUG_PRINT("\t\tiBackoff Times: %d\n", iBackoff_Times);
			PROV_SYSTEM("%s Step_2 iBackoff Times: %d >> %s", ECHO_CMD, iBackoff_Times, DEBUG_SAVE_DIR);
		}
		if(first_prov)
			PROV_SYSTEM("%s Step_3 First Provisioning Round... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);

		lPeriod_Time = lWhileTimeInterval + iBackoff_Times + iRandon_Time * 5;

		//debug_system_cmd("echo iPeriod Time >> /tmp/debugaa");
		PROV_SYSTEM("%s Step_4 iPeriod Time: %d >> %s", ECHO_CMD, lPeriod_Time, DEBUG_SAVE_DIR);
		DEBUG_SIMPLE_MSG("New Round!\n\tRound%d\n\tPeriodic Time: %ld\n\t\tFailed Times: %d\n"
				, prov_timestamp, lPeriod_Time, iFailed_Times);

		if((first_prov) || ((lTime_Now - lTime_Last_Update) > lPeriod_Time))
		{
			PROV_SYSTEM("%s Step_5 process_loop >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			DEBUG_PRINT("\n============Start Provisioning...======================\n");
			DEBUG_PRINT("Prov. Last attempt time get...\n");
			set_last_ntp_time_and_2_nvram(NVRAM_PROV_LAST_ATTEMPT_TIME);

			PROV_SYSTEM("%s Step_6 pre provision_process >> %s", ECHO_CMD, DEBUG_SAVE_DIR);

			iRet = provision_process(cRet, &iTime_Interval);
			DEBUG_PRINT("Provision Process .... iRet: %d\n", iRet);
			PROV_SYSTEM("%s Step_7 after provision process[cRet]:%c >> %s", ECHO_CMD, cRet, DEBUG_SAVE_DIR);
			PROV_SYSTEM("%s Step_8 provision process New Interval Time:%d >> %s", ECHO_CMD, iTime_Interval, DEBUG_SAVE_DIR);
			/* For first provisioning to recursive the get file failed... */
			if(first_prov)
				sleep(iBackoff_Times);

			/* For Provisioning Version Check... */
			if((cRet == 'v') || (cRet == 'r')|| (cRet == 'm'))
			{
				//continue;
				return MSG_OK;
			}

			/* For error message process, that can display what's error.... */
			if(iRet != MSG_OK)	//&&(iRet != GET_THE_SAME_FILE_NO_UPDATE)) /* MSG_OK = 0 */
			{
				/* Upgrade fail, must try in several seconds later... */
				iFailed_Times ++;

				/* if Not success for update CFG or FW, we need to wait some times to reload the CFG or FW... */
				error_msg_process(iRet);

				//debug_system_cmd("echo Update Failed times... >> /tmp/debugaa");
				PROV_SYSTEM("%s Step_9 Update Failed times:%d... >> %s", ECHO_CMD, iFailed_Times, DEBUG_SAVE_DIR);
				DEBUG_PRINT("\t\tUpdate Failed times= %d\n", iFailed_Times);
				sleep(2);
			}
			else	// Success or don't need to update FW....
			{
				first_prov = FALSE;
				/* Get Update new time(count = 0)... */
				iFailed_Times = 0;
				prov_timestamp = 0;
				/* Setting last update success... */
				lTime_Last_Update = get_sys_uptime_return_seconds();
				PROV_SYSTEM("%s Step_9 Success Update Last_update time:%ld... >> %s", ECHO_CMD, lTime_Last_Update, DEBUG_SAVE_DIR);
				DEBUG_PRINT("Update Last_update time:%ld\n", lTime_Last_Update);
				set_last_ntp_time_and_2_nvram(NVRAM_PROV_LAST_UPDATE_TIME);
				sleep(1);
			}
		}
		else
		{
			sleep(DEFAULT_RELOAD_PERIOD_TIME);	// now set to 5s...
			prov_timestamp ++;

			PROV_SYSTEM("%s Step_a Waiting for provision time stamp:%d... >> %s", ECHO_CMD, prov_timestamp, DEBUG_SAVE_DIR);
			DEBUG_SIMPLE_MSG("Waiting for provision time stamp.\n");
		}
		iRandon_Time = get_rand_sec();
		//DEBUG_PRINT("Get iRandon Time: %d\n", iRandon_Time);
	}
	return MSG_OK;
}

// if OK, return 0, else return ERROR_MSG....
int provision_process(char cRet, int *ipPeriodIntervalTime)
{
	struct sPROV_INFORMATION sProv_Information;
	int iRet = 0, iCfgNonRebootFlag = 1;
	FILE *fpCFG;
	char caTmp[MAX_CMD_USE_LENGTH] = "";

	/* Get Data from file and initialize.... */
	if(initialize_struct_Prov_Information(&sProv_Information) != MSG_OK)
	{
		ERROR_PRINT("Initialize the parameter failed, maybe couldn't get the parameter...\n\tPlease wait and retry...\n");
		PROV_SYSTEM("%s Step_6_1_failed Initialize the parameter failed, maybe couldn\\'t get the parameter, please wait and retry... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);

		return ERROR_MSG_CHECK;
	}
	DEBUG_PRINT("Initiailize Success...\n");
	*ipPeriodIntervalTime = sProv_Information.iPeriodicInterval;

	PROV_SYSTEM("%s Step_6_2 now open file name: %s... >> %s", ECHO_CMD, sProv_Information.caFile_Sys_Name, DEBUG_SAVE_DIR);
	sprintf(caTmp, "%s%s", DEFAUTL_TMP_DIR, update_cfg_file_name_into_simple(sProv_Information.caFile_Sys_Name));
	DEBUG_PRINT("The open file name: %s\n\n", caTmp);
	fpCFG = fopen(caTmp, "w+");
	fclose(fpCFG);

	PROV_SYSTEM("%s Step_6_3 The open file name: %s OK... >> %s", ECHO_CMD, caTmp, DEBUG_SAVE_DIR);

	/* Get file by cRet type way to get the file.... */
	iRet = set_flag_with_upgrade_method(cRet, &sProv_Information.ucProv_Methods);
	if(iRet != MSG_OK)
	{
		PROV_SYSTEM("%s Step_6_4 Couldn\\'t get the type of upgrade way... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
//		free(sProv_Information.cpBuffer);
		return iRet;
	}

	/* Backup the Org file (if not, copy mtdblock5) to old file, then delete Org file. */
	// Don't copy file to store_ng[mac].cfg...
	move_nvram5_file_to_store_name(sProv_Information.caFile_Sys_Name);

	if(get_internet_file(&sProv_Information) != MSG_OK)
	{
		//debug_system_cmd("echo ERROR_MSG_GET_INTERNET_FILE >> /tmp/debugaa");
		ERROR_PRINT("Error to get internet file by tftp...\n");
		PROV_SYSTEM("%s Step_6_5 Error to get internet file by tftp... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		return ERROR_MSG_GET_INTERNET_FILE;
	}

	if(process_local_file(&sProv_Information) != MSG_OK)	/* MSG_OK = 0 */
	{
		/* If process file return not ok, then malloc the memory Unsuccess...
			and don't need to free the buffer... */
		//debug_system_cmd("echo ERROR_MSG_UPDATE_TFTP >> /tmp/debugaa");
		PROV_SYSTEM("%s Step_6_6 ERROR_MSG_UPDATE_TFTP\\(process_local_file\\) >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		ERROR_PRINT("No file to open...\n");
		DEBUG_SIMPLE_MSG("No file to get from internet by tftp...\n");
		if(sProv_Information.cpBuffer)
			free(sProv_Information.cpBuffer);
		return ERROR_MSG_UPDATE_TFTP;
	}

	/* If process file ok, then would malloc the memory success... */
	/* Check the file size between old and new cfg file, that's to decide to get the new cfg file... */
	if(cfg_file_decrypt_rc4(sProv_Information.cpBuffer, sProv_Information.ulBufferLen, sProv_Information.caRC4_Key) != MSG_OK)
	{
		ERROR_PRINT("Error Decrypt RC4 Value...\n");
		//debug_system_cmd("echo ERROR_RC4_DECRYPT_PARA >> /tmp/debugaa");
		PROV_SYSTEM("%s Step_6_7 ERROR_RC4_DECRYPT_PARA RC4 decrypt >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		if(sProv_Information.cpBuffer)
			free(sProv_Information.cpBuffer);

		return ERROR_RC4_DECRYPT_PARA;
	}

	/* The lastest char must set to '\0' */
	sProv_Information.cpBuffer[sProv_Information.ulBufferLen] = '\0';
	DEBUG_SIMPLE_MSG("Decrypt RC4 file ok...\n");

	/* Here, the name was org-name from initialized parameters...
		it's removed the enc file and org-store name... */
	remove_tmp_enc_file(sProv_Information.caFile_Sys_Name);

	if(check_file_need_update_to_mtdblock5(&sProv_Information) == MSG_OK)
	{
		/* Need to upgrade cfg file into struct of sProv_Infomation... */
		update_cfg_setting_2_sProv(&sProv_Information);

		/* Get the decrytion file, and check the first byte to identify the update CFG or FW file.
			Pid's check must disign for cfg file or fw file. */
		/* Copy from voip/main.c: hook_wait().... */
		PROV_SYSTEM("%s Step_6_8 Update para. into structure... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		DEBUG_PRINT("Update Server IP Address: %s\n\n", sProv_Information.caServerIP);
		save_all_data(&sProv_Information);

		iCfgNonRebootFlag = check_cfg_file_need_to_reboot_modem(sProv_Information.cpBuffer);

		if(iCfgNonRebootFlag == MSG_OK)
		{
			PROV_SYSTEM("%s Step_6_8a reboot after update cfg file into mtdblock 5... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
			//system("reboot");
			prov_led_blink("r");
		}
		PROV_SYSTEM("%s Step_6_8b Non_reboot after update cfg file into mtdblock 5... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	}
//#ifdef PDEBUG
	sleep(10);
//#endif
	/* Here, the caFile_Sys_Name is the updated name after update new name from cfg file...
		Only remove the store_filename from /tmp... */
	remove_tmp_store_file(sProv_Information.caFile_Sys_Name);

	/* Check Pid, ServIP/Name, get new file by the same way, like tftp ...
		must get the FW name from cfg file...
		check_fw_file_checksum(&sProv_Information);
		sProv_Information.cState = STATE_UPDATE_FW; */

	if((check_fw_version_the_same(sProv_Information.caFWFileName) == MSG_OK) || is_string_all_space(sProv_Information.caFWFileName) == MSG_OK)	//[0] == '\0'))
	{
		/* Finish to update the newest FW... */
		*ipPeriodIntervalTime &= 0;
		*ipPeriodIntervalTime = sProv_Information.iPeriodicInterval;
		if(sProv_Information.cpBuffer)
			free(sProv_Information.cpBuffer);
		PROV_SYSTEM("%s Step_6_9 FW_same_not_need_update... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		DEBUG_SIMPLE_MSG("Update provisioning behavior OK (without update FW file),\n\t	\
					and wait next time to update...\n");
		return MSG_OK;
	}

	/* Call the update process and send a message to it. */
	if(process_fw_file_update(&sProv_Information) != MSG_OK)	/* MSG_OK = 0 */
	{
		PROV_SYSTEM("%s Step_6_c FW udpate failed to, wait backoff time... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		if(sProv_Information.cpBuffer)
			free(sProv_Information.cpBuffer);
		return ERROR_MSG_FW_FILE_UPDATE;
	}
	DEBUG_SIMPLE_MSG("Update FW file OK...\n");
	DEBUG_PRINT("FW update...\n\tOK...\n");
	//system("reboot");
	prov_led_blink("r");
	if(sProv_Information.cpBuffer)
		free(sProv_Information.cpBuffer);
	return MSG_OK;	/* OK, then return 0. */
}

int set_flag_with_upgrade_method(char cRet, unsigned char *ucpProv_Methods)
{
	switch(cRet)
	{
		case 'h':
			/* HTTP mode: ... */
			*ucpProv_Methods= PROV_USE_HTTP;
			DEBUG_PRINT("HTTP mode.....\n");
			return ERROR_MSG_PROV_METHOD;
			break;
		case 's':
			/* HTTPs mode: ... */
			*ucpProv_Methods = PROV_USE_HTTPS;
			DEBUG_PRINT("HTTPs mode.....\n");
			return ERROR_MSG_PROV_METHOD;
			break;
		case 'l':
			/* PSTN_Relay: ... */
			*ucpProv_Methods = PROV_USE_FTP; // ??
			DEBUG_PRINT("PSTN Relay mode.....\n");
			return ERROR_MSG_PROV_METHOD;
			break;
		case 't':
			/* TFTP mode: ...*/
			*ucpProv_Methods = PROV_USE_TFTP;
			return MSG_OK;
			break;
		case 'v':
			{
				char caProvVer[25] = "";

				get_modem_now_prov_cfg_version(caProvVer);
				printf("Provisioning CFG File Version: %s\n", caProvVer);
				return CHECK_CFG_VERSION;
			}
			break;
		case 'r':
			printf("Provisioning Update Version: %s\n", PROVISION_VERSION);
			return CHECK_PROV_VERSION;
			break;
		case 'm':
			{
				char caBuf[1024] = "";
				if(get_rt_now_datetime(caBuf) != MSG_OK)
					printf("Couldn't get the time...\n");
				DEBUG_PRINT("The actual time:\n\t%s\n", caBuf);
				return CHECK_PROV_VERSION;
			}
			break;
		default:
			ERROR_PRINT("No suitable way to update file into Modem...\n");
			return ERROR_MSG_PROV_METHOD;
			break;
	}
}

int check_file_need_update_to_mtdblock5(struct sPROV_INFORMATION *spProv_Info)
{
	if(check_file_size_diff(spProv_Info->caFile_Sys_Name, spProv_Info->cpBuffer) != MSG_OK)	/* MSG_OK = 0 */
	{
		DEBUG_PRINT("check_file_size the same: Non-need to update the file into flash...\n");
		DEBUG_SIMPLE_MSG("No need to update the file, ...\n\tGet the same file and don't need to update...\n");
		return GET_THE_SAME_FILE_NO_UPDATE;
	}
	PROV_SYSTEM("%s Step_6_7_1 check_file_size_diff ok, next step... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);

	/* Check modem Mac vs. CFG file MAC... */
	if (check_cfg_file_mac(spProv_Info) != MSG_OK)
	{
		PROV_SYSTEM("%s Step_6_7_2 MAC fail, don\\'t need to update... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		DEBUG_SIMPLE_MSG("MAC fail, don't need to update...\n");
		ERROR_PRINT("\tMAC check failed for cfg file.\n");	//goto FREE_PROV_CFG_BUFF;
		//free(spProv_Info.cpBuffer);
		return ERROR_MSG_CFG_PID_CHECK;
	}
	PROV_SYSTEM("%s Step_6_7_3 check_cfg_file_mac ok, next step... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	
	/* Here check the pid for cfg file... */
	if (check_cfg_file_pid(spProv_Info) != MSG_OK)
	{
		PROV_SYSTEM("%s Step_6_7_4 ERROR_MSG_CFG_PID_CHECK >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
		DEBUG_SIMPLE_MSG("PID fail, don't need to update...\n");
		ERROR_PRINT("\tPid check failed for cfg file.\n");	//goto FREE_PROV_CFG_BUFF;
		//free(sProv_Information.cpBuffer);
		return ERROR_MSG_CFG_PID_CHECK;
	}
#ifdef DEBUG_PRINT_DATA_BY_HEX
	DEBUG_PRINT("Output data:\n");
	for(iTmp = 0; iTmp < spProv_Info->ulBufferLen; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", spProv_Info->cpBuffer[iTmp]);
		if((iTmp + 1) %10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif
	PROV_SYSTEM("%s Step_6_7_5 CFG need to update into flash... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);

	return MSG_OK;
}

void save_all_data(struct sPROV_INFORMATION *spProv)
{
	// first save to router cfg(NVRAM...) it's need?
	save_cfg_2_nvram_set(spProv);
	PROV_SYSTEM("%s CFG_File Version:%s... >> %s", ECHO_CMD, spProv->caProvCFGVer,  DEBUG_SAVE_DIR);
	DEBUG_PRINT("Save cfg to router was OKKKKK...\n");
	save_prov_voip_para_2_NVRAM(spProv->cpBuffer);
	DEBUG_PRINT("Save prov voip para to NVRAM was OKKKKK...\n");

	DEBUG_PRINT("CFG update...\n");
	save_struct_data_2_tmp_file(spProv);
	PROV_SYSTEM("%s save_struct_data_2_tmp_file success... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	// save file to /etc/provisioning...
	save_para_2_file(spProv);
	PROV_SYSTEM("%s save_para_2_file success... >> %s", ECHO_CMD, DEBUG_SAVE_DIR);
	/* Check the save file is OK or not? */
	//read_file_from_save_data(&sProv_Information);
	/* Copy from voip/main.c: hook_wait().... */
	prov_hook_wait(3);
	// save file into /dev/mtdblock/5...
	save_file_to_nvram_mtdb5(spProv);
	DEBUG_PRINT("CFG update to NVRAM_5 update...\n");
	DEBUG_SIMPLE_MSG("Update voip cfg file to mtd block 5...\n");
}

int cfg_file_decrypt_rc4(unsigned char *cpLocalFileData, unsigned long ulDataLength, char *cpDefaultKey)
{
	int retval = 0, enc_type = 0;
	unsigned char ucaKeys[KEY_MAX_LEN+2] = "";
#ifdef DEBUG_PRINT_DATA_BY_HEX
	int iTmp;
#endif
	DEBUG_PRINT("cfg_file_decrypt_rc4:\n\tGet data:\n");
#ifdef DEBUG_PRINT_DATA_BY_HEX
	for(iTmp = 0; iTmp < (int)ulDataLength; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", cpLocalFileData[iTmp]);
		if((iTmp + 1) %10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#else
	DEBUG_PRINT("\t\t.........\n");
#endif
	//	Get the key from file or default...... and enc_type...(use default)
	get_ucaKey_from_setting_or_default(ucaKeys, cpDefaultKey);

	DEBUG_PRINT("\tGet Key ok...\n");

#ifdef DEBUG_PRINT_DATA_BY_HEX
	DEBUG_PRINT("\t\tGet ucaKeys result:\n");
	for(iTmp = 0; iTmp < (int)KEY_MAX_LEN/2; iTmp ++)
	{
		DEBUG_PRINT("0x%02hhx ", ucaKeys[iTmp]);
		if((iTmp + 1) %10 == 0)
			DEBUG_PRINT("\n");
	}
	DEBUG_PRINT("\n");
#endif
	retval = decrypt_file(cpLocalFileData, ulDataLength, enc_type, ucaKeys, KEY_MAX_LEN/2);

	if (retval ==ERROR_RC4_DECRYPT_PARA)
	{
		DEBUG_PRINT("\n Decrypt file error for cfg file.\n");
		//goto FREE_PROV_CFG_BUFF;
		return ERROR_RC4_DECRYPT_PARA;
	}

	return MSG_OK; /* MSG_OK = 0 */
}

void get_pid_from_kernel_mtdblock_1(void)
{
	FILE *fpPid;
	int iCount = 0;
	char caModemPid[128] = "";

	fpPid = fopen(DEFAULT_PID_IN_KERNEL,"r");
	if(fpPid == NULL)
	{
		strcpy(caDefaultPID, TXT_SIC);
		return;
	}
	fread(caModemPid, 1, 128, fpPid);
	fclose(fpPid);

	while(1)
	{
		if(caModemPid[iCount + DEFAULT_PID_OFFSET] == '\0')
			break;
//		if(caModemPid[iCount + DEFAULT_PID_OFFSET] == '\ff')
//			break;
		if(caModemPid[iCount + DEFAULT_PID_OFFSET] == '\n')
			break;

		caDefaultPID[iCount] = caModemPid[iCount + DEFAULT_PID_OFFSET];
		iCount ++;
	}
	caDefaultPID[iCount] = '\0';
	DEBUG_PRINT("\tGet PID in kernel file: %s\n", caDefaultPID);

	DEBUG_PRINT("\t\tPID get PID from kernel:\n\t\t\t%s\nThe Data...\n", caDefaultPID);
#ifdef PDEBUG_RD
	for(iCount = 0; iCount < DEFAULT_PID_LENGTH; iCount ++)
	{
		DEBUG_PRINT("%02hhx ", caModemPid[iCount]);
		if(((iCount +1) % 10) == 0)
			DEBUG_PRINT("\n");
	}
#endif
	DEBUG_PRINT("\nEnd of Get PID from Kernel(mtdblock/0)\n");
}

void get_modem_now_prov_cfg_version(char *cpProvVer)
{
	char caData[MAX_CFG_FILE_SIZE] = "";

	open_mtdblock5_file_to_get_data(caData);
	if(strlen(caData) == 0)
	{
		DEBUG_PRINT("The Prov. Cfg. Version: Couldn't find version in file...\n");
		strcpy(cpProvVer, "Data Empty");
		return;	// "Data Empty...";
	}

	get_cfg_file_version(caData, cpProvVer);
	DEBUG_PRINT("The Prov. Cfg. Version: %s\n", cpProvVer);
}
