#define DEBUG_SAVE_DIR	"/tmp/debugaa"
#define PROVISION_VERSION	"1.20"
/* What's way to update the file by provision? */
#define PROV_USE_TFTP		0x01
#define PROV_USE_HTTP		0x02
#define PROV_USE_HTTPS		0x04
#define PROV_USE_FTP		0x08

/*	Set the update file is cfg_file or fw_file.*/
#define STATE_UPDATE_CFG		0x01
#define STATE_UPDATE_FW		0x02

//	The update process has three modes to CHECK the update file ok or not.
#define CHECK_PID			0x01
#define CHECK_USER_PWD	0x02
#define CHECK_CHECKSUM	0x03
#define CHECK_FILE_SAME	0x04

/* User has the option to select update or not. */
#define USER_NO_SELECT_UPDATE_KEY	0x00
#define USER_SELECT_UPDATE_KEY		0x01

/* Provision TFTP Default parameter. */
#define TFTP_PROVISIONING_GET_FILE_NAME		"ngmac.cfg"
#define TFTP_PROVISIONING_SERVER_IP_ADDR	"192.168.0.113"
#define TFTP_PROVISIONING_BLOCK_SIZE			512 /* According to RFC1350, don't change */
#define TFTP_PROVISIONING_TIME_OUT			5 /* Seconds */
#define DEFAULT_TEST_RC4_KEY		"0000000000000000000000000000000000000000000000000000000000000000"
//#define DEFAULT_TEST_RC4_KEY	"e15e7122cd7745661d18930aa21d9602c0849d85e29e3af1d4e146f57738ec75"
								/* 64bytes, transfer from mac by MT */

/* Default Setting Parameters... */
/*	##PID:DG834GV
	##Firmware Version:A0.01.18
	##Tftp Port:69
	##Tftp Domain:172.31.2.51
	##Rc4 Key:3131
	##Periodic Interval:1440
	##CFG File Name:ng00c002f9ffe0.cfg	*/
#define CHECK_PID_STRING			"##PID:"
#define CHECK_FW_VERSION_STR			"##Firmware Version:"
#define CHECK_TFTP_DOMAIN_STR			"##Tftp Domain:"
#define CHECK_TFTP_DEFAULT_PORT_NUM_STR		"##Tftp Default Port:"
#define CHECK_TFTP_PRIMARY_PORT_NUM_STR		"##Tftp Primary Port:"
#define CHECK_TFTP_SECONDARY_PORT_NUM_STR	"##Tftp Secondary Port:"

#define CHECK_RC4_KEY_VALUE_STR			"##Rc4 Key:"
#define CHECK_RELOAD_PERIOD_STR			"##Periodic Interval:"
#define CHECK_SET_CFG_FILE_NAME			"##CFG File Name:"
#define CHECK_FW_UPDATE_FILE_NAME		"##FW File Name:"
#define CHECK_CFG_FILE_VERSION			"##PROV CFG Version:"
#define CHECK_CFG_FILE_MAC			"##MAC:"
/* NVRAM string for get/set */
#define NVRAM_TFTP_DOMAIN_STR			"prov_tftp_domain"
#define NVRAM_TFTP_DEFAULT_PORT_NUM_STR		"prov_tftp_default_port"
#define NVRAM_TFTP_PRIMARY_PORT_NUM_STR		"prov_tftp_primary_port"
#define NVRAM_TFTP_SECONDARY_PORT_NUM_STR	"prov_tftp_secondary_port"
#define NVRAM_RC4_KEY_STR			"prov_rc_key"
#define NVRAM_RELOAD_PERIOD_STR			"prov_period_inteval"
#define NVRAM_CFG_FILE_VERSION			"prov_cfg_fileversion"
#define NVRAM_CFG_FILE_NAME			"prov_cfg_filename"
#define NVRAM_FW_UPDATE_FILE_NAME		"prov_fw_filename"
#define NVRAM_PROV_LAST_UPDATE_TIME		"prov_last_update_time"
#define NVRAM_PROV_LAST_ATTEMPT_TIME		"prov_last_attempt_time"
#define NVRAM_PROV_ACTIVE_STATUS		"prov_active_status"
#define NVRAM_PROV_SET					"nvram set"
/* Default for ENV setting... */
#define ENV_DEFAULT_RC4_KEY		"RC4_KEY"
#define ENV_DEFAULT_TFTP_SERVER_IP	"TFTP_SERVER_IP"
/* Default value to set.... */
#define DEFAULT_TFTP_PORT_NUMBER		(69)
#define DEFAULT_PRIMARY_TFTP_PORT_NUMBER	(2400)
#define DEFAULT_RELOAD_PERIOD_TIME		(5)
#define DOMAIN_MAX_LEN				(150)
#define REQ_FILE_MAX_LEN			(150)
#define FILENAME_MAX_LEN			(150)
#define KEY_MAX_LEN				(64)
#define MAC_LENGTH				(12)
#define SYSTEM_CMD_INTERVAL_TIME		(1)
#define MAX_CMD_USE_LENGTH			(1024)
#define RETRY_ITEM_TIME				(3)
#define VERSION_LENGTH				(25)
#define MAX_CFG_FILE_SIZE			(4096)
#define DEFAULT_PID_OFFSET			(11)
#define DEFAULT_PID_LENGTH			(32)
#define FW_FILE_PID_OFFSET			(10000)

/* Default Path and file name to reference.... */
#define DEFAULT_CONFIG_FILE_PATH	"/etc/prov_setting"
#define STORE_RC4_KEY_FILE_NAME		"store_rc4key.key"
#define DEFAUTL_TMP_DIR			"/tmp/"
#define TXT_SIC				"DG834GV"
#define DEFAULT_PID_IN_KERNEL		"/dev/mtdblock/1"
#define OLD_FILE_NAME_HEAD		"old_"
#define STORE_FILE_NAME_HEAD		"store_"
#define REBOOT_CMD_IN_CFG_FILE		"reboot"
#define SAVE_VOIP_CFG_TO_FLASH		"/dev/mtdblock/5"
#define SAVE_MTD_2_TEMP_NAME		"/tmp/tmpcfg.cfg"

#define DEFAULT_FW_NAME			"DG834GV_V0.01.01.img"	//"fw.img"
#define UPGRADING			"/tmp/upgrading"
#define MXP_STOP			"/tmp/mxp_stop"
#define DEFAULT_VOIP_CFG_NAME		"/tmp/default.cfg"
#define VERSION_CHECK_FILE_NAME		"/etc/version"
#define TMP_TICFG_ENV			"/tmp/ticfgenv"
#define TMP_VOIP_PARA_SAVE_FILE		"/tmp/prov_voip.debug"
#define ECHO_CMD		"/bin/echo"
/* CFG update or FW update */
enum
{
	CFG_UPDATE_FLAG = 0,
	FW_UPDATE_FLAG = 1
};

/* Check the update file is new or not... */
enum
{
	GET_FILE_NO_CHANGE = 0,
	GET_FILE_NEW = 1
};

#ifndef TRUE
#define TRUE 0x01
#endif
#ifndef FALSE
#define FALSE 0x00
#endif

//#define PDEBUG
//#define ALL_DEBUG
/* Debug message. */
#ifdef PDEBUG
#define DEBUG_PRINT			printf
#define ERROR_PRINT			printf
#define DEBUG_SYSTEM			system
#define DEBUG_SIMPLE_MSG		printf
	#ifdef ALL_DEBUG
#define PDEBUG_RD
#define DEBUG_PRINT_DATA_BY_HEX
	#endif
#else
#define DEBUG_PRINT(...)	
#define ERROR_PRINT(...)	
#define DEBUG_SYSTEM(...)
#define DEBUG_SIMPLE_MSG(...)
#endif

/* Format of Provision Information. */
struct sPROV_INFORMATION
{
	int iTftpDefaultPortNum;
	int iTftpPrimaryPortNum;
	int iTftpSecondaryPortNum;
	int iPeriodicInterval;
	unsigned long ulBufferLen; /*To store returned buff len*/
	unsigned char *cpBuffer; /*To store return buff pointer*/
	unsigned char ucProv_Methods;
	unsigned short usProv_Port;
	char cState;
	char cErr_Code;
	char caProvCFGVer[VERSION_LENGTH];
	char caServerIP[DOMAIN_MAX_LEN];
	char caFile_Sys_Name[FILENAME_MAX_LEN];
	char caFWFileName[FILENAME_MAX_LEN];
	char caRC4_Key[KEY_MAX_LEN];
};

enum
{
    CFG_FILE =0,
    FW_FILE,
    FILE_NUMS
};

enum
{
	ENC_RC4,
	ENC_NULL
};

int prov_timestamp = 0;
char caDefaultPID[32] = "";

/* Start... function pre-define in here... */
int provision_process(char, int *);
int cfg_file_decrypt_rc4(unsigned char *, unsigned long, char *);
void save_all_data(struct sPROV_INFORMATION *);
void get_modem_now_prov_cfg_version(char *);
void get_pid_from_kernel_mtdblock_1(void);
int set_flag_with_upgrade_method(char , unsigned char *);
int check_file_need_update_to_mtdblock5(struct sPROV_INFORMATION *);
int debug_system_cmd(const char *format, ...);
int check_file_size_diff(char *, char *);

/* End... function pre-define in here... */

