/**
*rc4 code
**/
#include "rc4.h"

void prepare_key(unsigned char *key_data_ptr, int key_data_len, rc4_key *key)
{
  unsigned char t;
  unsigned char index1;
  unsigned char index2;
  unsigned char* state;
  short counter;

  state = &key->state[0];
  for(counter = 0; counter < 256; counter++)
    state[counter] = (unsigned char) counter;
  key->x = 0;
  key->y = 0;
  index1 = 0;
  index2 = 0;
  for(counter = 0; counter < 256; counter++)  {
    index2 = (key_data_ptr[index1] + state[counter] + index2) % 256;
    swap_byte(&state[counter], &state[index2]);
    index1 = (index1 + 1) % key_data_len;
  }
  return;
}

void rc4(unsigned char *buffer_ptr, unsigned long buffer_len, rc4_key *key)
{
  unsigned char t;
  unsigned char x;
  unsigned char y;
  unsigned char* state;
  unsigned char xorIndex;
  unsigned long counter;

  x = key->x;
  y = key->y;
  state = &key->state[0];
  for(counter = 0; counter < buffer_len; counter++)
  {
    x = (x + 1) % 256;
    y = (state[x] + y) % 256;
    swap_byte(&state[x], &state[y]);
    xorIndex = (state[x] + state[y]) % 256;
    buffer_ptr[counter] ^= state[xorIndex];
  }
  key->x = x;
  key->y = y;
}

void rc4_256(unsigned char *buffer_ptr, unsigned long buffer_len, rc4_key *key)
{
  unsigned char t;
  unsigned char x;
  unsigned char y;
  unsigned char* state;
  unsigned char xorIndex;
  unsigned long counter;

  x = key->x;
  y = key->y;
  state = &key->state[0];

 /*  
  for(counter = 0; counter < 256; counter++)
  {
    x = (x + 1) % 256;
    y = (state[x] + y) % 256;
    swap_byte(&state[x], &state[y]);
  }
*/
 /*does we need skip the the first 256 bytes*/  
  for(counter = 0; counter < buffer_len; counter++)
  {
    x = (x + 1) % 256;
    y = (state[x] + y) % 256;
    swap_byte(&state[x], &state[y]);
    xorIndex = (state[x] + state[y]) % 256;
    buffer_ptr[counter] ^= state[xorIndex];
  }
  key->x = x;
  key->y = y;
}

//#include "sntenv.h"

//char keybuf[64+8 /*KEY MAX LEN*/];
//char keyiv[ENV_VAL_LEN]={"1"};
char keyiv[32]={"1"};
char keybuf[40]={"1"};
rc4_key readyKey;
//int rc4_key_type = RC4_KEY_TYPE_HEX;
void rc4_decncrypt(char *data, unsigned long len)
{

/*    
*   snt_get_env(keyiv, RC4_KEY);     //cut this line from get key materials, we need init it at the tftp start-point
*/
	memcpy(keybuf, keyiv, 32);
	prepare_key(keybuf,32,&readyKey);
	rc4_256(data,len,&readyKey);
}
/**
**RC4 Code END
**/

/*For Integrated Provision*/
void rc4_decrypt(char *buff, unsigned int bufflen, char * keybuff, unsigned int keylen)
{
	memcpy(keybuf, keybuff, keylen);
	prepare_key(keybuf, keylen, &readyKey);
	rc4_256(buff,bufflen,&readyKey);
}


/*char * get_zero_rc4key()
{
    memset(keyiv, 0, sizeof(keyiv));
    return keyiv;
}*/
