/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#define FILESYSTEM	"/dev/mtdblock/0"
#define KERNEL		"/dev/mtdblock/1"
#define LOADER	 	"/dev/mtdblock/2"

#define PID_SIZE	70
#define HWID_OFFSET	-67


#define LOADER_SIZE	(64<<10)
#define KERNEL_SIZE	(640<<10)	
#define FS_SIZE		(3200<<10) - PID_SIZE - 8 
#define ADAM2_SIZE	(40<<10)
#define DOWNLOAD_SIZE	(24<<10)
#define KERNEL_OFFSET   128
#define USER_DEFINE	KERNEL_OFFSET - PID_SIZE

typedef struct{
	u_int8_t	magic_s[7];	/* sErCoMm */
	u_int8_t	ver_control[2];	/* version control */
	u_int8_t	download[2];	/* download control */
	u_int8_t	hw_id[32];  	/* H/W ID */ 
	u_int8_t	hw_ver[2];  	/* H/W version */
	u_int8_t	p_id[4];    	/* Product ID */
	u_int8_t	protocol_id[2];	/* Protocol ID */	
	u_int8_t	fun_id[6];	/* Function ID */
	u_int8_t	fw_ver[2];	/* F/W version */
	u_int8_t	start[2];	/* Starting code segment */
	u_int8_t	c_size[2];	/* Code size (kbytes) */
	u_int8_t	magic_e[7];	/* sErCoMm */
}sercomm_pid_t;

typedef struct{
	u_int8_t	loader[LOADER_SIZE];
	sercomm_pid_t	pid;
	u_int8_t	user_define[USER_DEFINE];
	u_int8_t	kernel[KERNEL_SIZE-KERNEL_OFFSET];
	u_int8_t	filesystem[FS_SIZE];
}image_t;

typedef struct{
	u_int16_t       checksum;
	u_int32_t	fw_len;
}user_def_t;
