#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "upgrade_flash.h"
unsigned short cal_checksum(FILE *fp,int size) {

	unsigned short checksum = 0;
	int i=0;
	
	while(i++<size)
		checksum+=(unsigned short)fgetc(fp);
	printf("checksum == %d\n",checksum);	
	return checksum;
}

int check_fw_file(char *filename)
{
	FILE *fp;
	long file_len=0;
	sercomm_pid_t mypid,opid;
	user_def_t   mydef;
	unsigned short checksum = 0;
	
	/* Get original PID */
	fp=fopen(KERNEL,"r");
	if(fp==NULL)
		return -1;
	
	fread(&opid,sizeof(opid),1,fp);
	fclose(fp);
	
	fp=fopen(filename,"r");
	
	if(fp==NULL)
		return -1;
	fseek(fp,0,SEEK_END);
	file_len=ftell(fp);
	if(file_len < (LOADER_SIZE + KERNEL_SIZE)){
		fclose(fp);
		return -1;
	}
	fseek(fp,LOADER_SIZE,0);
	fread(&mypid,sizeof(mypid),1,fp);
	fread(&mydef,sizeof(mydef),1,fp);
	printf("%s %s %ld %d %d\n",mypid.hw_id,opid.hw_id,file_len,mydef.fw_len,mydef.checksum);
	/* check length */
	if(file_len!=(mydef.fw_len+LOADER_SIZE)){
		fclose(fp);
		return -1;
	}
	/* check pid */
	if(memcmp(mypid.hw_id,opid.hw_id,32)!=0){
		fclose(fp);
		return -1;
	}
	
	/* check checksum */
	fseek(fp,LOADER_SIZE,0);
	checksum = cal_checksum(fp,PID_SIZE);
	
	fseek(fp,(LOADER_SIZE+KERNEL_OFFSET),0);
	checksum += cal_checksum(fp,mydef.fw_len-KERNEL_OFFSET);
	
	if(checksum !=mydef.checksum){
		printf("checksum error!\n");
		fclose(fp);
		return -1;
	}

	fclose(fp);
	
	
        return 0;	
}

int voip_fw_update(char *filename)
{
	FILE *fp,*fo;
	char buf[8192];
	long file_len=0;
	long offset=0;
	fp=fopen(filename,"r");
	
	if(fp==NULL)
		return -1;
	fseek(fp,0,SEEK_END);
	file_len=ftell(fp);
	/* shift to kernel start */
	fseek(fp,LOADER_SIZE,0);
	fo=fopen(KERNEL,"w");
	if(fo==NULL){
		system("/usr/bin/reboot");
	}
	while(offset < KERNEL_SIZE){
		fseek(fp,LOADER_SIZE+offset,0);
		fseek(fo,offset,0);
		offset+=fread(buf,1,8192,fp);
		fwrite(buf,8192,1,fo);
	}
	fclose(fo);
	fo=fopen(FILESYSTEM,"w");
	if(fo==NULL){
		system("/usr/bin/reboot");
	}
	offset=0;
	while(offset < (file_len-KERNEL_SIZE-LOADER_SIZE)){
		fseek(fp,LOADER_SIZE+KERNEL_SIZE+offset,0);
		fseek(fo,offset,0);
		offset+=fread(buf,1,8192,fp);
		fwrite(buf,8192,1,fo);
	}
	fclose(fp);
	fclose(fo);
	return 0;
}
