#ifndef _SNMP_LIB_
#define _SNMP_LIB_

#include "snmp_lib.h"
#include "include/snmp_asn1.h"
#include "include/snmp.h"

#define SNMP_MIB2_MGMT     4
#define SNMP_MIB2_GROUP    6
#define SNMP_MIB2_LEAF     7
#define SNMP_MIB2_TABLE    7
#define SNMP_MIB2_TBLENTRY 8
#define SNMP_MIB2_TBLOBJ   9
#define SNMP_MIB2_INDEX   10

#define ASN_STR ASN_OCTET_STR
#define ASN_OID ASN_OBJECT_ID
#define ASN_INT ASN_INTEGER
#define ASN_TIME ASN_TIMETICKS
#define ASN_CNT ASN_COUNTER
#define ASN_IP ASN_IPADDRESS
#define ASN_PHY ASN_PHYSADDR



typedef struct {
	netsnmp_variable_list	*pVarBind;
	netsnmp_variable_list	**pBulk;
	netsnmp_variable_list	*handled_var;	/* Last varbind handled */

	long	version;	/* PDU version */
	int	command;	/* GET, GETNEXT, etc. */
	long	req_id;
	long	errstat;
	long	errindex;
	int	vbcount;	/* Varbind count */
	int	handled_index;	/* Index of last handled varbind. Used for errors */

	/* Community info */
	char	*community;	/* SET_TEXT set */

	/* This is a pointer to the ip address where this pdu is from. It
	   is actually pointing to a struct on the stack in the main function.
	 */
	struct sockaddr_in	*from;
}snmp_pdu;

typedef int (*Func)(snmp_pdu *pdu,netsnmp_variable_list *vp, int item);


typedef struct {
	oid	name[14];
    	u_char	nameLen;
	u_char	type;
	Func	getfun;
//	Func	setfun;  //future
} map_entry_t;

int init_snmp(char *ipaddr);
int process_snmpPDU(char *rcvBuffer,int recvlen, struct sockaddr_in *from);
int snmp_oid_cmp(oid *in_name1, oid *in_name2, int len1, int len2);

#endif
