#include <sys/types.h>

#include "include/snmp_asn1.h"
#include "include/snmp.h"
#include "my_snmp_lib.h"

#include "mib2.h"
#include "private.h"



oid mib2Oid[] = {1, 3, 6, 1, 2, 1};
oid privateOid[] = {1, 3, 6, 1, 4, 1, 4526};


int get_map_entry(snmp_pdu *pdu,netsnmp_variable_list *vp)
{
	int ret=0;
#if 0
	 // validate the mib2 OID
	if (pdu->command != SNMP_MSG_GETNEXT){
	        if ((strncmp((char *)vp->name, (char *)mib2Oid,sizeof(oid)*6)) ||(vp->name_length < SNMPL_MIB2_TBLENTRY)){
		        return -1;
	        }
    	}
	if (pdu->command == SNMP_MSG_GET){
            if (vp->name[vp->name_length-1] == 0)
                vp->name_length -= 1;
        }
#endif
	
	/* add for oid < 6 */	
	if(vp->name_length <= 6 && pdu->command == SNMP_MSG_GETNEXT ){
		if(vp->name_length >= 5 && (vp->name[4] == 4)){
			memcpy(vp->name,privateOid,7*sizeof(oid));	
			vp->name_length=7;
		}else{
			memcpy(vp->name,mib2Oid,6*sizeof(oid));	
			vp->name_length=6;
		}
	}
#if 0	
	if(memcmp(mib2Oid,vp->name,6*sizeof(oid))==0){
		ret=get_mib2_entry(pdu,vp);
		
		if(ret==-1 && pdu->command == SNMP_MSG_GETNEXT){
			memcpy(vp->name,privateOid,7*sizeof(oid));	
			vp->name_length=7;
			ret=get_private_entry(pdu,vp);
		}
			
	}else if(memcmp(privateOid,vp->name,7*sizeof(oid))==0){
		ret=get_private_entry(pdu,vp);
	}else 
		ret=-1;
#else
	if(memcmp(mib2Oid,vp->name,6*sizeof(oid))==0){
		ret=get_mib2_entry(pdu,vp);
	}else
		ret=-1;
#endif
	
	/* process various type */	
	switch(vp->type){
		case ASN_STR:
			vp->val.string=vp->buf;
		        vp->val_len = strlen(vp->buf);
			break;
		case ASN_OID:
			vp->val.objid = (oid *)(vp->buf);
			break;
		case ASN_TIME:
		case ASN_INT:
        	case ASN_GAUGE:
		case ASN_CNT:
            	case ASN_IP:
			vp->val.integer = (long *)(vp->buf);
		        vp->val_len = sizeof(u_long);
			break;
		case ASN_PHY:
			vp->type=ASN_STR;
			vp->val.string=vp->buf;
			break;
	}
	return ret;

}

