#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <unistd.h>
#include <syslog.h>
#include <arpa/inet.h>
#include "my_snmp_lib.h"
#include "utility.h"
#include "snmp.h"

#define MAX_MESSAGE_LEN 4096

char *nvram_data;
char *remote_ip="127.0.0.1";
int  remote_port=0;

int main(int argc, char *argv[])
{
	char  rcvBuffer[MAX_MESSAGE_LEN];
	int server_fd_lan=-1,server_fd_wan=-1,server_fd=0;
	int retval,doLoop=1;
	fd_set rfds;
    	struct sockaddr_in  from_ip;
	socklen_t           from_len;
    	int recvlen;
	struct sockaddr_in  server_ip;
	
	daemon(1, 1);
	
	if(argv[1]==NULL || argv[2]==NULL){
		printf("\nUsage : %s lan_if wan_if\n",argv[0]);
		return -1;
	}
	
	getIfinfo(argv[1] ,(char *)&server_ip.sin_addr,IF_IPADDR);
		
	server_fd_lan=init_snmp(inet_ntoa(server_ip.sin_addr));
	
	if(server_fd_lan < 0){
		printf("Can't initial snmpd lan");
		return -1;
	}
	
	getIfinfo(argv[2] ,(char *)&server_ip.sin_addr,IF_IPADDR);
	server_fd_wan=init_snmp(inet_ntoa(server_ip.sin_addr));
	
	if(server_fd_wan < 0){
		printf("Can't initial snmpd wan");
		close(server_fd_lan);
		return -1;
	}
	
	server_fd= (server_fd_wan > server_fd_lan)?server_fd_wan:server_fd_lan;
	
	/* Watch server_fd to see when it has input. */
	
	/* monitor UDP port 161 */
	while(doLoop){
			
		FD_ZERO(&rfds);
		FD_SET(server_fd_wan, &rfds);
		FD_SET(server_fd_lan, &rfds);
		
	        retval = select(server_fd+1, &rfds, NULL, NULL, NULL);
        
		/* FD_ISSET(server_fd, &rfds) will be true. */
		if(!FD_ISSET(server_fd_lan, &rfds) 
				&& !FD_ISSET(server_fd_wan, &rfds))
			continue;
		
		if(FD_ISSET(server_fd_lan, &rfds))
   			dup2(server_fd_lan, STDIN_FILENO);
		else
   			dup2(server_fd_wan, STDIN_FILENO);
			
		from_len=sizeof(struct sockaddr_in);
		
		
		recvlen =recvfrom(STDIN_FILENO, rcvBuffer
				, MAX_MESSAGE_LEN -1
				, MSG_DONTWAIT,(struct sockaddr *)&from_ip
				, &from_len);
		if( recvlen >0)
	                rcvBuffer[recvlen]=0;
       		

		/* 
		 * Ok, we now have a complete PDU in the buffer, with 
		 * IP address info stored in the from_ip struct. Lets handle it 
		 */
		retval = process_snmpPDU(rcvBuffer,recvlen, &from_ip);
#if 0	
		if(1){
			FILE *fp;
			fp=fopen("/tmp/test","w");
			if(fp){
				fwrite(rcvBuffer,recvlen,1,fp);
				fclose(fp);
			}
		}
#endif
	}
	close(server_fd_lan);
	close(server_fd_wan);
	return 0;
}

