#include <netinet/in.h>

enum{
	IF_IPADDR=0,
	IF_MTU=1,
	IF_MAC=2,
	IF_QLEN=3,
	IF_NETMASK=4,
	IF_BRDADDR=5,

}if_type;

typedef struct {
	unsigned long in_bytes;	
	unsigned long in_packets;	
	unsigned long in_err;
	unsigned long in_drop;
	unsigned long in_mcast;
	unsigned long out_bytes;	
	unsigned long out_packets;	
	unsigned long out_err;
	unsigned long out_drop;
	unsigned long out_mcast;
} dev_info_t;

/* /dev/net/snmp */
#if 0
typedef struct {
	unsigned long Forwarding;
	unsigned long DefaultTTL;
	unsigned long InReceives;
	unsigned long InHdrErrors;
	unsigned long InAddrErrors;
	unsigned long ForwDatagrams;
	unsigned long InUnknownProtos;
	unsigned long InDiscards;
	unsigned long InDelivers;
	unsigned long OutRequests;
	unsigned long OutDiscards;
	unsigned long OutNoRoutes;
	unsigned long ReasmTimeout;
	unsigned long ReasmReqds;
	unsigned long ReasmOKs;
	unsigned long ReasmFails;
	unsigned long FragOKs;
	unsigned long FragFails;
	unsigned long FragCreates;
}snmp_ip_t;

typedef struct {
	unsigned long InMsgs;
	unsigned long InErrors;
	unsigned long InDestUnreachs;
	unsigned long InTimeExcds;
	unsigned long InParmProbs;
	unsigned long InSrcQuenchs;
	unsigned long InRedirects;
	unsigned long InEchos;
	unsigned long InEchoReps;
	unsigned long InTimestamps;
	unsigned long InTimestampReps;
	unsigned long InAddrMasks;
	unsigned long InAddrMaskReps;
	unsigned long OutMsgs;
	unsigned long OutErrors;
	unsigned long OutDestUnreachs;
	unsigned long OutTimeExcds;
	unsigned long OutParmProbs;
	unsigned long OutSrcQuenchs;
	unsigned long OutRedirects;
	unsigned long OutEchos;
	unsigned long OutEchoReps;
	unsigned long OutTimestamps;
	unsigned long OutTimestampReps;
	unsigned long OutAddrMasks;
	unsigned long OutAddrMaskReps;
}snmp_icmp_t;

typedef struct {
	unsigned long RtoAlgorithm;
	unsigned long RtoMin;
	unsigned long RtoMax;
	unsigned long MaxConn;
	unsigned long ActiveOpens;
	unsigned long PassiveOpens;
	unsigned long AttemptFails;
	unsigned long EstabResets;
	unsigned long CurrEstab;
	unsigned long InSegs;
	unsigned long OutSegs;
	unsigned long RetransSegs;
	unsigned long InErrs;
	unsigned long OutRsts;

}snmp_tcp_t;

typedef struct{
	unsigned long InDatagrams;
	unsigned long NoPorts;
	unsigned long InErrors;
	unsigned long OutDatagrams;
}snmp_udp_t;
#endif
typedef struct{
	unsigned long	ip[19];
	unsigned long	icmp[26];
	unsigned long 	tcp[14];
	unsigned long 	udp[4];
} snmp_info_t;

typedef struct route_table_s{
	char name[4];
	struct sockaddr_in dest;
	struct sockaddr_in gateway;
	struct sockaddr_in mask;
	int metric;
} route_table_t;


struct leases_t {
	unsigned char chaddr[16];
	u_int32_t yiaddr;
	u_int32_t expires;
	unsigned char hostname[16];
};

struct arp_info{
	char mac[18];
	char ipaddr[16];
	char ifname[16];
	int  type;
};

int getIfinfo(char *ifname ,char *buf,int type);
int get_dev_info(char *ifname ,dev_info_t *info);
int get_snmp_info(snmp_info_t *info);
int get_route_info(route_table_t *rt,int item);
int get_arp_info(struct arp_info *info,int item);
int convertStr2PhysAddr(char *dest, char *src);

