#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define TEST_OUTPUT "/tmp/test_output"

#define PPPOE	0
#define PPPOA	1
#define DHCP	2
#define FIX_IP	3

void write_result(char *data)
{
	FILE *fp;
	fp=fopen(TEST_OUTPUT,"a");
	if(fp){
		fprintf(fp,"%s\n",data);
		fclose(fp);
	}
#ifdef DEBUG
	printf("%s\n",data);
#endif
	
}
int check_conn(void)
{
	char *data;
	char *pt;
	char gateway[16]="";
	char tmp[128];
	
	if(myPipe("/sbin/route -n",&data)==-1)
		return 0;
	
	pt=data;
	while(*pt!='\0'){
		if(strncmp(pt,"0.0.0.0",7)==0)
			break;
		while(*pt!='\n' && *pt!='\0') pt++;
		if(*pt!='\0') pt++;
	}	

	if(*pt=='\0'){
		printf("no default gateway\n");
	}else{
		sscanf(pt,"%*s %s",gateway);
		free(data);
		sprintf(tmp,"/bin/ping -c 3 %s",gateway);
		if(myPipe(tmp,&data)==-1){
			return 0;
		}
		if(strstr(data,"icmp_seq")){
			return 1;
		}
	}
	free(data);

	return 0;

}
int wan_test_main(int argc,char **argv)
{
	FILE *fp;
	char tmp[128]="";
	int wan_mode=0;
	int i=0;
	
	if(argc < 2 ){
		printf("Usage: wan_test <wan_mode>\n");
		exit(1);
	}

	unlink("/tmp/nvram.bk");	
	if(strcasecmp(argv[1],"pppoe")==0)
		wan_mode=PPPOE;
	else if(strcasecmp(argv[1],"pppoa")==0)
		wan_mode=PPPOA;
	else if(strcasecmp(argv[1],"dhcpc")==0)
		wan_mode=DHCP;
	else
		wan_mode=FIX_IP;
		
	unlink("/tmp/pppd.fail");
	unlink(TEST_OUTPUT);	
	
	system("/usr/sbin/rc wan stop;/usr/sbin/rc wan start&");	
	/* stage 1 */
	write_result("Commencing Test ....");
	
	/* stage 2 */
	fp=fopen("/proc/avalanche/avsar_modem_training","r");
	
	if(fp==NULL){
		write_result("ADSL connection failed");
		goto fail;
	}
		
	fread(tmp,128,1,fp);
	fclose(fp);
	
	if(strstr(tmp,"SHOWTIME"))
		write_result("ADSL connection OK");
	else{ 
		write_result("ADSL connection failed");
		goto fail;
	}

	/* stage 3 */	
	while(access("/tmp/wan_uptime",F_OK)!=0 && i++<60){
			sleep(1);
	}
		
	/* stage 3 & 4 */		
	if(wan_mode == PPPOE || wan_mode == PPPOA){
		if(access("/tmp/pppd.fail",F_OK) == 0){
			if(wan_mode == PPPOE)
				write_result("PPPoE server located");
			else
				write_result("PPPoA server located");
			
			write_result("Login failed, check username and password");
			goto fail;
			
		}else if(access("/tmp/wan_uptime",F_OK)!=0){
			if(wan_mode == PPPOE)
				write_result("No PPPoE server found -- check connection method");
			else
				write_result("No PPPoA server found -- check connection method");			    
			goto fail;
		}else
			write_result("Login successful");
		
	}else if (wan_mode == DHCP){
		if(access("/tmp/wan_uptime",F_OK)!=0){
			write_result("No DHCP server found -- check connection method");
			goto fail;
		}else{
			write_result("ISP server located");
		}
	}else if (check_conn()==0)
		goto fail;
	/* stage 5 */
	write_result("Internet access OK, test completed successfully \nClick 'Close' to exit the Wizard");
	return 0;
fail:
	write_result("No Internet access, test FAILED \nCheck connections and settings");
	
	return 1;
}
