/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/*!
 *
 *   \file  wcfg_net.h
 *   \brief PURPOSE: wcfg_net.c header file
 *
 */


#ifndef __WCFGLIB_NET_H
#define __WCFGLIB_NET_H

#include "wcfglib.h"


unsigned int if_nametoindex(const char *);
int br_addif(const char *, const char *);
int br_delif(const char *, const char *);
int config_ip_settings(wcfgd *, int);
int tiap_wcfg_bridge_config(const char *devname, wcfgd *wd, int defaults);
int tiap_wcfg_bridge_add_wlan(wcfgd *wd);

int tiap_wcfg_set_route(const char *, __u32, __u32, __u32, const int);
int tiap_wcfg_get_default_gateway(__u32 *);
int tiap_wcfg_set_ipaddr_or_netmask(const char *, int, __u32);
int tiap_wcfg_get_ipaddr_or_netmask(const char *, int, __u32 *);
void tiap_wcfg_set_storage_ipaddr(wcfgd *, const int, const __u32);
int tiap_wcfg_dev_set_flags(const char *, int, int);
int tiap_wcfg_get_ipConfig( const char * devname, 
                            char * dotIpAdr, 
                            char * dotIpMask,
                            char * dotGateway
                           );


#endif
