
#ifndef HEADER_AES_LOCL_H
#define HEADER_AES_LOCL_H


#ifdef OPENSSL_NO_AES
#error AES is disabled.
#endif

#include <string.h>


typedef  unsigned int u32;
typedef  unsigned char u8;

#if defined(_MSC_VER) && !defined(_WIN32_WCE)
# define SWAP(x) (_lrotl(x, 8) & 0x00ff00ff | _lrotr(x, 8) & 0xff00ff00)
# define GETU32(p) SWAP(*((u32 *)(p)))
# define PUTU32(ct, st) { *((u32 *)(ct)) = SWAP((st)); }
#else
# define GETU32(pt) (((u32)(pt)[0] << 24) ^ ((u32)(pt)[1] << 16) ^ ((u32)(pt)[2] <<  8) ^ ((u32)(pt)[3]))
# define PUTU32(ct, st) { (ct)[0] = (u8)((st) >> 24); (ct)[1] = (u8)((st) >> 16); (ct)[2] = (u8)((st) >>  8); (ct)[3] = (u8)(st); }
#endif

/*
typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;
*/

#define MAXKC   (256/32)
#define MAXKB   (256/8)
#define MAXNR   14


#undef FULL_UNROLL

#endif /* !HEADER_AES_LOCL_H */
