/* LICENSE_CODE JUNGO */

#ifndef _RADIUSCT_H_
#define _RADIUSCT_H_


#ifdef VXWORKS
#include "pform_types.h"
#include "wlan_pal.h"
#else
#include <sys/types.h>
#include <sys/socket.h>
#endif



#define RADIUS_SECRET_LEN 64
#define RADIUS_PORT 1812

typedef struct server_list_t {
    struct server_list_t *next;
    struct in_addr ip;
    u16 port;
    u8 secret[RADIUS_SECRET_LEN]; /* RADIUS secret */
    int secret_len;
    int profile_index;
} server_list_t;

typedef struct {
    server_list_t *servers;
} radius_params_t;

typedef struct radius_client_t radius_client_t;
    
radius_client_t *radius_client_open(radius_params_t *params);

void radius_client_close(radius_client_t *client);

void server_list_free(server_list_t *server_list);

#endif
