/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:		mgmtParser.h										   */
/*		PURPOSE:	Management parser object							   */
/*																	 	   */
/***************************************************************************/

#ifndef _MGMT_SSID_HANDLE_H
#define _MGMT_SSID_HANDLE_H

#include "memMngr.h"
#include "802_11Defs.h"
#include "drvDbDefs.h"
#include "dda_wpa.h"

/**** init all ssid/vlan configuration *****/
STATUS   wdrv_mgmt_ssidInit(initConfigStruct *pInitConfigStruct);

/***********  get api **********/
STATUS   wdrv_mgmt_ssidGetSsidPrivacyIE(dot11_SSID_T *ssid,dot11_rsne_T **p_rsn,dot11_rsne_T **p_ssn);
STATUS   wdrv_mgmt_ssidGetVlanPofileIndex(int vlan,int *p_index);
STATUS   wdrv_mgmt_ssidGetSsidPofileIndex(dot11_SSID_T *ssid , int *p_index);
STATUS   wdrv_mgmt_ssidGetStationSsidIndex(UINT16 idx , int  *p_profile_idx);
STATUS   wdrv_mgmt_ssidGetBroadcastSuiteType(UINT8 *cipher,int prof_index);
STATUS   wdrv_mgmt_ssidGetStaVlanTag(char *mac ,UINT16 *vlan); 
STATUS   wdrv_mgmt_ssidGetBroadcastKey(int prof_index , wpa_temporal_key_t *p_key,int *p_key_idx);

void     wdrv_mgmt_ssidGetHiddenSsidStatus(UINT16 *value);
STATUS   wdrv_mgmt_ssidGetPrimarySsid(char *value);
void     wdrv_mgmt_ssidGetMultipleSsidStatus(UINT16 *value);
void     wdrv_mgmt_ssidGetElementFromMultipleSsidActualTable(apMultiSsidElem_t *mSsidElem, UINT16 index);
void	 wdrv_mgmt_ssidGetSsn(int profile_index,dot11_rsne_T *ssn);
void     wdrv_mgmt_ssidGetRsne(int profile_index,dot11_rsne_T *rsne);
STATUS     wdrv_mgmt_ssidGetPrimaryVlan(UINT16 *vlan);
int      wdrv_mgmt_ssidGetNumOfSsid(void);
BOOL     wdrv_mgmt_ssidIsActive(int index);


/******* set api **********/
STATUS   wdrv_mgmt_ssidSetBroadcastSuiteType(UINT8 cipher ,int prof_index);
STATUS   wdrv_mgmt_ssidSetBroadcastKey(int prof_index , wpa_temporal_key_t *p_key,int key_idx);
STATUS	 wdrv_mgmt_ssidUpdateHashTable(UINT16 idx,char *ssid, int SsidLen);
STATUS   wdrv_mgmt_ssidUpdateCapPrivBySsid(UINT16 *cap,dot11_SSID_T	*ssid);
STATUS   wdrv_mgmt_ssidUpdateCapPrivByStaIdx(UINT16 *cap,UINT16 idx);
STATUS   wdrv_mgmt_ssidUpdateCapPrivProfileIndex(UINT16 *cap,int profile_index);
void	 wdrv_mgmt_ssidSetSsn(UINT8 len, UINT8 *pInfo,int profile_index);
void	 wdrv_mgmt_ssidSetRsne(UINT8 len, UINT8 *pInfo,int profile_index);
void	 wdrv_mgmt_ssidSetPrivOpt(int profile_index ,BOOL val);
void	 wdrv_mgmt_ssidSetSecurityType(int profile_index ,wpa_sta_type_t type);
void     wdrv_mgmt_ssidGetSecurityType(int profile_index ,wpa_sta_type_t *type);
/* data path ,check performane !!!*/
STATUS   wdrv_mgmt_ssidHandleRecvTagPkt(char *pkt , int *profile);

/* check cases api */
STATUS   wdrv_mgmt_ssidIsStationNeedAuthSupprt(UINT16 index);
BOOL     wdrv_mgmt_ssidIsSSIDSupported(dot11_SSID_T	*ssid);
BOOL     wdrv_mgmt_ssidIsStationPrivOptOn(UINT16 index);
BOOL     wdrv_mgmt_ssidCapabilitiesPrivSupport(UINT16	*caps,dot11_SSID_T *ssid);
BOOL     wdrv_mgmt_ssidIs1PrivecyCfg(void);
BOOL     wdrv_mgmt_ssidIsProfilePrivOptOn(int profile_index);
STATUS wdrv_mgmt_ssidGetPrimarySsidIndex(int *index);
STATUS wdrv_mgmt_ssidGetInternalSsidIndex(int *index);




	

#endif  /* _MGMT_SSID_HANDLE_H */
