/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004    Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/
/**************************************************************************/
/*		MODULE:	QoSClassifier.h 				  */
/*    	PURPOSE:		 				          */
/**************************************************************************/

#ifndef _QOS_INCLUDE_QOSCLASSIFIER_H
#define _QOS_INCLUDE_QOSCLASSIFIER_H

typedef enum {
	WDRV_QOS_CLASSIFIER_MODE_VLAN = 0,
	WDRV_QOS_CLASSIFIER_MODE_DIFFSERV,
	WDRV_QOS_CLASSIFIER_MODE_UDP_PORT,
	WDRV_QOS_CLASSIFIER_MODE_UNDEFINED
} wdrv_QoSClassifierMode_t;

typedef enum {
	WDRV_QOS_CLASSIFIER_AC_BE = 0,
	WDRV_QOS_CLASSIFIER_AC_BK = 1,
	WDRV_QOS_CLASSIFIER_AC_VI = 2,
	WDRV_QOS_CLASSIFIER_AC_VO = 3,
	WDRV_QOS_CLASSIFIER_BROADCAST = 4,
	WDRV_QOS_CLASSIFIER_AC_UNDEFINED = -1
} wdrv_QoSClassifierAC_t;

typedef UINT8 wdrv_QoSClassifierUP_t;

#define WDRV_QOS_DEFAULT_MSDU_LIFETIME 9000000

#pragma pack(1)
typedef struct {
   UINT8	dest[6];	 
   UINT8	source[6];	
   UINT16 vlan_proto; 
   UINT16 vlan_TCI;   
   UINT16	vlan_encapsulated_proto;
} wdrv_QoSEthernetHeader_t;

typedef struct {
	UINT8 version_ihl;
	UINT8 tos;
	UINT16 total_length;
	UINT16 id;
	UINT16 frag_off;
	UINT8 ttl;
	UINT8 prot;
	UINT16 checksum;
	UINT32 source;
	UINT32 dest;
} wdrv_QoSIPHeader_t;

#pragma pack()

STATUS wdrv_QoSClassifierInit(BOOL enabled, wdrv_QoSClassifierMode_t mode, UINT8 inDiffServMapSize, wdrv_QoSClassifierUP_t * inDiffServMap);
STATUS wdrv_QoSClassifierShutdown(void);
extern wdrv_QoSClassifierAC_t (*wdrv_QoSClassifierClassify)(UINT8 * ethernetHeader, UINT8 * ipHeader, UINT8 * up);
UINT32 wdrv_QoSGetTimestamp(void);

#endif // _QOS_INCLUDE_QOSCLASSIFIER_H
