/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/*!
 *                                                                         
 *   \file  dda_fw_trace.c                                                
 *   \brief PURPOSE: handle FW trace
/***********************************************************
	 includes.
*******************************************************/


#ifndef TIWLAN_FW_TRACE
#error "FW trace should be disabled !!!"
#endif

#include "wlan_pal.h"
#include <linux/config.h>
#include <linux/version.h>
#include <linux/skbuff.h>
#include <linux/mm.h>

#include "dda.h"

/*******************************************************************************************/
/*!
	\brief Sends FW trace from driver to an application
	
	\param buf 	input trace buffer
	\param size bufer length
	
	\return OK/NOK
	
*/
/*******************************************************************************************/
int whal_AcxFWTraceSend(char * buf, int size) 
{
	return tiwlan_ddaNetLinkSend(buf, size, TIWLAN_NETLINK_DESTINATION_FW_TRACE);
}
