/***************************************************************************                                                                                                             
**+----------------------------------------------------------------------+**                                                                                                             
**|                                ****                                  |**                                                                                                             
**|                                ****                                  |**                                                                                                             
**|                                ******o***                            |**                                                                                                             
**|                          ********_///_****                           |**                                                                                                             
**|                           ***** /_//_/ ****                          |**                                                                                                             
**|                            ** ** (__/ ****                           |**                                                                                                             
**|                                *********                             |**                                                                                                             
**|                                 ****                                 |**                                                                                                             
**|                                  ***                                 |**                                                                                                             
**|                                                                      |**                                                                                                             
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**                                                                                                             
**|                        ALL RIGHTS RESERVED                           |**                                                                                                             
**|                                                                      |**                                                                                                             
**| Permission is hereby granted to licensees of Texas Instruments       |**                                                                                                             
**| Incorporated (TI) products to use this computer program for the sole |**                                                                                                             
**| purpose of implementing a licensee product based on TI products.     |**                                                                                                             
**| No other rights to reproduce, use, or disseminate this computer      |**                                                                                                             
**| program, whether in part or in whole, are granted.                   |**                                                                                                             
**|                                                                      |**                                                                                                             
**| TI makes no representation or warranties with respect to the         |**                                                                                                             
**| performance of this computer program, and specifically disclaims     |**                                                                                                             
**| any responsibility for any damages, special or consequential,        |**                                                                                                             
**| connected with the use of this program.                              |**                                                                                                             
**|                                                                      |**                                                                                                             
**+----------------------------------------------------------------------+**                                                                                                             
***************************************************************************/                                                                                                             
                                                                                                             
/*!
 *                                                                                                                                                                                     
 *   \file  release.h                                                                                                                                                                
 *   \brief PURPOSE: release specific definitions file.                                                                                                                                       
 *                                                                                                                                                                                     
 */                                                                                                             
                                                                                                             
                                                                                                             
#ifndef _RELEASE_H_                                                                                                             
#define _RELEASE_H_                                                                                                             
                                                                                                             
#define SW_VERSION_MAJOR	6
#define SW_VERSION_MINOR	2
#define SW_VERSION_PATCH	0
#define SW_VERSION_BUILD	20
   
#ifdef DEBUG
#define SW_VERSION_STR	"6.2.0.20 DEBUG"
#else                                                                                                 
#define SW_VERSION_STR	"6.2.0.20"
#endif
                                                                                                       
#define SW_RELEASE_MONTH	07
#define SW_RELEASE_DAY		20
#define SW_RELEASE_YEAR		2005
                                                                                          
#endif /* _RELEASE_H_ */                                                                                                    
                                                                                                       
/*                                                                                                        
-------------------------------------------------------
		AP-DK 6.2 Release Notes
-------------------------------------------------------
DEV_AP-DK6.2.0.20_BFT

	- Set AP default IP parameters before activating TFTP transaction in VxWorks
	- FW 3.2.0.20 - Disable Notch filters & PN sequencer

DEV_AP-DK6.2.0.19_BFT

	- Back to BusyBox 0.6 (BusyBox 1.0 cause problem on Ctrl C and insmod)

DEV_AP-DK6.2.0.18_BFT

	- FW 3.2.0.19 - Fix beacon drift problem
	- Fix QOS problem with the ethernet header and VLAN extension

DEV_AP-DK6.2.0.17_BFT

	- FW 3.2.0.18
	- Bug Fixes

DEV_AP-DK6.2.0.16_BFT

	- Buisy Box 1.0
	- Ice Debug support
	- Bug Fixes

	- PSP: REL_BasePSP7.1.0.8_GA

DEV_AP-DK6.2.0.15_BFT

	- Merged from 6.0.0.61
	- Bug Fixes
	- EEProm Less Production Process
	- FW version 3.2.0.16
		- Fixed duration in RTS frames
		- Fixed durations in fragmented frames
		- Fix bug: Traffic indication bit set when dtim count is not 0
		- Fix bug introduced in 3.2.0.15 - Remove ACK from RTS duration.


	- PSP: REL_BasePSP7.1.0.8_GA

Victoria Rev 3.2.0.14 mrudek
    - Make a correct enable of QoS frames at receive regarding 1350A device.


DEV_AP-DK6.2.0.14_BFT

  - FW 3.2.0.12 
		- fix beacon power setting in the middle of calibration
		- Integrate HDK 3.06 Official
	    - Revert back ch 14 coefficients.
	    - Fix RTS duration
		- Save memory by putting in code in init section (intvecs.asm)
	    - Remove tx_calculate_memory
		- Code review - align with eSTA5.0 code

	- Fix PS kernel panic

DEV_AP-DK6.2.0.13_BFT

	- Merge from bug fixes after 6.0 GA
	
DEV_AP-DK6.2.0.12_BFT

  - Merged from AP-DK6.0.0.59
  - FW 3.2.0.10

DEV_AP-DK6.2.0.11_BFT

  - Use firmware fw_dcrhp_1150_ap.bin high power 

DEV_AP-DK6.2.0.10_BFT

  - Remove the setting of PHY_RXAGC_CFG1 in ApBridgeMode for 1150
  - Add setting register 0x3c4bcd to 0x26 to fix 802.11b rates problem
		**** to be removed in the next RM/Firmware release ****
  - Fix reading eeprom version in eepromless mode

DEV_AP-DK6.2.0.9_BFT

  - PSP Label DEV_BasePSP7.1.0.4_BFT
  - Firmware 3.2.0.9 - new radio module for 1350 HDK 1.0
  - Eepromless is the default
  - Fix for Eepromless on VxWorks

DEV_AP-DK6.2.0.8_BFT

  - PSP Label DEV_BasePSP7.1.0.4_BFT
  - Firmware 3.2.0.8
  - Support EEProm content via ENV Variables
  

DEV_AP-DK6.2.0.7_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
  - Firmware 3.2.0.6
  - Merge VXWorks bring up fixes
  - Merge From AP-DK6.0.0.55

DEV_AP-DK6.2.0.6_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
  - Firmware 3.2.0.4

  - ACI V.2


DEV_AP-DK6.2.0.5_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
	- 80Mhz VLinq
	
  - Firmware 3.2.0.4
  - Merge From AP-DK6.0.0.52
  

DEV_AP-DK6.2.0.4_Eng_Drop
	- Not official release

DEV_AP-DK6.2.0.3_Eng_Drop

  - Disable Energy Detection
  - Firmware 3.2.0.2
    - Aligned to FW 3.0.0.115
    - FCS filtering
    - ACK emulation removal
    - AES MIC correction
    - Integrate HDK 3.05"B"
	- Fix EEPROM read issue


DEV_AP-DK6.2.0.2_Eng_Drop

  - Use Energy detection IE instead of direct PHY register access
  - Remove HAL API for CwMin configuration by register
  - Merge Power save fix from ApDk 6.0.0.48
  - Firmware 3.0.0.912
    - FCS error filtering.
    - AES MIC calculation change.
    - ACK emulation removal from 4x.

DEV_AP-DK6.2.0.1_Eng_Drop

  - Based on AP-DK6.0.0.46
  - Use PSP with 1150 support, REL_BasePSP7.1.0.1_Eng_Drop 
  - Add support for DCR radio
  - Fix makefiles for 1150
  - Fix PHY registers address for 1150
  - Use firmware based on 3.0.0.112 with 1150 merge (no official release yet)

-------------------------------------------------------
*/