/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/******************************************************************************/

/*! \file  dda_EventQueueTest.c                                               
    \brief Contains routines for dda_EventQueue unit testing                                                                          
*/
/******************************************************************************/

STATUS ActionFun_1( void * data );
STATUS ActionFun_2( void * data );

/***********************************************************
	global variables
************************************************************/

EVQ_ACTION_FUN_P ActFunArr[] = { ActionFun_1, ActionFun_2 };

EVQ_QUEUE_P EVQ_queue;


/*******************************************************************************
		PUBLIC FUNCTION IMPLEMENTATION
********************************************************************************/

/******************************************************************************/

/*! \brief 	Action function #1
	\return status OK
*/
/******************************************************************************/

STATUS ActionFun_1( void * data )
{
    printf("ActionFun_1 data=%p message=%x\n", data, *((UINT32 *)data));
    return OK;
}

/******************************************************************************/

/*! \brief 	Action function #2
	\return status OK
*/
/******************************************************************************/

STATUS ActionFun_2( void * data )
{
    printf("ActionFun_2 data=%p message=%x\n", data, *((UINT32 *)data));
    return OK;
}


/******************************************************************************/

/*! \brief 	Create test queue
*/
/******************************************************************************/

void EVQ_Init(void)
{
     
  EVQ_queue= EVQ_Create( 2  /* numOfList     */,
					     10 /* numOfEvents   */, 
						 5  /* maxProcessNum */,
                         6  /* eventDataSize */,
                         ActFunArr );

}

/******************************************************************************/

/*! \brief 	Fill queue by events
*/
/******************************************************************************/

void EVQ_Fill(void)
{

EVQ_PutEvent( EVQ_queue     /*  pEvQueue */,
              5             /* eventType */,
              0             /* listNum   */, 
              "12345"       /*  message  */,
              5             /* messageLen*/ );

EVQ_PutEvent( EVQ_queue, 11, 1, "abcdef", 6);
EVQ_PutEvent( EVQ_queue, 22, 0, "abcdef", 6);
EVQ_PutEvent( EVQ_queue, 33, 0, "678910", 4);
EVQ_PutEvent( EVQ_queue, 44, 0, "678910", 4);
EVQ_PutEvent( EVQ_queue, 55, 1, "345678", 5);
EVQ_PutEvent( EVQ_queue, 66, 1, "987678", 3);
EVQ_PutEvent( EVQ_queue, 66, 0, "345678", 5);
EVQ_PutEvent( EVQ_queue, 77, 0, "345678", 6);

}


