/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/******************************************************************************/

/*! \file  wlanEnd.h                                               
    \brief This module implements WLAN END driver
*/
/******************************************************************************/


#ifndef _END_INIT_H_
#define _END_INIT_H_


#ifdef _WLAN_END_C
#   define  PUBLIC
#else
#   define  PUBLIC  extern
#endif

typedef STATUS (recvRtnApEnd_t) ( END_OBJ * pEnd, M_BLK_ID pData);

PUBLIC STATUS  	WEND_DrvLoad( void );
PUBLIC STATUS 	WEND_Start(void);
PUBLIC STATUS 	WEND_Stop(void);
PUBLIC BOOL 	WEND_IsInitialized(void);
PUBLIC void		WEND_SetRecvRtn(recvRtnApEnd_t _brgEnabledRecvRtn);
PUBLIC STATUS 	WEND_EndRecv(mem_MSDU_T * pMsdu);
PUBLIC void     WEND_SetAdminStatus(int state);
PUBLIC int      WEND_GetAdminStatus(void);
PUBLIC void     wlanMib2StatShow( int dev_port);
PUBLIC void * 	wend_GetEndDevCookie();
PUBLIC void 	WEND_poolShow( void);
 


#undef PUBLIC

#endif   /* _END_INIT_H_ */

