/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2003 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/
 
/****************************************************************************
 *
 *   MODULE:  fw_trace_app.c
 *   PURPOSE:  
 *   
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <asm/types.h>
#include <sys/socket.h>
#include <linux/netlink.h>
#include <linux/rtnetlink.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
 

#define HOST_PORT 5656
//#define HOST_ADDR "192.168.1.42"

/* TODO : FIXME, duplicate definition */
#define FW_TRACE_HELLO 26

struct message_t {
	int type;
	short info_len;
	char info[255];
};

int main(int argc, char ** argv) {
	int fd, res, host_fd, i, len /*, msg_size, msg_size_size*/;
	struct sockaddr_nl local;
	struct sockaddr_in host_addr;
	struct message_t hello_message;
	struct sockaddr_nl  danl;
	fd_set readfds;
	char buf[65508]; // TODO : use define

	if (argc != 2) {
		printf("Usage: %s <ip addr>\n", argv[0]);
		return 1;
	}

	printf("FW Trace app is running, FW Trace Server addr is : %s\n", argv[1]);

	fd = socket(AF_NETLINK, SOCK_DGRAM, NETLINK_USERSOCK);
	if (fd < 0) {
		perror(__FUNCTION__);
		return -1;
	}

	memset(&local, 0, sizeof(local));
	local.nl_family = AF_NETLINK;

	if (bind(fd, (struct sockaddr*)&local, sizeof(local)) < 0) {
		perror("FW Trace App : bind failed");
		return -1;
	}

	hello_message.type = FW_TRACE_HELLO;

	danl.nl_family = AF_NETLINK;
	danl.nl_pad = 0;
	danl.nl_pid = 0;		// target in kernel
	danl.nl_groups = 0;

	for (i=0; i<10; ++i) {
		if (sendto(fd, &hello_message, sizeof(hello_message), 0, (struct sockaddr *)&danl, sizeof(struct  sockaddr_nl)) > 0) 
			break;
		sleep(3);
	}
	if (i == 10) {
		perror("FW Trace App : Can't send hello message");
		return -1;
	}

	memset(&host_addr, 0, sizeof(host_addr));
	host_addr.sin_family = AF_INET;
	host_addr.sin_addr.s_addr = inet_addr(argv[1]);
	host_addr.sin_port = htons(HOST_PORT);
	host_fd = socket(PF_INET, SOCK_DGRAM, 0);

	if (host_fd < 0) {
		perror("FW Trace App : socket failed !");
		return -1;
	}
	/*
	res = getsockopt(host_fd, SOL_SOCKET, SOL_MAX_MSG_SIZE, (char*)&msg_size, &msg_size_size);
	if (res  != 0) {
		perror("getsockopt failed !");
		return -1;
	}

	printf("MAX UDP size : %d\n", msg_size);
	*/

	while (1) {
		FD_ZERO(&readfds);
		FD_SET(fd, &readfds);

		res = select(fd+1, &readfds, NULL, NULL, NULL);

		if (res > 0) {
			//			puts("FW Trace App received something !");
			res = recvfrom(fd, buf, 65508, MSG_DONTWAIT, NULL, NULL);
			if (res <= 0 ) {
				perror("FW Trace App : recv failed !!!");
			} else {
				len = res;
				//				printf("Sending UDP packet if size : %d\n", len);
				res = sendto(host_fd, buf, len, 0, (struct sockaddr *)&host_addr, sizeof(host_addr));
				if (res != len)
					perror("Send failed !");
			}
		} 
	}

	return 0;
}
