/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998-2004 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |** 
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																									*/
/*	 MODULE:	wds_supplicant.h	   									   */
/*   PURPOSE:	WPA supplicant for WDS headers and definitions			   */
/*																									*/
/***************************************************************************/
/***************************************************************************/

#ifndef WDS_SUPPLICANT_H
#define WDS_SUPPLICANT_H

#include "net_types.h"
#include "wpa_info_elem.h"
#include "dda_wpaauth_ioctl.h"
#include "hiddenSecurityProfileAPI.h"


/* WDS supplicant configuration parameters */
typedef struct 
{
	ether_mac_t authMAC;
	tiap_wpa_auth_psk_t psk;
		
}WpasConf_T;

typedef enum
{
	WPAS_RESTART,
	WPAS_EAPOL,
	WPAS_ABORT,
	WPAS_CLOSE_AUTH,
}wpasEvent_T;

void wpas_InitSupplicant(void);
void wpas_OpenNewAssoc(wpa_port_t *wpaPort, dynamicSecureCfg_T *pCfg);
void wpas_SupplGetEvent(wpasEvent_T event, eapol_pkt_t *eapolPkt, wpa_port_t *wpaPort);
u32  wpas_HandleEapol(eapol_pkt_t *eapol, u32 eapolDataLen, wpa_port_t *wpaPort);
u32	 wpas_IsPktToSupplicant(ether_mac_t srcPkt);



#endif /*WDS_SUPPLICANT_H*/


