/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004    Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/
/**************************************************************************/
/*	MODULE:	QoSACParams.h 	                                          */
/*    	PURPOSE:		                                          */
/**************************************************************************/

#ifndef __INCLUDE_CORE_QOS_WME_H
#define __INCLUDE_CORE_QOS_WME_H

#include "whal.h"
#include "QoSClassifier.h"

#define WDRV_QOS_MAX_UP 8
#define WDRV_QOS_MAX_CP 64

/* Note : due to current AP enginous architecture this struct definition has to be duplicated in cli/configurator header files */

extern UINT8 wdrv_QoSAuxMapACtoUP[WDRV_QOS_MAX_AC];
extern wdrv_QoSClassifierAC_t wdrv_QoSAuxMapUPtoAC[WDRV_QOS_MAX_UP];
extern wdrv_QoSClassifierAC_t wdrv_QoSAuxMapPriorToAC[WDRV_QOS_MAX_UP];
extern UINT32 wdrv_QoSAuxMapACtoTxFlags[WDRV_QOS_MAX_AC];
extern wdrv_QoSClassifierAC_t wdrv_QoSAuxMapsTxFlagstoAC[WDRV_QOS_MAX_AC];
extern UINT8 wdrv_QoSACtoACID[WDRV_QOS_MAX_AC];

enum {
	WDRV_QOS_AC_AP_PARAMS = 0,
	WDRV_QOS_AC_STA_PARAMS = 1
}; 

typedef struct {
	BOOL enabled;
	edcf_info_t ap_edcfParams[WDRV_QOS_MAX_AC], sta_edcfParams[WDRV_QOS_MAX_AC];
	wdrv_QoSClassifierMode_t classifierMode;
	UINT8 queueSizes[WDRV_QOS_MAX_AC];
	UINT8 numOfCP;
	wdrv_QoSClassifierUP_t diffServCPToUPMap[WDRV_QOS_MAX_CP]; 
} wdrv_QoSACParams_t;

#endif 
