/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*	  MODULE:	concatenator.h	                                           */ 
/*   PURPOSE:	Performs concatenation.			 						   */ 
/*																		   */
/***************************************************************************/
#ifndef CONCATENATOR_H
#define CONCATENATOR_H

/*************************************************************************
 *                        wdrv_txConcatMsduList                          *
 *************************************************************************
DESCRIPTION: This function get a list of MSDUs (The first MSDU pointes 
             on the others) and concatenate them into one MPDU by linking the
             buffers BDs. In return only the first MSDU struct is in use, 
             and it contains the entire concatenated MPDU.                
                                                                                                   
INPUT:       buildMsduPtr - Msdu containing the headers on base of which the
							concatenation is done.
			 firstMsduPtr - Pointer to the first MSDU.
             concatFlags - Concatenation flags.
             
             
OUTPUT:      firstMsduPtr - The msdu containig concatenated BDs.

RETURN:                                                                                                                                        
************************************************************************/
void wdrv_txConcatMsduList( mem_MSDU_T *buildMsduPtr, mem_MSDU_T** firstMsduPtr, UINT16 concatFlags );

#endif
