/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:	wdsDrv.h                							       */
/*   PURPOSE:	WDS driver functions prototypes and definitions.	       */
/*																		   */
/***************************************************************************/

#ifndef __WDS_DRV_H__
#define __WDS_DRV_H__

#ifdef __WDS_DRV_C__
#define PUBLIC
#else /* ifdef __WDS_DRV_C__ */
#define PUBLIC extern
#endif /* ifdef __WDS_DRV_C__ */

#include "memMngr.h"
#include "wds.h"

PUBLIC STATUS wdrv_wdsDrvPktFromEthrToWlan(mem_MSDU_T *pMsdu, UINT8 *pLinkPartner);
PUBLIC void wdrv_wdsBridgeFromWlanFrame(mem_MSDU_T *pMsdu,UINT32 pktEmulate, BOOL micOK, 
                                        UINT16 srcStaIndex);
PUBLIC void * wdrv_wdsInterfaceCookieGet(char *pMac);
PUBLIC void wdrv_wdsInterfaceCookieAdd(char *pMac, void *pCookie);
PUBLIC void wdrv_wdsInterfaceCookieRemove(char *pMac);
PUBLIC void * wdrv_wdsInterfaceCookieGetByIndex(UINT32 wIndex);
PUBLIC void wdrv_wdsGetStat(wdsDrvStat_s *pBuff);
PUBLIC void wdrv_wdsBridgeInfoGet(wdsDrvSwtchingEntry_s *pBuff);
PUBLIC void wdrv_wdsBeaconsSendEnable(UINT32 enable);
PUBLIC UINT32 wdrv_wdsIsBssInService(void);
PUBLIC void wdrv_wdsBssServiceStateSet(UINT32 inService);

#undef PUBLIC

#endif /* ifndef __WDS_DRV_H__ */
