/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/***************************************************************************/
/*																		   */
/*		MODULE:	wds.h                 							           */
/*   PURPOSE:	WDS common definitions.	                                   */
/*																		   */
/***************************************************************************/

#ifndef __WDS_H__
#define __WDS_H__

#define WDS_MAX_DL_NUMBER            4  /* Max number of the WDS downlinks */
#define WDS_LINKS_NUMBER             (WDS_MAX_DL_NUMBER + 1)

#define WDS_DEVNAME_UL "wdsup"
#define WDS_DEVNAME_DL "wdsdw"

/***************************************************************
*  WDS TI SNAP header used in kernel and user spaces both.     *
*  When you need it just add local variable to your function:  *
*      char wdsTiSnapHdr[] = WDS_TI_SNAP_HEADER;               *
***************************************************************/

#define WDS_TI_SNAP_HEADER {0xAA, 0xAA, 0x00, 0x08, 0x00, 0x28, 0x60, 0xD0}

#ifdef VXWORKS
#define WDS_READ_BUFFER_SIZE    256
#define TIAP_SOCKADDR_WDS_IPC_PORT 5123
#define TIAP_SOCKADDR_WDS_IPC_IP   "127.0.0.1"
#define TIAP_SOCKADDR_WDS_ISC_PORT 5124
#define TIAP_SOCKADDR_WDS_ISC_IP   "127.0.0.1"
#define TIAP_SOCKADDR_WDS_IPC_REP_PORT 5125
#endif /* ifdef VXWORKS */


typedef struct {
    /* TX */
    UINT32 tx_staIndexNotFound;
    UINT32 tx_staIndexNotAuthorized;
    UINT32 tx_pkts;
    UINT32 tx_fails;
    /* RX */
    UINT32 rx_wrongRA;
    UINT32 rx_srcNotAuthorized;
    UINT32 rx_TAnotFound;
    UINT32 rx_pkts;
} wdsDrvStat_s;

typedef struct  {
    void *pCookie;
    UINT32 inUse;
    UINT32 used;
    char mac[6];
} wdsDrvSwtchingEntry_s;

typedef struct {
    UINT32 sentProtocolMsgs;
    UINT32 sentProtocolMsgsFails;
    UINT32 recvProtocolMsgs;
} wdsDrvMngrStat_s;

typedef struct {
    /* RX */
    UINT32 rx_packets;
    UINT32 rx_errors;
    UINT32 rx_dropped;
    /* TX */
    UINT32 tx_packets;
    UINT32 tx_errors;
    UINT32 tx_dropped;
} wdsNetIfcStat_s;


#endif /* ifndef __WDS_H__ */

