/***************************************************************************                                                                                                             
**+----------------------------------------------------------------------+**                                                                                                             
**|                                ****                                  |**                                                                                                             
**|                                ****                                  |**                                                                                                             
**|                                ******o***                            |**                                                                                                             
**|                          ********_///_****                           |**                                                                                                             
**|                           ***** /_//_/ ****                          |**                                                                                                             
**|                            ** ** (__/ ****                           |**                                                                                                             
**|                                *********                             |**                                                                                                             
**|                                 ****                                 |**                                                                                                             
**|                                  ***                                 |**                                                                                                             
**|                                                                      |**                                                                                                             
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**                                                                                                             
**|                        ALL RIGHTS RESERVED                           |**                                                                                                             
**|                                                                      |**                                                                                                             
**| Permission is hereby granted to licensees of Texas Instruments       |**                                                                                                             
**| Incorporated (TI) products to use this computer program for the sole |**                                                                                                             
**| purpose of implementing a licensee product based on TI products.     |**                                                                                                             
**| No other rights to reproduce, use, or disseminate this computer      |**                                                                                                             
**| program, whether in part or in whole, are granted.                   |**                                                                                                             
**|                                                                      |**                                                                                                             
**| TI makes no representation or warranties with respect to the         |**                                                                                                             
**| performance of this computer program, and specifically disclaims     |**                                                                                                             
**| any responsibility for any damages, special or consequential,        |**                                                                                                             
**| connected with the use of this program.                              |**                                                                                                             
**|                                                                      |**                                                                                                             
**+----------------------------------------------------------------------+**                                                                                                             
***************************************************************************/                                                                                                             
                                                                                                             
/*!
 *                                                                                                                                                                                     
 *   \file  release.h                                                                                                                                                                
 *   \brief PURPOSE: release specific definitions file.                                                                                                                                       
 *                                                                                                                                                                                     
 */                                                                                                             
                                                                                                             
                                                                                                             
#ifndef _RELEASE_H_                                                                                                             
#define _RELEASE_H_                                                                                                             
       
#define SW_VERSION_MAJOR	6
#define SW_VERSION_MINOR	3
#define SW_VERSION_PATCH	0
#define SW_VERSION_BUILD	23

#define SW_VERSION_NUMBER_STR	"6.3.0.23"
                                                                                                                                                                                                                 
#ifdef TIWLAN_DEBUG
	#define SW_VER_DEBUG_STR    " DEBUG"
#else                                                                                                 
	#define SW_VER_DEBUG_STR
#endif

#ifdef TIWLAN_FW_TRACE
	#define SW_VER_FWDEBUG_STR " FW_DEBUG"
#else
	#define SW_VER_FWDEBUG_STR 
#endif

#define SW_VERSION_STR SW_VERSION_NUMBER_STR  SW_VER_DEBUG_STR SW_VER_FWDEBUG_STR
        
#define SW_RELEASE_MONTH	1
#define SW_RELEASE_DAY		25
#define SW_RELEASE_YEAR		2006
                                                                                          
#endif /* _RELEASE_H_ */                                                                                                    

/*                                                                                                        
-------------------------------------------------------
		AP-DK 6.3 Release Notes
-------------------------------------------------------
DEV_AP-DK6.3.0.23
    - change kernel option to fix the performance in 4x + PB 
		# CONFIG_KMOD is not set 
		# CONFIG_PSP_TRACE is not set
	- change the calibration interval for radio CRT /DCR from 300 sec to 25 sec
	-  Add TIAP_TRACE_PKT_TX_EXIT_FOR_NSP 

DEV_AP-DK6.3.0.22
    - Set PreambleMode to LOMG when in WiFi WMM mode only to pass WiFi WMM Test2 (b mode)	
	- Fix the memory leakage that cause the ARP table problem.  
		
      
Victoria Rev 3.3.0.27 mrudek
    - Fix the HDK init sequence in order to allow LPF calibration to run.
      This fixes the FCC compliance problem on DCR radio based designs.


DEV_AP-DK6.3.0.21
		
      
Victoria Rev 3.3.0.26 mrudek
    - Align with official HDK modules:
      * HDK 3.11.01 - regarding DCR HP radio design.
      * HDK 3.03.10 - regarding CRT3427 radio design.
      Note that even in case of CRT3427 radio the HDK version
      shall identify 3.11.01.


DEV_AP-DK6.3.0.20

  Change default parameters to:
        - Beacon Interval = 100 TU
        - DTIM Period = 3
        - MSDU Lifetime:AC_VO = 9000 ms AC_VI = 9000 ms
		                AC_BE = 9000 ms AC_BK = 9000 ms
		- FixMR 9590 WDS: RSSI values are incorrect
		- checking DMA status before reboot.
		

  
Victoria Rev 3.3.0.25 
    - Upgrade to Radio Module 3.11.
    - Introduce a fix for proximity problem (PHY 0x310c register) on DCR HP radio.
    - Fix ACM_IFS_CFG2 value in TDD and CRT radios.
    - Remove PHY sequencer change when tunning in to channel 13 in CRT radio.
    - Revert back to the original power level table.
    - Introduce a fix for proximity problem (PHY 0x310c register) on CRT3427 radio.

                                                                                                       

DEV_AP-DK6.3.0.19
	
	- Fix skb length in pill API
	- Fix VLAN>127 issue

DEV_AP-DK6.3.0.18
	
	Validate mSSID enabled when enabled WMM with VLAN classification
	
DEV_AP-DK6.3.0.17
	
	- FW3.3.0.18
		- Merge Aes fix from 4.1
		- Added fix in order not to throw away ps-polls in the Rx paths

	- Fix WPA broadcast afterrecovery
	- Fix GTK update when WDS AP is diconnecteds
	- Check WME enable when parsing WME IE - MR 8928
	 

DEV_AP-DK6.3.0.16
	
	- Support new led manager
	
	- Fix WLAN crash when removing WLAH card MR9008

    - Check Mac addr validity on WDS
  
	- FW3.3.0.16
		 Activate the backoff fix only if working in WMM

	


DEV_AP-DK6.3.0.15
	Fix unload sequence in driver - stop timers before unload

DEV_AP-DK6.3.0.14
	Fix unload sequence in driver - remove break from set_event
	

DEV_AP-DK6.3.0.13
	FW3.3.0.15 
    - Allow handling of encrypted management frames.
    - Add station context initialization at MIC stage.

DEV_AP-DK6.3.0.12

	FW Rev 3.3.0.13 
    - Remove : Fix TxMic queue handling of NULL frames with encryption
    - Fix TxStuck recovery MR 9011

	PSP Label REL_BasePSP7.4.0.12_BFT

	Fix unload sequence in driver

	support AR7VW board


DEV_AP-DK6.3.0.11
	FW3.3.0.11 
		- Added Kick Frame call from FDB to Medium Sensor - FIX WMM Issue

DEV_AP-DK6.3.0.10

	FW3.3.0.10 
		- Allow update of front AC backoff only if frame is kicked and medium sensor
		state machine did not lose sync. This obsoletes saving rx_phy backoff saving 
		in 3.3.0.8

	- Support new API for EAPOL in PIL

DEV_AP-DK6.3.0.9

		- Fix Instrumentation Issue
		- Fix Fast Bridge support Issue
		- Fix PSP Trace Kernel Panic

	
		FW3.3.0.9 
		- Resolved AP Tx stuck condition in WMM. MR8606  


DEV_AP-DK6.3.0.8

	FW3.3.0.8
		- Fix debug trace boundary pattern.
		- Save rx_phy backoff every time medium sensor goes IDLE.
		- Boost current transmit while suspend is requested.

	Fix MRs -
		In WDS network, AP allows configuration of the same MAC - MR8849 
		WDS web pages is not showing proper information when WDS is disabled. - MR8846 
		Remove 802.11h from the serial log - MR8843 
		Cleanup of ACX100 printings - MR842 
		AP cannot transmit multicast packets - MR8804 
    

DEV_AP-DK6.3.0.7  - Ignore !!!!
  

DEV_AP-DK6.3.0.6

	- PSP7.4 - DREL_BasePSP7.4.0.4_BFT

	- Changing driver unloed sequence prevent from timer to expired after 
		driver modules was unload - MR8774
	- Fix 1130 support - MR8712
	- Validate session timeout value range under EAP-TLS - MR8722
	
DEV_AP-DK6.3.0.5
	PSP7.4 - use friendly label:  DEV_BasePSP7.4.0.2_Test_0509
	- Fix VxWorks support (PIL+INSTRUMENTATION)
	
DEV_AP-DK6.3.0.4

	PSP7.4 - use friendly label:  DEV_BasePSP7.4.0.2_Test_0509
	- Merge PIL support
	- Merge Instrumentation
	- fix MRS:
		- Increase mailbox queue size - MR8578
		- Fix BE/BK prioritization in WME+PS - MR8721
		- Use global flag to indicate that MBox command complete interrupt occured but 
			handling has been deferred - MR8710
		- Update authorized stations counter when MAC_DEAUTHORIZE mgmt 
			event is received - MR8497
		
	- Merge new firmware FW 3.3.0.8
		- Fix debug trace boundary pattern.
		- Save rx_phy backoff every time medium sensor goes IDLE.
		- Boost current transmit while suspend is requested.
		- remove race between TIM update & beacon TX



DEV_AP-DK6.2.0.25
	- FIx WPA2-TLS aligment issue - MR8672
	- Fix RX stuck recovery condition - MR8660
	- Change MBLK alocation nuber to 256 - MR8655
	- Enable beacon stuck recovery on only in WDS 
	- change beacon stuck recovery condition - add 2 times checking before recovery
	
DEV_AP-DK6.2.0.24
	- change all wpaMessage_t to static allocation - fix MR8324, MR8567
	- Fix WPA crash - fix MR8494, MR8540

	

DEV_AP-DK6.2.0.23

	- Life time change to 9 seconds on BE when WME enable  fix (MR 8502)
	- After SockRead in WPA, check buffer validity (fix the WPA crash issue).
	- Fix 4x with WDS crude mode  fix MR 8477
	- change Beacon, Broadcast, Multicast to 1M

	- Merge new firmware FW 3.3.0.6
		- HDK3.08 official integrated 


DEV_AP-DK6.2.0.22

	 - return to 6.2 release numbers
	 - Fix beacon stuck issue after send recovery command (MR-7854 fix)
	 - Add PHY counters to the ACXSTAT command (MR-8363 fix)
	 - Enable SW download by the WEB on VxWorks (MR-8010, 6290 fix)
	 - Add dynamic firmware load for VxWorks
	 - MSDU Alloc Failed Message Fix
	 - Print if debug version on ver command (MR-7720 fix)
	 - Check setAC parameters for no ack (MR-7531 fix)
	 - Change printf to report level printing in mgmtSm.c (MR-5291 fix)
	 - Remove Semaphore in whalTrace module (MR-7977 fix)
	 - Add station cipher ioctl (MR-7829 fix)
	 - Defualt recovery set to HARD RESET (same as AP-DK6.0 / AP-DK6.2)
	 
	- Merge new firmware FW 3.3.0.4 
        - added PHY statistics
        - HDK3.08'C' integration
        - Fix TXOP fragmentation issue
        - reduce radio storage area to 256 bytes



DEV_AP-DK6.3.0.3_BFT

	- Fix BE BK priority in power save (MR 8026 fix)
	- Disable legacy fragmentation with WME enabled (MR 7901)
	- Don't let traffic pass between two stations associated to different ssids (MR 8066 fix)
	- Change RSSI factor from 190 to 296 (MR 7640)
	- Fix WPA information element length (Fix MR 7653  blitzz station problem)
	- Increase max number of http parameters (MR 8100 fix)
	- Write signed value to MAC register ( MR 7718)
	- Set SA max duration configurable (MRs 5721, 5722 fix)
	- Swap parameters in wdrv_txSendPsCleanStaListMsg (MR 7855) 
	
DEV_AP-DK6.3.0.2_BFT

	- Merge from DEV_AP-DK6.2.0.20_Best_And_Final
	- Support VLYNQ Daisy-Chain
	- On recovery, change reset from hard reset(GPIO) into Soft Reset of the TNETW but not include VLYNQ

DEV_AP-DK6.3.0.1_BFT
	
	- Start itg branch from DEV_AP-DK6.2.0.16_BFT

-------------------------------------------------------
*/


/*                                                                                                        
-------------------------------------------------------
		AP-DK 6.2 Release Notes
-------------------------------------------------------
DEV_AP-DK6.2.0.20_BFT

	- Set AP default IP parameters before activating TFTP transaction in VxWorks
	- FW 3.2.0.20 - Disable Notch filters & PN sequencer

DEV_AP-DK6.2.0.19_BFT

	- Back to BusyBox 0.6 (BusyBox 1.0 cause problem on Ctrl C and insmod)

DEV_AP-DK6.2.0.18_BFT

	- FW 3.2.0.19 - Fix beacon drift problem
	- Fix QOS problem with the ethernet header and VLAN extension

DEV_AP-DK6.2.0.17_BFT

	- FW 3.2.0.18
	- Bug Fixes

DEV_AP-DK6.2.0.16_BFT

	- Buisy Box 1.0
	- Ice Debug support
	- Bug Fixes

	- PSP: REL_BasePSP7.1.0.8_GA

DEV_AP-DK6.2.0.15_BFT

	- Merged from 6.0.0.61
	- Bug Fixes
	- EEProm Less Production Process
	- FW version 3.2.0.16
		- Fixed duration in RTS frames
		- Fixed durations in fragmented frames
		- Fix bug: Traffic indication bit set when dtim count is not 0
		- Fix bug introduced in 3.2.0.15 - Remove ACK from RTS duration.


	- PSP: REL_BasePSP7.1.0.8_GA

Victoria Rev 3.2.0.14 mrudek
    - Make a correct enable of QoS frames at receive regarding 1350A device.


DEV_AP-DK6.2.0.14_BFT

  - FW 3.2.0.12 
		- fix beacon power setting in the middle of calibration
		- Integrate HDK 3.06 Official
	    - Revert back ch 14 coefficients.
	    - Fix RTS duration
		- Save memory by putting in code in init section (intvecs.asm)
	    - Remove tx_calculate_memory
		- Code review - align with eSTA5.0 code

	- Fix PS kernel panic

DEV_AP-DK6.2.0.13_BFT

	- Merge from bug fixes after 6.0 GA
	
DEV_AP-DK6.2.0.12_BFT

  - Merged from AP-DK6.0.0.59
  - FW 3.2.0.10

DEV_AP-DK6.2.0.11_BFT

  - Use firmware fw_dcrhp_1150_ap.bin high power 

DEV_AP-DK6.2.0.10_BFT

  - Remove the setting of PHY_RXAGC_CFG1 in ApBridgeMode for 1150
  - Add setting register 0x3c4bcd to 0x26 to fix 802.11b rates problem
		**** to be removed in the next RM/Firmware release ****
  - Fix reading eeprom version in eepromless mode

DEV_AP-DK6.2.0.9_BFT

  - PSP Label DEV_BasePSP7.1.0.4_BFT
  - Firmware 3.2.0.9 - new radio module for 1350 HDK 1.0
  - Eepromless is the default
  - Fix for Eepromless on VxWorks

DEV_AP-DK6.2.0.8_BFT

  - PSP Label DEV_BasePSP7.1.0.4_BFT
  - Firmware 3.2.0.8
  - Support EEProm content via ENV Variables
  

DEV_AP-DK6.2.0.7_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
  - Firmware 3.2.0.6
  - Merge VXWorks bring up fixes
  - Merge From AP-DK6.0.0.55

DEV_AP-DK6.2.0.6_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
  - Firmware 3.2.0.4

  - ACI V.2


DEV_AP-DK6.2.0.5_BFT

  - PSP Label DEV_BasePSP7.1.0.3_BFT
	- 80Mhz VLinq
	
  - Firmware 3.2.0.4
  - Merge From AP-DK6.0.0.52
  

DEV_AP-DK6.2.0.4_Eng_Drop
	- Not official release

DEV_AP-DK6.2.0.3_Eng_Drop

  - Disable Energy Detection
  - Firmware 3.2.0.2
    - Aligned to FW 3.0.0.115
    - FCS filtering
    - ACK emulation removal
    - AES MIC correction
    - Integrate HDK 3.05"B"
	- Fix EEPROM read issue


DEV_AP-DK6.2.0.2_Eng_Drop

  - Use Energy detection IE instead of direct PHY register access
  - Remove HAL API for CwMin configuration by register
  - Merge Power save fix from ApDk 6.0.0.48
  - Firmware 3.0.0.912
    - FCS error filtering.
    - AES MIC calculation change.
    - ACK emulation removal from 4x.

DEV_AP-DK6.2.0.1_Eng_Drop

  - Based on AP-DK6.0.0.46
  - Use PSP with 1150 support, REL_BasePSP7.1.0.1_Eng_Drop 
  - Add support for DCR radio
  - Fix makefiles for 1150
  - Fix PHY registers address for 1150
  - Use firmware based on 3.0.0.112 with 1150 merge (no official release yet)

-------------------------------------------------------
*/