/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998,1999,2000 Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/******************************************************************************/

/*! \file  dda_contexts.h                                               
	\brief This module implements driver context DDA Task                                                                         
*/

/******************************************************************************/

#ifndef _DDA_CONTEXTS_H_
#define _DDA_CONTEXTS_H_

#include "mgmtSm.h"
#include "mainsm.h"
#include "rx.h"
#include "tx.h"
#include "whalAcxMbox.h"

#ifdef _DDA_CONTEXTS_C
#   define  PUBLIC
#else
#   define  PUBLIC  extern
#endif

#define DDA_DECLARE_WAIT_MECHANISM(wait)    SEM_ID (wait) = (SEM_ID) NULL
#define DDA_TASKLET_BUFFER_POOL_SIZE   300

PUBLIC STATUS DCX_TaskInit( int taskPriority );
PUBLIC STATUS DCX_TaskDelete(void);
PUBLIC STATUS dda_tasklet_init(unsigned long pool_size);
PUBLIC STATUS wdrv_DDA_tx_setEvent(TxMessage_T *message);
PUBLIC STATUS wdrv_DDA_rx_setEvent(RxMessage_T *message);
PUBLIC STATUS wdrv_DDA_mainSm_setEvent(mainsmMessage_T *message);
PUBLIC STATUS wdrv_DDA_mgmt_setEvent(mgmtMessage_T *message);
PUBLIC STATUS wdrv_DDA_mailbox_setEvent(UINT32  event_type);
PUBLIC STATUS wdrv_DDA_restart_setEvent(void);
PUBLIC long   wdrv_DDA_sleep_timeout(void *wait_q,long timeout);
PUBLIC void   wdrv_DDA_wake(void *wait_q);
PUBLIC void   inline wdrv_DDA_init_tx_sched_count(void);
PUBLIC void   inline wdrv_DDA_init_rx_sched_count(void);
PUBLIC void   DCX_suspend(void);
PUBLIC void   DCX_resume(void);

#undef PUBLIC
#endif /*_DDA_CONTEXTS_H_*/
