/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 1998 - 2004 Texas Instruments Incorporated         |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/******************************************************************************/

/*! \file  dda_proc_fs_defs.h                                               
    \brief This module implements api functions for proc use                                                                          
*/
/******************************************************************************/

#ifndef  _DDA_PROC_FS_DEFS_
#define  _DDA_PROC_FS_DEFS_

/*****************************************************
params struct 
 use in input parameters func.
 NOTE:
   1. fill parametrs according to the proc_func order !!!   	
   2. the data size givven to the proc func = sizeof(proc_params_strcut)	
**********************************************************/
#define PROC_PARAMS_MAGIC 0x42DEAD43

#pragma pack(1)
typedef union _proc_params{
    struct {
		__u32 magic;
		__u32 Param1;
		__u32 Param2;
		__u32 Param3;
		__u32 Param4;
		__u32 Param5;
		__u32 Param6;
		__u32 Param7;
		__u32 Param8;
		__u8 mac[6];
    } s;
    char buf[4096];
} proc_params;

#pragma pack() 


/* proc dir names */
#define   WLAN_PROC_BASE_DIR_PATH     "/proc/wlan/"

typedef enum 
{
	WLAN_PROC_BASE_DIR_NAME,   	/* 0 */
	WLAN_PROC_BIT_DIR_NAME,
	WLAN_PROC_MGMT_DIR_NAME,
	WLAN_PROC_WPA_DIR_NAME,
	WLAN_PROC_PRIVACY_DIR_NAME,
	WLAN_PROC_SERV_DIR_NAME,
	WLAN_PROC_SHOW_DIR_NAME,
	WLAN_PROC_HAL_DIR_NAME,
	WLAN_PROC_4X_DIRNAME,
	WLAN_PROC_PROD_DIR_NAME,
	WLAN_PROC_DIR_NAME_LAST   	/* 10 */

}  DPR_PROC_DIR_NAME_E;


/*bit entries name */

typedef enum 
{
	WLAN_PROC_BIT_FCC,
	WLAN_PROC_BIT_TELEC,
	WLAN_PROC_BIT_TXCFG,
	WLAN_PROC_BIT_RXCFG,
	WLAN_PROC_BIT_CLRSTAT,
	WLAN_PROC_BIT_TXSTOP,
	WLAN_PROC_BIT_BITSTOP,
	WLAN_PROC_BIT_RXSTAT,
	WLAN_PROC_BIT_TXSTAT

} DPR_PROC_BIT_E;


/* mgmt entries name*/

typedef enum 
{
	WLAN_PROC_MGMT_DEAUTH,
	WLAN_PROC_MGMT_DISASS,
	WLAN_PROC_MGMT_STATABLE,
    WLAN_PROC_MGMT_STASTATISTICS,
	WLAN_PROC_MGMT_4XTABLE,
	WLAN_PROC_MGMT_STAHASH,
	WLAN_PROC_MGMT_STARATES,
	WLAN_PROC_MGMT_COUNTERS,
	WLAN_PROC_MGMT_SETLOG,
	WLAN_PROC_MGMT_AGING,
	WLAN_PROC_MGMT_SHOW,
	WLAN_PROC_MGMT_TST_NULL,
	WLAN_PROC_MGMT_TST_AUTH1,
	WLAN_PROC_MGMT_TST_AUTH3,
	WLAN_PROC_MGMT_TST_ASS,
	WLAN_PROC_MGMT_TST_REASS,
	WLAN_PROC_MGMT_TST_DEAUTH,
	WLAN_PROC_MGMT_TS_DEASS,
	WLAN_PROC_MGMT_TST_CLASS3,
	WLAN_PROC_MGMT_TST_CHALLENGE,
	WLAN_PROC_MGMT_TST_FINDSTA,
	WLAN_PROC_MGMT_TST_FIND_INS,
	WLAN_PROC_MGMT_TST_REM_STAT,
	WLAN_PROC_MGMT_TST_RESET


} DPR_PROC_MGMT_E;


/* wpa entries */

typedef enum 
{
	WLAN_PROC_WPA_RESET

} DPR_PROC_WPA_E;


/* privacy menu*/
typedef enum 
{
	WLAN_PROC_PRIVACY_CFG,
	WLAN_PROC_PRIVACY_NOTIFY,
	WLAN_PROC_PRIVACY_WEP_KEYS,
	WLAN_PROC_PRIVACY_COUNTERS,
	WLAN_PROC_PRIVACY_INVOKE,
	WLAN_PROC_PRIVACY_EXCLUDE

} DPR_PROC_RPIVACY_E;

/*serv menu*/
typedef enum 
{
	WLAN_PROC_SERV_WLAN_PARAMS,
	WLAN_PROC_SERV_RATES,
	WLAN_PROC_SERV_COUNTERS,
	WLAN_PROC_SERV_RADIO_FREQ,
	WLAN_PROC_SERV_RADIO_PARAMS,
	WLAN_PROC_SERV_POWER_LEVEL

} DPR_PROC_SERV_E;


/* show menu */
typedef enum 
{
	WLAN_PROC_SHOW_BSS,
	WLAN_PROC_SHOW_PS,
	WLAN_PROC_SHOW_TX_STAT,
	WLAN_PROC_SHOW_LAN_MIB,
	WLAN_PROC_SHOW_LAN_STAT,
	WLAN_PROC_SHOW_LAN_POOL,
	WLAN_PROC_SHOW_MEM_STAT,
	WLAN_PROC_SHOW_RATE_ADAP

} DPR_PROC_SHOW_E;

/* hal and hal diag menu */
typedef enum 
{
	WLAN_PROC_HAL_FWVER,
	WLAN_PROC_HAL_ACX_PARAM,
	WLAN_PROC_HAL_RX_INFO,
	WLAN_PROC_HAL_RX_QUEUE,
	WLAN_PROC_HAL_INTR,
	WLAN_PROC_HAL_MBOX,
	WLAN_PROC_HAL_ACXSTAT,
	WLAN_PROC_HAL_RESTART_STAT,
	WLAN_PROC_HAL_LED,
	WLAN_PROC_HAL_EED,
	WLAN_PROC_HAL_EEW,
	WLAN_PROC_HAL_SET_TX_COMPTRSH,
	WLAN_PROC_HAL_FW_VER_ONLY,
	WLAN_PROC_HAL_RADIO_VER_ONLY,
	WLAN_PROC_HAL_EEPROM_VER_ONLY,
	WLAN_PROC_HAL_SETPS_MODE,
	WLAN_PROC_HAL_PRINTREGS,
	WLAN_PROC_HAL_PHY_REG_WRITE,
	WLAN_PROC_HAL_MAC_REG_WRITE,
	WLAN_PROC_HAL_SET_RX_PROMIS,
	WLAN_PROC_HAL_MODE_SNIFFER,
	WLAN_PROC_HAL_SELEC_FW_NUM,
	WLAN_PROC_HAL_SETY_Q_SIZE_TYPE,
	WLAN_PROC_HAL_SET_NVBYTE,
	WLAN_PROC_HAL_SELEC_RADIO_NUM,
	WLAN_PROC_HAL_TRACE_ENABLE,
	WLAN_PROC_HAL_TRACE_RX_STAT,
	WLAN_PROC_HAL_RX_BUFFS,
	WLAN_PROC_INTERF_WD_PARAMS,
    WLAN_PROC_HAL_MBOX_ERR,
    WLAN_PROC_HAL_MEDIUM_USAGE,
	WLAN_PROC_HAL_LAST

} DPR_PROC_HAL_E;


/* 4x */
typedef enum 
{
	WLAN_PROC_4X_MAX_CONCATSIZE,
	WLAN_PROC_SHOW_4X_MAX_CONCATSIZE,

} DPR_PROC_4X_E;

/* prod */

typedef enum 
{
	WLAN_PROC_PROD_VERSION

} DPR_PROC_PROD_E;

#endif /* _DDA_PROC_FS_DEFS_ */

