#include "pid.h"

#define PID_SIZE	70
#define HWID_OFFSET	-67


#define LOADER_SIZE	(64<<10)
#define KERNEL_SIZE	(640<<10)	
#define FS_SIZE		(3200<<10) - PID_SIZE - 8 
#define ADAM2_SIZE	(40<<10)
#define DOWNLOAD_SIZE	(24<<10)
#define KERNEL_OFFSET   128
#define USER_DEFINE	KERNEL_OFFSET - PID_SIZE

typedef struct{
	u_int8_t	loader[LOADER_SIZE];
	sercomm_pid_t	pid;
	u_int8_t	user_define[USER_DEFINE];
	u_int8_t	kernel[KERNEL_SIZE-KERNEL_OFFSET];
	u_int8_t	filesystem[FS_SIZE];
}image_t;

typedef struct{
	u_int16_t       checksum;
	u_int32_t	fw_len;
}user_def_t;
