#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "makeImage.h"

int check_checksum(image_t *image) {

	unsigned short checksum = 0;
	unsigned char *pt=(char *)image;
	int i=0;
	
	while(i++<CHECKSUM_RANGE)
		checksum+=*(pt++);
	
	return (checksum == image->checksum);
}

unsigned short cal_checksum(image_t *image) {

	unsigned short checksum = 0;
	unsigned char *pt=(char *)image;
	int i=0;
	
	while(i++<CHECKSUM_RANGE)
		checksum+=*(pt++);
	return checksum;
}
void my_read_file(char *filename,char *buf,int size)
{
	FILE *fp;
	int len=0;
	if((fp=fopen(filename,"rb"))==NULL){
		fprintf(stderr,"Error opening %s for output\n",filename);
		exit(-1);
	}
	fseek(fp,0,SEEK_END);
	len=ftell(fp);
	
	if(len > size){
		fclose(fp);
		fprintf(stderr,"Sorry, %s must less than %d\n", filename,size);
		exit(-1);
	}
	fseek(fp, 0L, SEEK_SET);
	len=fread(buf,1,size,fp);
	fclose(fp);
}

int main(int argc,char **argv)
{
	image_t image;
	FILE	*fp;
	
	memset(&image,0xff,sizeof(image_t));
	if (argc != 4){
		printf("Usage: %s outImage inImage fs\n", argv[0]);
		return -1;
	}
	/* adam2 */
	my_read_file(argv[2],(char *)&image,sizeof(image_t));
	if(image.pid.hw_id[0]!='D'
			|| image.pid.hw_id[1]!='G'
			|| image.pid.hw_id[2]!='8'
			|| image.pid.hw_id[3]!='3'
			|| image.pid.hw_id[4]!='4'){
		printf("Image Error!\n");
		return -1;
	}
	
	if(!check_checksum(&image)){
		printf("Image Error!\n");
		return -1;
	}
	
	my_read_file(argv[3],image.filesystem,FS_SIZE);
	
	/* checksum */
	image.checksum=cal_checksum(&image);
	/* fakw */
	memset(&image.fake,0xff,sizeof(image.fake));
	
	/* write image */
	fp=fopen(argv[1],"wb");	
	if(fp==NULL){
		fprintf(stderr,"Error opening %s for output\n",argv[0]);
		return -1;
		
	}
	fwrite(&image,sizeof(image_t),1,fp);
	fclose(fp);
	return 0;
}
