#include <stdio.h>
#include <stdlib.h>
#define PID_SIZE	70
#define LOADER_SIZE	(128<<10)
#define KERNEL_SIZE	(704<<10)	
#define FS_SIZE		(3136<<10)-78
#define CHECKSUM_RANGE	0x3dfffc
typedef struct{
	u_int8_t	magic_s[11];
	u_int8_t	HW_ID[46];
	u_int8_t	version[2];
	u_int8_t	fake[4];
	u_int8_t	magic_e[7];
}sercomm_pid_t;

typedef struct{
	u_int8_t	loader[LOADER_SIZE];
	u_int8_t	kernel[KERNEL_SIZE];
	u_int8_t	filesystem[FS_SIZE];
	sercomm_pid_t	pid;
//	u_int8_t 	pid[70];
	u_int8_t	fake[4];
	u_int16_t	checksum;
}image_t;

int check_checksum(image_t *image) {

	unsigned short checksum = 0;
	unsigned char *pt=(char *)image;
	int i=0;
	
	while(i++<CHECKSUM_RANGE)
		checksum+=*(pt++);
	
	printf("cal==%hx image==%hx\n",checksum,image->checksum);
	printf("HW_ID==%s\n",image->pid.HW_ID);	
	return 0;
}

int main(int argc,char **argv)
{
	FILE *fp;
	image_t image;
	
	bzero(&image,sizeof(image_t));
	fp=fopen(argv[1],"rb");	
	fread(&image,sizeof(image_t),1,fp);
	fclose(fp);
	check_checksum(&image);	
	
	return 0;
}
