#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "makeImage.h"


unsigned short cal_checksum(image_t *image) {

	unsigned short checksum = 0;
	unsigned char *pt=(char *)image;
	int i=0;
	
	while(i++<CHECKSUM_RANGE)
		checksum+=*(pt++);
	return checksum;
}
void my_read_file(char *filename,char *buf,int size)
{
	FILE *fp;
	int len=0;
	if((fp=fopen(filename,"rb"))==NULL){
		fprintf(stderr,"Error opening %s for output\n",filename);
		exit(-1);
	}
	fseek(fp,0,SEEK_END);
	len=ftell(fp);
	
	if(len > size){
		fclose(fp);
		fprintf(stderr,"Sorry, %s must less than %d\n", filename,size);
		exit(-1);
	}
	fseek(fp, 0L, SEEK_SET);
	len=fread(buf,1,size,fp);
	fclose(fp);
	printf("%s read %d kbytes maximum %d kbytes\n",filename,len/1024,size/1024);
}

int main(int argc,char **argv)
{
	image_t image;
	FILE	*fp;
	
	memset(&image,0xff,sizeof(image_t));
	if (argc != 7){
		printf("Usage: %s outimage loader downloader kernel ramdisk PID\n"
				, argv[0]);
		return -1;
	}
	/* loader */
	/* adam2 */
	my_read_file(argv[2],image.loader,ADAM2_SIZE);
	/* download */
	my_read_file(argv[3],image.loader+ADAM2_SIZE,DOWNLOAD_SIZE);
	/* kernel */
	my_read_file(argv[4],image.kernel,KERNEL_SIZE);
	/* filesystem */
	my_read_file(argv[5],image.filesystem,FS_SIZE);
	/* PID */
	my_read_file(argv[6],(char *)&image.pid,PID_SIZE);
	/* sing */
	memset(image.signature,0xff,sizeof(image.signature));
	/* checksum */
	image.checksum=cal_checksum(&image);
	/* fakw */
	memset(&image.fake,0xff,sizeof(image.fake));
	
	/* write image */
	fp=fopen(argv[1],"wb");	
	if(fp==NULL){
		fprintf(stderr,"Error opening %s for output\n",argv[0]);
		return -1;
		
	}
	fwrite(&image,sizeof(image_t),1,fp);
	fclose(fp);
	return 0;
}
